/* A Bison parser, made by GNU Bison 3.8.2.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2021 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <https://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output, and Bison version.  */
#define YYBISON 30802

/* Bison version string.  */
#define YYBISON_VERSION "3.8.2"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1


/* Substitute the variable and function names.  */
#define yyparse         ir3_yyparse
#define yylex           ir3_yylex
#define yyerror         ir3_yyerror
#define yydebug         ir3_yydebug
#define yynerrs         ir3_yynerrs
#define yylval          ir3_yylval
#define yychar          ir3_yychar

/* First part of user prologue.  */
#line 32 "../src/freedreno/ir3/ir3_parser.y"

#define YYDEBUG 0

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <math.h>

#include "util/half_float.h"
#include "util/u_math.h"

#include "ir3/ir3.h"
#include "ir3/ir3_shader.h"
#include "ir3/instr-a3xx.h"

#include "ir3_parser.h"

#define swap(a, b) \
	do { __typeof(a) __tmp = (a); (a) = (b); (b) = __tmp; } while (0)

/* ir3 treats the abs/neg flags as separate flags for float vs integer,
 * but in the instruction encoding they are the same thing.  Tracking
 * them separately is only for the benefit of ir3 opt passes, and not
 * required here, so just use the float versions:
 */
#define IR3_REG_ABS     IR3_REG_FABS
#define IR3_REG_NEGATE  IR3_REG_FNEG

static struct ir3_kernel_info    *info;
static struct ir3_shader_variant *variant;
/* NOTE the assembler doesn't really use the ir3_block construction
 * like the compiler does.  Everything is treated as one large block.
 * Which might happen to contain flow control.  But since we don't
 * use any of the ir3 backend passes (sched, RA, etc) this doesn't
 * really matter.
 */
static struct ir3_block          *block;   /* current shader block */
static struct ir3_instruction    *instr;   /* current instruction */
static unsigned ip; /* current instruction pointer */
static struct hash_table *labels;

void *ir3_parser_dead_ctx;

static struct {
	unsigned flags;
	unsigned repeat;
	unsigned nop;
} iflags;

static struct {
	unsigned flags;
	unsigned wrmask;
} rflags;

static struct {
        uint32_t reg_address_hi;
        uint32_t reg_address_lo;
        uint32_t reg_tmp;

        uint32_t regs_to_dump[128];
        uint32_t regs_count;
} meta_print_data;

int ir3_yyget_lineno(void);

static void new_label(const char *name)
{
	ralloc_steal(labels, (void *) name);
	_mesa_hash_table_insert(labels, name, (void *)(uintptr_t)ip);
}

static struct ir3_instruction * new_instr(opc_t opc)
{
	instr = ir3_instr_create(block, opc, 4, 6);
	instr->flags = iflags.flags;
	instr->repeat = iflags.repeat;
	instr->nop = iflags.nop;
	instr->line = ir3_yyget_lineno();
	iflags.flags = iflags.repeat = iflags.nop = 0;
	ip++;
	return instr;
}

static void new_shader(void)
{
	variant->ir = ir3_create(variant->compiler, variant);
	block = ir3_block_create(variant->ir);
	list_addtail(&block->node, &variant->ir->block_list);
	ip = 0;
	labels = _mesa_hash_table_create(variant, _mesa_hash_string, _mesa_key_string_equal);
	ir3_parser_dead_ctx = ralloc_context(NULL);
}

static type_t parse_type(const char **type)
{
	if (!strncmp("f16", *type, 3)) {
		*type += 3;
		return TYPE_F16;
	} else if (!strncmp("f32", *type, 3)) {
		*type += 3;
		return TYPE_F32;
	} else if (!strncmp("u16", *type, 3)) {
		*type += 3;
		return TYPE_U16;
	} else if (!strncmp("u32", *type, 3)) {
		*type += 3;
		return TYPE_U32;
	} else if (!strncmp("s16", *type, 3)) {
		*type += 3;
		return TYPE_S16;
	} else if (!strncmp("s32", *type, 3)) {
		*type += 3;
		return TYPE_S32;
	} else if (!strncmp("u8", *type, 2)) {
		*type += 2;
		return TYPE_U8;
	} else if (!strncmp("s8", *type, 2)) {
		*type += 2;
		return TYPE_S8;
	} else {
		assert(0);  /* shouldn't get here */
		return ~0;
	}
}

static struct ir3_instruction * parse_type_type(struct ir3_instruction *instr,
		const char *type_type)
{
	instr->cat1.src_type = parse_type(&type_type);
	instr->cat1.dst_type = parse_type(&type_type);
	return instr;
}

static struct ir3_register * new_src(int num, unsigned flags)
{
	struct ir3_register *reg;
	flags |= rflags.flags;
	if (num & 0x1)
		flags |= IR3_REG_HALF;
	reg = ir3_src_create(instr, num>>1, flags);
	reg->wrmask = MAX2(1, rflags.wrmask);
	rflags.flags = rflags.wrmask = 0;
	return reg;
}

static struct ir3_register * new_dst(int num, unsigned flags)
{
	struct ir3_register *reg;
	flags |= rflags.flags;
	if (num & 0x1)
		flags |= IR3_REG_HALF;
	reg = ir3_dst_create(instr, num>>1, flags);
	reg->wrmask = MAX2(1, rflags.wrmask);
	rflags.flags = rflags.wrmask = 0;
	return reg;
}

static struct ir3_register * dummy_dst(void)
{
	return new_dst(0, 0);
}

static void fixup_cat5_s2en(void)
{
	assert(opc_cat(instr->opc) == 5);
	if (!(instr->flags & IR3_INSTR_S2EN))
		return;
	/* For various reasons (ie. mainly to make the .s2en src easier to
	 * find, given that various different cat5 tex instructions can have
	 * different # of src registers), in ir3 the samp/tex src register
	 * is first, rather than last.  So we have to detect this case and
	 * fix things up.
	 */
	struct ir3_register *s2en_src = instr->srcs[instr->srcs_count - 1];

	if (instr->flags & IR3_INSTR_B)
		assert(!(s2en_src->flags & IR3_REG_HALF));
	else
		assert(s2en_src->flags & IR3_REG_HALF);

	for (int i = 0; i < instr->srcs_count - 1; i++) {
		instr->srcs[i+1] = instr->srcs[i];
	}
	instr->srcs[0] = s2en_src;
}

static void add_const(unsigned reg, unsigned c0, unsigned c1, unsigned c2, unsigned c3)
{
	struct ir3_const_state *const_state = ir3_const_state(variant);
	assert((reg & 0x7) == 0);
	int idx = reg >> (1 + 2); /* low bit is half vs full, next two bits are swiz */
	if (idx * 4 + 4 > const_state->immediates_size) {
		const_state->immediates = rerzalloc(const_state,
				const_state->immediates,
				__typeof__(const_state->immediates[0]),
				const_state->immediates_size,
				idx * 4 + 4);
		for (unsigned i = const_state->immediates_size; i < idx * 4; i++)
			const_state->immediates[i] = 0xd0d0d0d0;
		const_state->immediates_size = const_state->immediates_count = idx * 4 + 4;
	}
	const_state->immediates[idx * 4 + 0] = c0;
	const_state->immediates[idx * 4 + 1] = c1;
	const_state->immediates[idx * 4 + 2] = c2;
	const_state->immediates[idx * 4 + 3] = c3;
}

static void add_sysval(unsigned reg, unsigned compmask, gl_system_value sysval)
{
	unsigned n = variant->inputs_count++;
	variant->inputs[n].regid = reg;
	variant->inputs[n].sysval = true;
	variant->inputs[n].slot = sysval;
	variant->inputs[n].compmask = compmask;
	variant->total_in++;
}

static bool resolve_labels(void)
{
	int instr_ip = 0;
	foreach_instr (instr, &block->instr_list) {
		if (opc_cat(instr->opc) == 0 && instr->cat0.target_label) {
			struct hash_entry *entry = _mesa_hash_table_search(labels, instr->cat0.target_label);
			if (!entry) {
				fprintf(stderr, "unknown label %s\n", instr->cat0.target_label);
				return false;
			}
			int target_ip = (uintptr_t)entry->data;
			instr->cat0.immed = target_ip - instr_ip;
		}
		instr_ip++;
	}
	return true;
}

#ifdef YYDEBUG
int yydebug;
#endif

extern int yylex(void);
void ir3_yyset_lineno(int _line_number);
void ir3_yyset_input(FILE *f);

int yyparse(void);

static void yyerror(const char *error)
{
	fprintf(stderr, "error at line %d: %s\n", ir3_yyget_lineno(), error);
}

struct ir3 * ir3_parse(struct ir3_shader_variant *v,
		struct ir3_kernel_info *k, FILE *f)
{
	ir3_yyset_lineno(1);
	ir3_yyset_input(f);
#ifdef YYDEBUG
	yydebug = 1;
#endif
	info = k;
	variant = v;
	if (yyparse() || !resolve_labels()) {
		ir3_destroy(variant->ir);
		variant->ir = NULL;
	}
	ralloc_free(labels);
	ralloc_free(ir3_parser_dead_ctx);
	return variant->ir;
}

#line 348 "src/freedreno/ir3/ir3_parser.c"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

#include "ir3_parser.h"
/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_T_INT = 3,                      /* T_INT  */
  YYSYMBOL_T_HEX = 4,                      /* T_HEX  */
  YYSYMBOL_T_FLOAT = 5,                    /* T_FLOAT  */
  YYSYMBOL_T_IDENTIFIER = 6,               /* T_IDENTIFIER  */
  YYSYMBOL_T_REGISTER = 7,                 /* T_REGISTER  */
  YYSYMBOL_T_CONSTANT = 8,                 /* T_CONSTANT  */
  YYSYMBOL_T_A_LOCALSIZE = 9,              /* T_A_LOCALSIZE  */
  YYSYMBOL_T_A_CONST = 10,                 /* T_A_CONST  */
  YYSYMBOL_T_A_BUF = 11,                   /* T_A_BUF  */
  YYSYMBOL_T_A_INVOCATIONID = 12,          /* T_A_INVOCATIONID  */
  YYSYMBOL_T_A_WGID = 13,                  /* T_A_WGID  */
  YYSYMBOL_T_A_NUMWG = 14,                 /* T_A_NUMWG  */
  YYSYMBOL_T_A_BRANCHSTACK = 15,           /* T_A_BRANCHSTACK  */
  YYSYMBOL_T_A_IN = 16,                    /* T_A_IN  */
  YYSYMBOL_T_A_OUT = 17,                   /* T_A_OUT  */
  YYSYMBOL_T_A_TEX = 18,                   /* T_A_TEX  */
  YYSYMBOL_T_A_PVTMEM = 19,                /* T_A_PVTMEM  */
  YYSYMBOL_T_A_EARLYPREAMBLE = 20,         /* T_A_EARLYPREAMBLE  */
  YYSYMBOL_T_ABSNEG = 21,                  /* T_ABSNEG  */
  YYSYMBOL_T_NEG = 22,                     /* T_NEG  */
  YYSYMBOL_T_ABS = 23,                     /* T_ABS  */
  YYSYMBOL_T_R = 24,                       /* T_R  */
  YYSYMBOL_T_LAST = 25,                    /* T_LAST  */
  YYSYMBOL_T_HR = 26,                      /* T_HR  */
  YYSYMBOL_T_HC = 27,                      /* T_HC  */
  YYSYMBOL_T_EVEN = 28,                    /* T_EVEN  */
  YYSYMBOL_T_POS_INFINITY = 29,            /* T_POS_INFINITY  */
  YYSYMBOL_T_NEG_INFINITY = 30,            /* T_NEG_INFINITY  */
  YYSYMBOL_T_EI = 31,                      /* T_EI  */
  YYSYMBOL_T_WRMASK = 32,                  /* T_WRMASK  */
  YYSYMBOL_T_FLUT_0_0 = 33,                /* T_FLUT_0_0  */
  YYSYMBOL_T_FLUT_0_5 = 34,                /* T_FLUT_0_5  */
  YYSYMBOL_T_FLUT_1_0 = 35,                /* T_FLUT_1_0  */
  YYSYMBOL_T_FLUT_2_0 = 36,                /* T_FLUT_2_0  */
  YYSYMBOL_T_FLUT_E = 37,                  /* T_FLUT_E  */
  YYSYMBOL_T_FLUT_PI = 38,                 /* T_FLUT_PI  */
  YYSYMBOL_T_FLUT_INV_PI = 39,             /* T_FLUT_INV_PI  */
  YYSYMBOL_T_FLUT_INV_LOG2_E = 40,         /* T_FLUT_INV_LOG2_E  */
  YYSYMBOL_T_FLUT_LOG2_E = 41,             /* T_FLUT_LOG2_E  */
  YYSYMBOL_T_FLUT_INV_LOG2_10 = 42,        /* T_FLUT_INV_LOG2_10  */
  YYSYMBOL_T_FLUT_LOG2_10 = 43,            /* T_FLUT_LOG2_10  */
  YYSYMBOL_T_FLUT_4_0 = 44,                /* T_FLUT_4_0  */
  YYSYMBOL_T_SY = 45,                      /* T_SY  */
  YYSYMBOL_T_SS = 46,                      /* T_SS  */
  YYSYMBOL_T_JP = 47,                      /* T_JP  */
  YYSYMBOL_T_EQ_FLAG = 48,                 /* T_EQ_FLAG  */
  YYSYMBOL_T_SAT = 49,                     /* T_SAT  */
  YYSYMBOL_T_RPT = 50,                     /* T_RPT  */
  YYSYMBOL_T_UL = 51,                      /* T_UL  */
  YYSYMBOL_T_NOP = 52,                     /* T_NOP  */
  YYSYMBOL_T_OP_NOP = 53,                  /* T_OP_NOP  */
  YYSYMBOL_T_OP_BR = 54,                   /* T_OP_BR  */
  YYSYMBOL_T_OP_BRAO = 55,                 /* T_OP_BRAO  */
  YYSYMBOL_T_OP_BRAA = 56,                 /* T_OP_BRAA  */
  YYSYMBOL_T_OP_BRAC = 57,                 /* T_OP_BRAC  */
  YYSYMBOL_T_OP_BANY = 58,                 /* T_OP_BANY  */
  YYSYMBOL_T_OP_BALL = 59,                 /* T_OP_BALL  */
  YYSYMBOL_T_OP_BRAX = 60,                 /* T_OP_BRAX  */
  YYSYMBOL_T_OP_JUMP = 61,                 /* T_OP_JUMP  */
  YYSYMBOL_T_OP_CALL = 62,                 /* T_OP_CALL  */
  YYSYMBOL_T_OP_RET = 63,                  /* T_OP_RET  */
  YYSYMBOL_T_OP_KILL = 64,                 /* T_OP_KILL  */
  YYSYMBOL_T_OP_END = 65,                  /* T_OP_END  */
  YYSYMBOL_T_OP_EMIT = 66,                 /* T_OP_EMIT  */
  YYSYMBOL_T_OP_CUT = 67,                  /* T_OP_CUT  */
  YYSYMBOL_T_OP_CHMASK = 68,               /* T_OP_CHMASK  */
  YYSYMBOL_T_OP_CHSH = 69,                 /* T_OP_CHSH  */
  YYSYMBOL_T_OP_FLOW_REV = 70,             /* T_OP_FLOW_REV  */
  YYSYMBOL_T_OP_BKT = 71,                  /* T_OP_BKT  */
  YYSYMBOL_T_OP_STKS = 72,                 /* T_OP_STKS  */
  YYSYMBOL_T_OP_STKR = 73,                 /* T_OP_STKR  */
  YYSYMBOL_T_OP_XSET = 74,                 /* T_OP_XSET  */
  YYSYMBOL_T_OP_XCLR = 75,                 /* T_OP_XCLR  */
  YYSYMBOL_T_OP_GETLAST = 76,              /* T_OP_GETLAST  */
  YYSYMBOL_T_OP_GETONE = 77,               /* T_OP_GETONE  */
  YYSYMBOL_T_OP_DBG = 78,                  /* T_OP_DBG  */
  YYSYMBOL_T_OP_SHPS = 79,                 /* T_OP_SHPS  */
  YYSYMBOL_T_OP_SHPE = 80,                 /* T_OP_SHPE  */
  YYSYMBOL_T_OP_PREDT = 81,                /* T_OP_PREDT  */
  YYSYMBOL_T_OP_PREDF = 82,                /* T_OP_PREDF  */
  YYSYMBOL_T_OP_PREDE = 83,                /* T_OP_PREDE  */
  YYSYMBOL_T_OP_MOVMSK = 84,               /* T_OP_MOVMSK  */
  YYSYMBOL_T_OP_MOVA1 = 85,                /* T_OP_MOVA1  */
  YYSYMBOL_T_OP_MOVA = 86,                 /* T_OP_MOVA  */
  YYSYMBOL_T_OP_MOV = 87,                  /* T_OP_MOV  */
  YYSYMBOL_T_OP_COV = 88,                  /* T_OP_COV  */
  YYSYMBOL_T_OP_SWZ = 89,                  /* T_OP_SWZ  */
  YYSYMBOL_T_OP_GAT = 90,                  /* T_OP_GAT  */
  YYSYMBOL_T_OP_SCT = 91,                  /* T_OP_SCT  */
  YYSYMBOL_T_OP_ADD_F = 92,                /* T_OP_ADD_F  */
  YYSYMBOL_T_OP_MIN_F = 93,                /* T_OP_MIN_F  */
  YYSYMBOL_T_OP_MAX_F = 94,                /* T_OP_MAX_F  */
  YYSYMBOL_T_OP_MUL_F = 95,                /* T_OP_MUL_F  */
  YYSYMBOL_T_OP_SIGN_F = 96,               /* T_OP_SIGN_F  */
  YYSYMBOL_T_OP_CMPS_F = 97,               /* T_OP_CMPS_F  */
  YYSYMBOL_T_OP_ABSNEG_F = 98,             /* T_OP_ABSNEG_F  */
  YYSYMBOL_T_OP_CMPV_F = 99,               /* T_OP_CMPV_F  */
  YYSYMBOL_T_OP_FLOOR_F = 100,             /* T_OP_FLOOR_F  */
  YYSYMBOL_T_OP_CEIL_F = 101,              /* T_OP_CEIL_F  */
  YYSYMBOL_T_OP_RNDNE_F = 102,             /* T_OP_RNDNE_F  */
  YYSYMBOL_T_OP_RNDAZ_F = 103,             /* T_OP_RNDAZ_F  */
  YYSYMBOL_T_OP_TRUNC_F = 104,             /* T_OP_TRUNC_F  */
  YYSYMBOL_T_OP_ADD_U = 105,               /* T_OP_ADD_U  */
  YYSYMBOL_T_OP_ADD_S = 106,               /* T_OP_ADD_S  */
  YYSYMBOL_T_OP_SUB_U = 107,               /* T_OP_SUB_U  */
  YYSYMBOL_T_OP_SUB_S = 108,               /* T_OP_SUB_S  */
  YYSYMBOL_T_OP_CMPS_U = 109,              /* T_OP_CMPS_U  */
  YYSYMBOL_T_OP_CMPS_S = 110,              /* T_OP_CMPS_S  */
  YYSYMBOL_T_OP_MIN_U = 111,               /* T_OP_MIN_U  */
  YYSYMBOL_T_OP_MIN_S = 112,               /* T_OP_MIN_S  */
  YYSYMBOL_T_OP_MAX_U = 113,               /* T_OP_MAX_U  */
  YYSYMBOL_T_OP_MAX_S = 114,               /* T_OP_MAX_S  */
  YYSYMBOL_T_OP_ABSNEG_S = 115,            /* T_OP_ABSNEG_S  */
  YYSYMBOL_T_OP_AND_B = 116,               /* T_OP_AND_B  */
  YYSYMBOL_T_OP_OR_B = 117,                /* T_OP_OR_B  */
  YYSYMBOL_T_OP_NOT_B = 118,               /* T_OP_NOT_B  */
  YYSYMBOL_T_OP_XOR_B = 119,               /* T_OP_XOR_B  */
  YYSYMBOL_T_OP_CMPV_U = 120,              /* T_OP_CMPV_U  */
  YYSYMBOL_T_OP_CMPV_S = 121,              /* T_OP_CMPV_S  */
  YYSYMBOL_T_OP_MUL_U24 = 122,             /* T_OP_MUL_U24  */
  YYSYMBOL_T_OP_MUL_S24 = 123,             /* T_OP_MUL_S24  */
  YYSYMBOL_T_OP_MULL_U = 124,              /* T_OP_MULL_U  */
  YYSYMBOL_T_OP_BFREV_B = 125,             /* T_OP_BFREV_B  */
  YYSYMBOL_T_OP_CLZ_S = 126,               /* T_OP_CLZ_S  */
  YYSYMBOL_T_OP_CLZ_B = 127,               /* T_OP_CLZ_B  */
  YYSYMBOL_T_OP_SHL_B = 128,               /* T_OP_SHL_B  */
  YYSYMBOL_T_OP_SHR_B = 129,               /* T_OP_SHR_B  */
  YYSYMBOL_T_OP_ASHR_B = 130,              /* T_OP_ASHR_B  */
  YYSYMBOL_T_OP_BARY_F = 131,              /* T_OP_BARY_F  */
  YYSYMBOL_T_OP_FLAT_B = 132,              /* T_OP_FLAT_B  */
  YYSYMBOL_T_OP_MGEN_B = 133,              /* T_OP_MGEN_B  */
  YYSYMBOL_T_OP_GETBIT_B = 134,            /* T_OP_GETBIT_B  */
  YYSYMBOL_T_OP_SETRM = 135,               /* T_OP_SETRM  */
  YYSYMBOL_T_OP_CBITS_B = 136,             /* T_OP_CBITS_B  */
  YYSYMBOL_T_OP_SHB = 137,                 /* T_OP_SHB  */
  YYSYMBOL_T_OP_MSAD = 138,                /* T_OP_MSAD  */
  YYSYMBOL_T_OP_MAD_U16 = 139,             /* T_OP_MAD_U16  */
  YYSYMBOL_T_OP_MADSH_U16 = 140,           /* T_OP_MADSH_U16  */
  YYSYMBOL_T_OP_MAD_S16 = 141,             /* T_OP_MAD_S16  */
  YYSYMBOL_T_OP_MADSH_M16 = 142,           /* T_OP_MADSH_M16  */
  YYSYMBOL_T_OP_MAD_U24 = 143,             /* T_OP_MAD_U24  */
  YYSYMBOL_T_OP_MAD_S24 = 144,             /* T_OP_MAD_S24  */
  YYSYMBOL_T_OP_MAD_F16 = 145,             /* T_OP_MAD_F16  */
  YYSYMBOL_T_OP_MAD_F32 = 146,             /* T_OP_MAD_F32  */
  YYSYMBOL_T_OP_SEL_B16 = 147,             /* T_OP_SEL_B16  */
  YYSYMBOL_T_OP_SEL_B32 = 148,             /* T_OP_SEL_B32  */
  YYSYMBOL_T_OP_SEL_S16 = 149,             /* T_OP_SEL_S16  */
  YYSYMBOL_T_OP_SEL_S32 = 150,             /* T_OP_SEL_S32  */
  YYSYMBOL_T_OP_SEL_F16 = 151,             /* T_OP_SEL_F16  */
  YYSYMBOL_T_OP_SEL_F32 = 152,             /* T_OP_SEL_F32  */
  YYSYMBOL_T_OP_SAD_S16 = 153,             /* T_OP_SAD_S16  */
  YYSYMBOL_T_OP_SAD_S32 = 154,             /* T_OP_SAD_S32  */
  YYSYMBOL_T_OP_SHRM = 155,                /* T_OP_SHRM  */
  YYSYMBOL_T_OP_SHLM = 156,                /* T_OP_SHLM  */
  YYSYMBOL_T_OP_SHRG = 157,                /* T_OP_SHRG  */
  YYSYMBOL_T_OP_SHLG = 158,                /* T_OP_SHLG  */
  YYSYMBOL_T_OP_ANDG = 159,                /* T_OP_ANDG  */
  YYSYMBOL_T_OP_DP2ACC = 160,              /* T_OP_DP2ACC  */
  YYSYMBOL_T_OP_DP4ACC = 161,              /* T_OP_DP4ACC  */
  YYSYMBOL_T_OP_WMM = 162,                 /* T_OP_WMM  */
  YYSYMBOL_T_OP_WMM_ACCU = 163,            /* T_OP_WMM_ACCU  */
  YYSYMBOL_T_OP_RCP = 164,                 /* T_OP_RCP  */
  YYSYMBOL_T_OP_RSQ = 165,                 /* T_OP_RSQ  */
  YYSYMBOL_T_OP_LOG2 = 166,                /* T_OP_LOG2  */
  YYSYMBOL_T_OP_EXP2 = 167,                /* T_OP_EXP2  */
  YYSYMBOL_T_OP_SIN = 168,                 /* T_OP_SIN  */
  YYSYMBOL_T_OP_COS = 169,                 /* T_OP_COS  */
  YYSYMBOL_T_OP_SQRT = 170,                /* T_OP_SQRT  */
  YYSYMBOL_T_OP_HRSQ = 171,                /* T_OP_HRSQ  */
  YYSYMBOL_T_OP_HLOG2 = 172,               /* T_OP_HLOG2  */
  YYSYMBOL_T_OP_HEXP2 = 173,               /* T_OP_HEXP2  */
  YYSYMBOL_T_OP_ISAM = 174,                /* T_OP_ISAM  */
  YYSYMBOL_T_OP_ISAML = 175,               /* T_OP_ISAML  */
  YYSYMBOL_T_OP_ISAMM = 176,               /* T_OP_ISAMM  */
  YYSYMBOL_T_OP_SAM = 177,                 /* T_OP_SAM  */
  YYSYMBOL_T_OP_SAMB = 178,                /* T_OP_SAMB  */
  YYSYMBOL_T_OP_SAML = 179,                /* T_OP_SAML  */
  YYSYMBOL_T_OP_SAMGQ = 180,               /* T_OP_SAMGQ  */
  YYSYMBOL_T_OP_GETLOD = 181,              /* T_OP_GETLOD  */
  YYSYMBOL_T_OP_CONV = 182,                /* T_OP_CONV  */
  YYSYMBOL_T_OP_CONVM = 183,               /* T_OP_CONVM  */
  YYSYMBOL_T_OP_GETSIZE = 184,             /* T_OP_GETSIZE  */
  YYSYMBOL_T_OP_GETBUF = 185,              /* T_OP_GETBUF  */
  YYSYMBOL_T_OP_GETPOS = 186,              /* T_OP_GETPOS  */
  YYSYMBOL_T_OP_GETINFO = 187,             /* T_OP_GETINFO  */
  YYSYMBOL_T_OP_DSX = 188,                 /* T_OP_DSX  */
  YYSYMBOL_T_OP_DSY = 189,                 /* T_OP_DSY  */
  YYSYMBOL_T_OP_GATHER4R = 190,            /* T_OP_GATHER4R  */
  YYSYMBOL_T_OP_GATHER4G = 191,            /* T_OP_GATHER4G  */
  YYSYMBOL_T_OP_GATHER4B = 192,            /* T_OP_GATHER4B  */
  YYSYMBOL_T_OP_GATHER4A = 193,            /* T_OP_GATHER4A  */
  YYSYMBOL_T_OP_SAMGP0 = 194,              /* T_OP_SAMGP0  */
  YYSYMBOL_T_OP_SAMGP1 = 195,              /* T_OP_SAMGP1  */
  YYSYMBOL_T_OP_SAMGP2 = 196,              /* T_OP_SAMGP2  */
  YYSYMBOL_T_OP_SAMGP3 = 197,              /* T_OP_SAMGP3  */
  YYSYMBOL_T_OP_DSXPP_1 = 198,             /* T_OP_DSXPP_1  */
  YYSYMBOL_T_OP_DSYPP_1 = 199,             /* T_OP_DSYPP_1  */
  YYSYMBOL_T_OP_RGETPOS = 200,             /* T_OP_RGETPOS  */
  YYSYMBOL_T_OP_RGETINFO = 201,            /* T_OP_RGETINFO  */
  YYSYMBOL_T_OP_BRCST_A = 202,             /* T_OP_BRCST_A  */
  YYSYMBOL_T_OP_QSHUFFLE_BRCST = 203,      /* T_OP_QSHUFFLE_BRCST  */
  YYSYMBOL_T_OP_QSHUFFLE_H = 204,          /* T_OP_QSHUFFLE_H  */
  YYSYMBOL_T_OP_QSHUFFLE_V = 205,          /* T_OP_QSHUFFLE_V  */
  YYSYMBOL_T_OP_QSHUFFLE_DIAG = 206,       /* T_OP_QSHUFFLE_DIAG  */
  YYSYMBOL_T_OP_TCINV = 207,               /* T_OP_TCINV  */
  YYSYMBOL_T_OP_LDG = 208,                 /* T_OP_LDG  */
  YYSYMBOL_T_OP_LDG_A = 209,               /* T_OP_LDG_A  */
  YYSYMBOL_T_OP_LDL = 210,                 /* T_OP_LDL  */
  YYSYMBOL_T_OP_LDP = 211,                 /* T_OP_LDP  */
  YYSYMBOL_T_OP_STG = 212,                 /* T_OP_STG  */
  YYSYMBOL_T_OP_STG_A = 213,               /* T_OP_STG_A  */
  YYSYMBOL_T_OP_STL = 214,                 /* T_OP_STL  */
  YYSYMBOL_T_OP_STP = 215,                 /* T_OP_STP  */
  YYSYMBOL_T_OP_LDIB = 216,                /* T_OP_LDIB  */
  YYSYMBOL_T_OP_G2L = 217,                 /* T_OP_G2L  */
  YYSYMBOL_T_OP_L2G = 218,                 /* T_OP_L2G  */
  YYSYMBOL_T_OP_PREFETCH = 219,            /* T_OP_PREFETCH  */
  YYSYMBOL_T_OP_LDLW = 220,                /* T_OP_LDLW  */
  YYSYMBOL_T_OP_STLW = 221,                /* T_OP_STLW  */
  YYSYMBOL_T_OP_RESFMT = 222,              /* T_OP_RESFMT  */
  YYSYMBOL_T_OP_RESINFO = 223,             /* T_OP_RESINFO  */
  YYSYMBOL_T_OP_ATOMIC_ADD = 224,          /* T_OP_ATOMIC_ADD  */
  YYSYMBOL_T_OP_ATOMIC_SUB = 225,          /* T_OP_ATOMIC_SUB  */
  YYSYMBOL_T_OP_ATOMIC_XCHG = 226,         /* T_OP_ATOMIC_XCHG  */
  YYSYMBOL_T_OP_ATOMIC_INC = 227,          /* T_OP_ATOMIC_INC  */
  YYSYMBOL_T_OP_ATOMIC_DEC = 228,          /* T_OP_ATOMIC_DEC  */
  YYSYMBOL_T_OP_ATOMIC_CMPXCHG = 229,      /* T_OP_ATOMIC_CMPXCHG  */
  YYSYMBOL_T_OP_ATOMIC_MIN = 230,          /* T_OP_ATOMIC_MIN  */
  YYSYMBOL_T_OP_ATOMIC_MAX = 231,          /* T_OP_ATOMIC_MAX  */
  YYSYMBOL_T_OP_ATOMIC_AND = 232,          /* T_OP_ATOMIC_AND  */
  YYSYMBOL_T_OP_ATOMIC_OR = 233,           /* T_OP_ATOMIC_OR  */
  YYSYMBOL_T_OP_ATOMIC_XOR = 234,          /* T_OP_ATOMIC_XOR  */
  YYSYMBOL_T_OP_RESINFO_B = 235,           /* T_OP_RESINFO_B  */
  YYSYMBOL_T_OP_LDIB_B = 236,              /* T_OP_LDIB_B  */
  YYSYMBOL_T_OP_STIB_B = 237,              /* T_OP_STIB_B  */
  YYSYMBOL_T_OP_ATOMIC_B_ADD = 238,        /* T_OP_ATOMIC_B_ADD  */
  YYSYMBOL_T_OP_ATOMIC_B_SUB = 239,        /* T_OP_ATOMIC_B_SUB  */
  YYSYMBOL_T_OP_ATOMIC_B_XCHG = 240,       /* T_OP_ATOMIC_B_XCHG  */
  YYSYMBOL_T_OP_ATOMIC_B_INC = 241,        /* T_OP_ATOMIC_B_INC  */
  YYSYMBOL_T_OP_ATOMIC_B_DEC = 242,        /* T_OP_ATOMIC_B_DEC  */
  YYSYMBOL_T_OP_ATOMIC_B_CMPXCHG = 243,    /* T_OP_ATOMIC_B_CMPXCHG  */
  YYSYMBOL_T_OP_ATOMIC_B_MIN = 244,        /* T_OP_ATOMIC_B_MIN  */
  YYSYMBOL_T_OP_ATOMIC_B_MAX = 245,        /* T_OP_ATOMIC_B_MAX  */
  YYSYMBOL_T_OP_ATOMIC_B_AND = 246,        /* T_OP_ATOMIC_B_AND  */
  YYSYMBOL_T_OP_ATOMIC_B_OR = 247,         /* T_OP_ATOMIC_B_OR  */
  YYSYMBOL_T_OP_ATOMIC_B_XOR = 248,        /* T_OP_ATOMIC_B_XOR  */
  YYSYMBOL_T_OP_ATOMIC_S_ADD = 249,        /* T_OP_ATOMIC_S_ADD  */
  YYSYMBOL_T_OP_ATOMIC_S_SUB = 250,        /* T_OP_ATOMIC_S_SUB  */
  YYSYMBOL_T_OP_ATOMIC_S_XCHG = 251,       /* T_OP_ATOMIC_S_XCHG  */
  YYSYMBOL_T_OP_ATOMIC_S_INC = 252,        /* T_OP_ATOMIC_S_INC  */
  YYSYMBOL_T_OP_ATOMIC_S_DEC = 253,        /* T_OP_ATOMIC_S_DEC  */
  YYSYMBOL_T_OP_ATOMIC_S_CMPXCHG = 254,    /* T_OP_ATOMIC_S_CMPXCHG  */
  YYSYMBOL_T_OP_ATOMIC_S_MIN = 255,        /* T_OP_ATOMIC_S_MIN  */
  YYSYMBOL_T_OP_ATOMIC_S_MAX = 256,        /* T_OP_ATOMIC_S_MAX  */
  YYSYMBOL_T_OP_ATOMIC_S_AND = 257,        /* T_OP_ATOMIC_S_AND  */
  YYSYMBOL_T_OP_ATOMIC_S_OR = 258,         /* T_OP_ATOMIC_S_OR  */
  YYSYMBOL_T_OP_ATOMIC_S_XOR = 259,        /* T_OP_ATOMIC_S_XOR  */
  YYSYMBOL_T_OP_ATOMIC_G_ADD = 260,        /* T_OP_ATOMIC_G_ADD  */
  YYSYMBOL_T_OP_ATOMIC_G_SUB = 261,        /* T_OP_ATOMIC_G_SUB  */
  YYSYMBOL_T_OP_ATOMIC_G_XCHG = 262,       /* T_OP_ATOMIC_G_XCHG  */
  YYSYMBOL_T_OP_ATOMIC_G_INC = 263,        /* T_OP_ATOMIC_G_INC  */
  YYSYMBOL_T_OP_ATOMIC_G_DEC = 264,        /* T_OP_ATOMIC_G_DEC  */
  YYSYMBOL_T_OP_ATOMIC_G_CMPXCHG = 265,    /* T_OP_ATOMIC_G_CMPXCHG  */
  YYSYMBOL_T_OP_ATOMIC_G_MIN = 266,        /* T_OP_ATOMIC_G_MIN  */
  YYSYMBOL_T_OP_ATOMIC_G_MAX = 267,        /* T_OP_ATOMIC_G_MAX  */
  YYSYMBOL_T_OP_ATOMIC_G_AND = 268,        /* T_OP_ATOMIC_G_AND  */
  YYSYMBOL_T_OP_ATOMIC_G_OR = 269,         /* T_OP_ATOMIC_G_OR  */
  YYSYMBOL_T_OP_ATOMIC_G_XOR = 270,        /* T_OP_ATOMIC_G_XOR  */
  YYSYMBOL_T_OP_LDGB = 271,                /* T_OP_LDGB  */
  YYSYMBOL_T_OP_STGB = 272,                /* T_OP_STGB  */
  YYSYMBOL_T_OP_STIB = 273,                /* T_OP_STIB  */
  YYSYMBOL_T_OP_LDC = 274,                 /* T_OP_LDC  */
  YYSYMBOL_T_OP_LDLV = 275,                /* T_OP_LDLV  */
  YYSYMBOL_T_OP_GETSPID = 276,             /* T_OP_GETSPID  */
  YYSYMBOL_T_OP_GETWID = 277,              /* T_OP_GETWID  */
  YYSYMBOL_T_OP_GETFIBERID = 278,          /* T_OP_GETFIBERID  */
  YYSYMBOL_T_OP_STC = 279,                 /* T_OP_STC  */
  YYSYMBOL_T_OP_STSC = 280,                /* T_OP_STSC  */
  YYSYMBOL_T_OP_BAR = 281,                 /* T_OP_BAR  */
  YYSYMBOL_T_OP_FENCE = 282,               /* T_OP_FENCE  */
  YYSYMBOL_T_OP_SLEEP = 283,               /* T_OP_SLEEP  */
  YYSYMBOL_T_OP_ICINV = 284,               /* T_OP_ICINV  */
  YYSYMBOL_T_OP_DCCLN = 285,               /* T_OP_DCCLN  */
  YYSYMBOL_T_OP_DCINV = 286,               /* T_OP_DCINV  */
  YYSYMBOL_T_OP_DCFLU = 287,               /* T_OP_DCFLU  */
  YYSYMBOL_T_OP_CCINV = 288,               /* T_OP_CCINV  */
  YYSYMBOL_T_OP_LOCK = 289,                /* T_OP_LOCK  */
  YYSYMBOL_T_OP_UNLOCK = 290,              /* T_OP_UNLOCK  */
  YYSYMBOL_T_OP_ALIAS = 291,               /* T_OP_ALIAS  */
  YYSYMBOL_T_RAW = 292,                    /* T_RAW  */
  YYSYMBOL_T_OP_PRINT = 293,               /* T_OP_PRINT  */
  YYSYMBOL_T_TYPE_F16 = 294,               /* T_TYPE_F16  */
  YYSYMBOL_T_TYPE_F32 = 295,               /* T_TYPE_F32  */
  YYSYMBOL_T_TYPE_U16 = 296,               /* T_TYPE_U16  */
  YYSYMBOL_T_TYPE_U32 = 297,               /* T_TYPE_U32  */
  YYSYMBOL_T_TYPE_S16 = 298,               /* T_TYPE_S16  */
  YYSYMBOL_T_TYPE_S32 = 299,               /* T_TYPE_S32  */
  YYSYMBOL_T_TYPE_U8 = 300,                /* T_TYPE_U8  */
  YYSYMBOL_T_TYPE_S8 = 301,                /* T_TYPE_S8  */
  YYSYMBOL_T_UNTYPED = 302,                /* T_UNTYPED  */
  YYSYMBOL_T_TYPED = 303,                  /* T_TYPED  */
  YYSYMBOL_T_MIXED = 304,                  /* T_MIXED  */
  YYSYMBOL_T_UNSIGNED = 305,               /* T_UNSIGNED  */
  YYSYMBOL_T_LOW = 306,                    /* T_LOW  */
  YYSYMBOL_T_HIGH = 307,                   /* T_HIGH  */
  YYSYMBOL_T_1D = 308,                     /* T_1D  */
  YYSYMBOL_T_2D = 309,                     /* T_2D  */
  YYSYMBOL_T_3D = 310,                     /* T_3D  */
  YYSYMBOL_T_4D = 311,                     /* T_4D  */
  YYSYMBOL_T_LT = 312,                     /* T_LT  */
  YYSYMBOL_T_LE = 313,                     /* T_LE  */
  YYSYMBOL_T_GT = 314,                     /* T_GT  */
  YYSYMBOL_T_GE = 315,                     /* T_GE  */
  YYSYMBOL_T_EQ = 316,                     /* T_EQ  */
  YYSYMBOL_T_NE = 317,                     /* T_NE  */
  YYSYMBOL_T_S2EN = 318,                   /* T_S2EN  */
  YYSYMBOL_T_SAMP = 319,                   /* T_SAMP  */
  YYSYMBOL_T_TEX = 320,                    /* T_TEX  */
  YYSYMBOL_T_BASE = 321,                   /* T_BASE  */
  YYSYMBOL_T_OFFSET = 322,                 /* T_OFFSET  */
  YYSYMBOL_T_UNIFORM = 323,                /* T_UNIFORM  */
  YYSYMBOL_T_NONUNIFORM = 324,             /* T_NONUNIFORM  */
  YYSYMBOL_T_IMM = 325,                    /* T_IMM  */
  YYSYMBOL_T_NAN = 326,                    /* T_NAN  */
  YYSYMBOL_T_INF = 327,                    /* T_INF  */
  YYSYMBOL_T_A0 = 328,                     /* T_A0  */
  YYSYMBOL_T_A1 = 329,                     /* T_A1  */
  YYSYMBOL_T_P0 = 330,                     /* T_P0  */
  YYSYMBOL_T_W = 331,                      /* T_W  */
  YYSYMBOL_T_CAT1_TYPE_TYPE = 332,         /* T_CAT1_TYPE_TYPE  */
  YYSYMBOL_T_INSTR_TYPE = 333,             /* T_INSTR_TYPE  */
  YYSYMBOL_T_MOD_TEX = 334,                /* T_MOD_TEX  */
  YYSYMBOL_T_MOD_MEM = 335,                /* T_MOD_MEM  */
  YYSYMBOL_T_MOD_RT = 336,                 /* T_MOD_RT  */
  YYSYMBOL_337_ = 337,                     /* '-'  */
  YYSYMBOL_338_ = 338,                     /* ','  */
  YYSYMBOL_339_ = 339,                     /* '('  */
  YYSYMBOL_340_ = 340,                     /* ')'  */
  YYSYMBOL_341_ = 341,                     /* '='  */
  YYSYMBOL_342_ = 342,                     /* ':'  */
  YYSYMBOL_343_ = 343,                     /* '!'  */
  YYSYMBOL_344_ = 344,                     /* '#'  */
  YYSYMBOL_345_ = 345,                     /* '.'  */
  YYSYMBOL_346_a_ = 346,                   /* 'a'  */
  YYSYMBOL_347_o_ = 347,                   /* 'o'  */
  YYSYMBOL_348_p_ = 348,                   /* 'p'  */
  YYSYMBOL_349_s_ = 349,                   /* 's'  */
  YYSYMBOL_350_ = 350,                     /* '+'  */
  YYSYMBOL_351_ = 351,                     /* '<'  */
  YYSYMBOL_352_g_ = 352,                   /* 'g'  */
  YYSYMBOL_353_ = 353,                     /* '['  */
  YYSYMBOL_354_ = 354,                     /* ']'  */
  YYSYMBOL_355_l_ = 355,                   /* 'l'  */
  YYSYMBOL_356_k_ = 356,                   /* 'k'  */
  YYSYMBOL_357_c_ = 357,                   /* 'c'  */
  YYSYMBOL_358_w_ = 358,                   /* 'w'  */
  YYSYMBOL_359_r_ = 359,                   /* 'r'  */
  YYSYMBOL_360_ = 360,                     /* '>'  */
  YYSYMBOL_361_h_ = 361,                   /* 'h'  */
  YYSYMBOL_YYACCEPT = 362,                 /* $accept  */
  YYSYMBOL_shader = 363,                   /* shader  */
  YYSYMBOL_364_1 = 364,                    /* $@1  */
  YYSYMBOL_headers = 365,                  /* headers  */
  YYSYMBOL_header = 366,                   /* header  */
  YYSYMBOL_const_val = 367,                /* const_val  */
  YYSYMBOL_localsize_header = 368,         /* localsize_header  */
  YYSYMBOL_const_header = 369,             /* const_header  */
  YYSYMBOL_buf_header_addr_reg = 370,      /* buf_header_addr_reg  */
  YYSYMBOL_buf_header = 371,               /* buf_header  */
  YYSYMBOL_372_2 = 372,                    /* $@2  */
  YYSYMBOL_invocationid_header = 373,      /* invocationid_header  */
  YYSYMBOL_wgid_header = 374,              /* wgid_header  */
  YYSYMBOL_numwg_header = 375,             /* numwg_header  */
  YYSYMBOL_branchstack_header = 376,       /* branchstack_header  */
  YYSYMBOL_pvtmem_header = 377,            /* pvtmem_header  */
  YYSYMBOL_earlypreamble_header = 378,     /* earlypreamble_header  */
  YYSYMBOL_in_header = 379,                /* in_header  */
  YYSYMBOL_out_header = 380,               /* out_header  */
  YYSYMBOL_tex_header = 381,               /* tex_header  */
  YYSYMBOL_iflag = 382,                    /* iflag  */
  YYSYMBOL_iflags = 383,                   /* iflags  */
  YYSYMBOL_instrs = 384,                   /* instrs  */
  YYSYMBOL_instr = 385,                    /* instr  */
  YYSYMBOL_label = 386,                    /* label  */
  YYSYMBOL_cat0_src1 = 387,                /* cat0_src1  */
  YYSYMBOL_cat0_src2 = 388,                /* cat0_src2  */
  YYSYMBOL_cat0_immed = 389,               /* cat0_immed  */
  YYSYMBOL_cat0_instr = 390,               /* cat0_instr  */
  YYSYMBOL_391_3 = 391,                    /* $@3  */
  YYSYMBOL_392_4 = 392,                    /* $@4  */
  YYSYMBOL_393_5 = 393,                    /* $@5  */
  YYSYMBOL_394_6 = 394,                    /* $@6  */
  YYSYMBOL_395_7 = 395,                    /* $@7  */
  YYSYMBOL_396_8 = 396,                    /* $@8  */
  YYSYMBOL_397_9 = 397,                    /* $@9  */
  YYSYMBOL_398_10 = 398,                   /* $@10  */
  YYSYMBOL_399_11 = 399,                   /* $@11  */
  YYSYMBOL_400_12 = 400,                   /* $@12  */
  YYSYMBOL_401_13 = 401,                   /* $@13  */
  YYSYMBOL_402_14 = 402,                   /* $@14  */
  YYSYMBOL_403_15 = 403,                   /* $@15  */
  YYSYMBOL_404_16 = 404,                   /* $@16  */
  YYSYMBOL_405_17 = 405,                   /* $@17  */
  YYSYMBOL_406_18 = 406,                   /* $@18  */
  YYSYMBOL_cat1_opc = 407,                 /* cat1_opc  */
  YYSYMBOL_cat1_src = 408,                 /* cat1_src  */
  YYSYMBOL_cat1_movmsk = 409,              /* cat1_movmsk  */
  YYSYMBOL_410_19 = 410,                   /* $@19  */
  YYSYMBOL_cat1_mova1 = 411,               /* cat1_mova1  */
  YYSYMBOL_412_20 = 412,                   /* $@20  */
  YYSYMBOL_cat1_mova = 413,                /* cat1_mova  */
  YYSYMBOL_414_21 = 414,                   /* $@21  */
  YYSYMBOL_cat1_swz = 415,                 /* cat1_swz  */
  YYSYMBOL_416_22 = 416,                   /* $@22  */
  YYSYMBOL_cat1_gat = 417,                 /* cat1_gat  */
  YYSYMBOL_418_23 = 418,                   /* $@23  */
  YYSYMBOL_cat1_sct = 419,                 /* cat1_sct  */
  YYSYMBOL_420_24 = 420,                   /* $@24  */
  YYSYMBOL_cat1_instr = 421,               /* cat1_instr  */
  YYSYMBOL_cat2_opc_1src = 422,            /* cat2_opc_1src  */
  YYSYMBOL_cat2_opc_2src_cnd = 423,        /* cat2_opc_2src_cnd  */
  YYSYMBOL_cat2_opc_2src = 424,            /* cat2_opc_2src  */
  YYSYMBOL_cond = 425,                     /* cond  */
  YYSYMBOL_cat2_instr = 426,               /* cat2_instr  */
  YYSYMBOL_cat3_dp_signedness = 427,       /* cat3_dp_signedness  */
  YYSYMBOL_cat3_dp_pack = 428,             /* cat3_dp_pack  */
  YYSYMBOL_cat3_opc = 429,                 /* cat3_opc  */
  YYSYMBOL_cat3_imm_reg_opc = 430,         /* cat3_imm_reg_opc  */
  YYSYMBOL_cat3_wmm = 431,                 /* cat3_wmm  */
  YYSYMBOL_cat3_dp = 432,                  /* cat3_dp  */
  YYSYMBOL_cat3_instr = 433,               /* cat3_instr  */
  YYSYMBOL_cat4_opc = 434,                 /* cat4_opc  */
  YYSYMBOL_cat4_instr = 435,               /* cat4_instr  */
  YYSYMBOL_cat5_opc_dsxypp = 436,          /* cat5_opc_dsxypp  */
  YYSYMBOL_cat5_opc = 437,                 /* cat5_opc  */
  YYSYMBOL_cat5_flag = 438,                /* cat5_flag  */
  YYSYMBOL_cat5_flags = 439,               /* cat5_flags  */
  YYSYMBOL_cat5_samp = 440,                /* cat5_samp  */
  YYSYMBOL_cat5_tex = 441,                 /* cat5_tex  */
  YYSYMBOL_cat5_type = 442,                /* cat5_type  */
  YYSYMBOL_cat5_a1 = 443,                  /* cat5_a1  */
  YYSYMBOL_cat5_instr = 444,               /* cat5_instr  */
  YYSYMBOL_cat6_typed = 445,               /* cat6_typed  */
  YYSYMBOL_cat6_dim = 446,                 /* cat6_dim  */
  YYSYMBOL_cat6_type = 447,                /* cat6_type  */
  YYSYMBOL_cat6_imm_offset = 448,          /* cat6_imm_offset  */
  YYSYMBOL_cat6_offset = 449,              /* cat6_offset  */
  YYSYMBOL_cat6_dst_offset = 450,          /* cat6_dst_offset  */
  YYSYMBOL_cat6_immed = 451,               /* cat6_immed  */
  YYSYMBOL_cat6_a6xx_global_address_pt3 = 452, /* cat6_a6xx_global_address_pt3  */
  YYSYMBOL_cat6_a6xx_global_address_pt2 = 453, /* cat6_a6xx_global_address_pt2  */
  YYSYMBOL_cat6_a6xx_global_address = 454, /* cat6_a6xx_global_address  */
  YYSYMBOL_cat6_load = 455,                /* cat6_load  */
  YYSYMBOL_456_25 = 456,                   /* $@25  */
  YYSYMBOL_457_26 = 457,                   /* $@26  */
  YYSYMBOL_458_27 = 458,                   /* $@27  */
  YYSYMBOL_459_28 = 459,                   /* $@28  */
  YYSYMBOL_460_29 = 460,                   /* $@29  */
  YYSYMBOL_461_30 = 461,                   /* $@30  */
  YYSYMBOL_462_31 = 462,                   /* $@31  */
  YYSYMBOL_cat6_store = 463,               /* cat6_store  */
  YYSYMBOL_464_32 = 464,                   /* $@32  */
  YYSYMBOL_465_33 = 465,                   /* $@33  */
  YYSYMBOL_466_34 = 466,                   /* $@34  */
  YYSYMBOL_467_35 = 467,                   /* $@35  */
  YYSYMBOL_468_36 = 468,                   /* $@36  */
  YYSYMBOL_cat6_loadib = 469,              /* cat6_loadib  */
  YYSYMBOL_470_37 = 470,                   /* $@37  */
  YYSYMBOL_cat6_storeib = 471,             /* cat6_storeib  */
  YYSYMBOL_472_38 = 472,                   /* $@38  */
  YYSYMBOL_cat6_prefetch = 473,            /* cat6_prefetch  */
  YYSYMBOL_474_39 = 474,                   /* $@39  */
  YYSYMBOL_cat6_atomic_opc = 475,          /* cat6_atomic_opc  */
  YYSYMBOL_cat6_a3xx_atomic_opc = 476,     /* cat6_a3xx_atomic_opc  */
  YYSYMBOL_cat6_a6xx_atomic_opc = 477,     /* cat6_a6xx_atomic_opc  */
  YYSYMBOL_cat6_a3xx_atomic_s = 478,       /* cat6_a3xx_atomic_s  */
  YYSYMBOL_cat6_a6xx_atomic_g = 479,       /* cat6_a6xx_atomic_g  */
  YYSYMBOL_cat6_atomic_l = 480,            /* cat6_atomic_l  */
  YYSYMBOL_cat6_atomic = 481,              /* cat6_atomic  */
  YYSYMBOL_cat6_ibo_opc_1src = 482,        /* cat6_ibo_opc_1src  */
  YYSYMBOL_cat6_ibo_opc_ldgb = 483,        /* cat6_ibo_opc_ldgb  */
  YYSYMBOL_cat6_ibo_opc_stgb = 484,        /* cat6_ibo_opc_stgb  */
  YYSYMBOL_cat6_ibo = 485,                 /* cat6_ibo  */
  YYSYMBOL_486_40 = 486,                   /* $@40  */
  YYSYMBOL_cat6_id_opc = 487,              /* cat6_id_opc  */
  YYSYMBOL_cat6_id = 488,                  /* cat6_id  */
  YYSYMBOL_cat6_bindless_base = 489,       /* cat6_bindless_base  */
  YYSYMBOL_cat6_bindless_mode = 490,       /* cat6_bindless_mode  */
  YYSYMBOL_cat6_reg_or_immed = 491,        /* cat6_reg_or_immed  */
  YYSYMBOL_cat6_bindless_ibo_opc_1src = 492, /* cat6_bindless_ibo_opc_1src  */
  YYSYMBOL_cat6_bindless_ibo_opc_2src = 493, /* cat6_bindless_ibo_opc_2src  */
  YYSYMBOL_cat6_bindless_ibo_opc_2src_dst = 494, /* cat6_bindless_ibo_opc_2src_dst  */
  YYSYMBOL_cat6_bindless_ibo = 495,        /* cat6_bindless_ibo  */
  YYSYMBOL_cat6_bindless_ldc_opc = 496,    /* cat6_bindless_ldc_opc  */
  YYSYMBOL_cat6_bindless_ldc_middle = 497, /* cat6_bindless_ldc_middle  */
  YYSYMBOL_cat6_bindless_ldc = 498,        /* cat6_bindless_ldc  */
  YYSYMBOL_stc_dst = 499,                  /* stc_dst  */
  YYSYMBOL_cat6_stc = 500,                 /* cat6_stc  */
  YYSYMBOL_501_41 = 501,                   /* $@41  */
  YYSYMBOL_502_42 = 502,                   /* $@42  */
  YYSYMBOL_cat6_todo = 503,                /* cat6_todo  */
  YYSYMBOL_cat6_instr = 504,               /* cat6_instr  */
  YYSYMBOL_cat7_scope = 505,               /* cat7_scope  */
  YYSYMBOL_cat7_scopes = 506,              /* cat7_scopes  */
  YYSYMBOL_cat7_barrier = 507,             /* cat7_barrier  */
  YYSYMBOL_508_43 = 508,                   /* $@43  */
  YYSYMBOL_509_44 = 509,                   /* $@44  */
  YYSYMBOL_cat7_data_cache = 510,          /* cat7_data_cache  */
  YYSYMBOL_cat7_alias_src = 511,           /* cat7_alias_src  */
  YYSYMBOL_cat7_alias_scope = 512,         /* cat7_alias_scope  */
  YYSYMBOL_cat7_instr = 513,               /* cat7_instr  */
  YYSYMBOL_514_45 = 514,                   /* $@45  */
  YYSYMBOL_raw_instr = 515,                /* raw_instr  */
  YYSYMBOL_meta_print_regs = 516,          /* meta_print_regs  */
  YYSYMBOL_meta_print_reg = 517,           /* meta_print_reg  */
  YYSYMBOL_meta_print_start = 518,         /* meta_print_start  */
  YYSYMBOL_meta_print = 519,               /* meta_print  */
  YYSYMBOL_src = 520,                      /* src  */
  YYSYMBOL_dst = 521,                      /* dst  */
  YYSYMBOL_const = 522,                    /* const  */
  YYSYMBOL_dst_reg_flag = 523,             /* dst_reg_flag  */
  YYSYMBOL_dst_reg_flags = 524,            /* dst_reg_flags  */
  YYSYMBOL_dst_reg = 525,                  /* dst_reg  */
  YYSYMBOL_src_reg_flag = 526,             /* src_reg_flag  */
  YYSYMBOL_src_reg_flags = 527,            /* src_reg_flags  */
  YYSYMBOL_src_reg = 528,                  /* src_reg  */
  YYSYMBOL_src_reg_gpr = 529,              /* src_reg_gpr  */
  YYSYMBOL_src_const = 530,                /* src_const  */
  YYSYMBOL_src_reg_or_const = 531,         /* src_reg_or_const  */
  YYSYMBOL_src_reg_or_const_or_rel = 532,  /* src_reg_or_const_or_rel  */
  YYSYMBOL_src_reg_or_const_or_rel_or_imm = 533, /* src_reg_or_const_or_rel_or_imm  */
  YYSYMBOL_src_reg_or_rel_or_imm = 534,    /* src_reg_or_rel_or_imm  */
  YYSYMBOL_offset = 535,                   /* offset  */
  YYSYMBOL_relative_gpr_src = 536,         /* relative_gpr_src  */
  YYSYMBOL_relative_gpr_dst = 537,         /* relative_gpr_dst  */
  YYSYMBOL_relative_const = 538,           /* relative_const  */
  YYSYMBOL_relative = 539,                 /* relative  */
  YYSYMBOL_immediate_cat1 = 540,           /* immediate_cat1  */
  YYSYMBOL_immediate = 541,                /* immediate  */
  YYSYMBOL_flut_immed = 542,               /* flut_immed  */
  YYSYMBOL_integer = 543,                  /* integer  */
  YYSYMBOL_float = 544,                    /* float  */
  YYSYMBOL_type = 545                      /* type  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;


/* Second part of user prologue.  */
#line 317 "../src/freedreno/ir3/ir3_parser.y"

#if YYDEBUG
static void print_token(FILE *file, int type, YYSTYPE value)
{
	fprintf(file, "\ntype: %d\n", type);
}

#define YYPRINT(file, type, value) print_token(file, type, value)
#endif

#line 938 "src/freedreno/ir3/ir3_parser.c"


#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

/* Work around bug in HP-UX 11.23, which defines these macros
   incorrectly for preprocessor constants.  This workaround can likely
   be removed in 2023, as HPE has promised support for HP-UX 11.23
   (aka HP-UX 11i v2) only through the end of 2022; see Table 2 of
   <https://h20195.www2.hpe.com/V2/getpdf.aspx/4AA4-7673ENW.pdf>.  */
#ifdef __hpux
# undef UINT_LEAST8_MAX
# undef UINT_LEAST16_MAX
# define UINT_LEAST8_MAX 255
# define UINT_LEAST16_MAX 65535
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_int16 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YY_USE(E) ((void) (E))
#else
# define YY_USE(E) /* empty */
#endif

/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
#if defined __GNUC__ && ! defined __ICC && 406 <= __GNUC__ * 100 + __GNUC_MINOR__
# if __GNUC__ * 100 + __GNUC_MINOR__ < 407
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")
# else
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# endif
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if 1

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* 1 */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  3
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   1518

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  362
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  184
/* YYNRULES -- Number of rules.  */
#define YYNRULES  577
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  1194

/* YYMAXUTOK -- Last valid token kind.  */
#define YYMAXUTOK   591


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (yysymbol_kind_t, yytranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_int16 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   343,     2,   344,     2,     2,     2,     2,
     339,   340,     2,   350,   338,   337,   345,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   342,     2,
     351,   341,   360,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   353,     2,   354,     2,     2,     2,   346,     2,   357,
       2,     2,     2,   352,   361,     2,     2,   356,   355,     2,
       2,   347,   348,     2,   359,   349,     2,     2,     2,   358,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336
};

#if YYDEBUG
/* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,   721,   721,   721,   723,   724,   726,   727,   728,   729,
     730,   731,   732,   733,   734,   735,   736,   737,   739,   740,
     741,   742,   744,   750,   755,   763,   765,   765,   771,   777,
     784,   791,   800,   802,   804,   807,   809,   811,   818,   819,
     820,   821,   822,   823,   824,   825,   827,   828,   830,   831,
     833,   834,   835,   836,   837,   838,   839,   840,   841,   842,
     843,   845,   847,   848,   850,   851,   853,   854,   856,   857,
     857,   858,   858,   859,   859,   860,   860,   861,   861,   862,
     862,   863,   863,   864,   864,   865,   865,   866,   867,   867,
     868,   869,   870,   871,   872,   873,   874,   874,   875,   876,
     877,   878,   879,   879,   880,   881,   881,   882,   883,   883,
     884,   884,   885,   886,   886,   888,   891,   895,   896,   898,
     898,   914,   914,   921,   921,   928,   928,   930,   930,   932,
     932,   935,   936,   937,   938,   939,   940,   941,   942,   944,
     945,   946,   947,   948,   949,   950,   951,   952,   953,   954,
     955,   956,   957,   959,   960,   961,   962,   963,   964,   966,
     967,   968,   969,   970,   971,   972,   973,   974,   975,   976,
     977,   978,   979,   980,   981,   982,   983,   984,   985,   986,
     987,   988,   989,   990,   991,   992,   994,   995,   996,   997,
     998,   999,  1001,  1002,  1003,  1005,  1006,  1008,  1009,  1011,
    1012,  1013,  1014,  1015,  1016,  1017,  1018,  1019,  1020,  1021,
    1022,  1023,  1024,  1025,  1026,  1028,  1029,  1030,  1031,  1032,
    1034,  1035,  1037,  1038,  1040,  1041,  1042,  1043,  1045,  1046,
    1047,  1048,  1049,  1050,  1051,  1052,  1053,  1054,  1056,  1058,
    1059,  1061,  1062,  1063,  1064,  1065,  1066,  1067,  1068,  1069,
    1070,  1071,  1072,  1073,  1074,  1075,  1076,  1077,  1078,  1079,
    1080,  1081,  1082,  1083,  1084,  1085,  1086,  1087,  1088,  1089,
    1090,  1091,  1093,  1094,  1095,  1096,  1097,  1098,  1099,  1100,
    1101,  1102,  1103,  1104,  1106,  1107,  1108,  1109,  1111,  1112,
    1113,  1114,  1115,  1116,  1117,  1118,  1119,  1120,  1121,  1122,
    1123,  1124,  1125,  1126,  1127,  1128,  1129,  1131,  1132,  1134,
    1135,  1136,  1137,  1139,  1140,  1141,  1142,  1143,  1144,  1146,
    1149,  1154,  1160,  1166,  1169,  1171,  1171,  1172,  1172,  1173,
    1173,  1174,  1174,  1175,  1175,  1176,  1176,  1176,  1180,  1180,
    1181,  1181,  1182,  1182,  1183,  1183,  1184,  1184,  1186,  1186,
    1187,  1187,  1189,  1189,  1191,  1192,  1193,  1194,  1195,  1196,
    1197,  1198,  1199,  1200,  1201,  1203,  1204,  1205,  1206,  1207,
    1208,  1209,  1210,  1211,  1212,  1213,  1215,  1216,  1217,  1218,
    1219,  1220,  1221,  1222,  1223,  1224,  1225,  1227,  1229,  1231,
    1233,  1234,  1235,  1237,  1239,  1240,  1242,  1243,  1244,  1244,
    1247,  1248,  1249,  1251,  1253,  1254,  1256,  1257,  1258,  1260,
    1261,  1263,  1265,  1266,  1267,  1268,  1269,  1270,  1271,  1272,
    1273,  1274,  1275,  1276,  1278,  1280,  1281,  1282,  1284,  1288,
    1289,  1291,  1297,  1298,  1299,  1302,  1302,  1303,  1303,  1305,
    1306,  1307,  1309,  1310,  1311,  1312,  1313,  1314,  1315,  1316,
    1317,  1318,  1319,  1320,  1322,  1323,  1324,  1325,  1327,  1328,
    1330,  1330,  1331,  1331,  1333,  1334,  1335,  1337,  1338,  1340,
    1341,  1342,  1344,  1345,  1346,  1347,  1348,  1349,  1350,  1351,
    1351,  1358,  1360,  1361,  1363,  1367,  1374,  1432,  1433,  1434,
    1435,  1437,  1438,  1439,  1440,  1442,  1444,  1445,  1446,  1447,
    1448,  1450,  1451,  1454,  1455,  1457,  1458,  1459,  1460,  1461,
    1463,  1464,  1466,  1467,  1469,  1470,  1472,  1473,  1475,  1476,
    1478,  1479,  1480,  1482,  1483,  1484,  1486,  1487,  1488,  1490,
    1491,  1492,  1494,  1495,  1497,  1498,  1500,  1501,  1503,  1504,
    1510,  1511,  1512,  1513,  1514,  1515,  1516,  1518,  1519,  1520,
    1521,  1522,  1525,  1526,  1527,  1528,  1529,  1530,  1531,  1532,
    1533,  1534,  1535,  1536,  1538,  1539,  1540,  1541,  1543,  1544,
    1546,  1547,  1548,  1549,  1550,  1551,  1552,  1553
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if 1
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "T_INT", "T_HEX",
  "T_FLOAT", "T_IDENTIFIER", "T_REGISTER", "T_CONSTANT", "T_A_LOCALSIZE",
  "T_A_CONST", "T_A_BUF", "T_A_INVOCATIONID", "T_A_WGID", "T_A_NUMWG",
  "T_A_BRANCHSTACK", "T_A_IN", "T_A_OUT", "T_A_TEX", "T_A_PVTMEM",
  "T_A_EARLYPREAMBLE", "T_ABSNEG", "T_NEG", "T_ABS", "T_R", "T_LAST",
  "T_HR", "T_HC", "T_EVEN", "T_POS_INFINITY", "T_NEG_INFINITY", "T_EI",
  "T_WRMASK", "T_FLUT_0_0", "T_FLUT_0_5", "T_FLUT_1_0", "T_FLUT_2_0",
  "T_FLUT_E", "T_FLUT_PI", "T_FLUT_INV_PI", "T_FLUT_INV_LOG2_E",
  "T_FLUT_LOG2_E", "T_FLUT_INV_LOG2_10", "T_FLUT_LOG2_10", "T_FLUT_4_0",
  "T_SY", "T_SS", "T_JP", "T_EQ_FLAG", "T_SAT", "T_RPT", "T_UL", "T_NOP",
  "T_OP_NOP", "T_OP_BR", "T_OP_BRAO", "T_OP_BRAA", "T_OP_BRAC",
  "T_OP_BANY", "T_OP_BALL", "T_OP_BRAX", "T_OP_JUMP", "T_OP_CALL",
  "T_OP_RET", "T_OP_KILL", "T_OP_END", "T_OP_EMIT", "T_OP_CUT",
  "T_OP_CHMASK", "T_OP_CHSH", "T_OP_FLOW_REV", "T_OP_BKT", "T_OP_STKS",
  "T_OP_STKR", "T_OP_XSET", "T_OP_XCLR", "T_OP_GETLAST", "T_OP_GETONE",
  "T_OP_DBG", "T_OP_SHPS", "T_OP_SHPE", "T_OP_PREDT", "T_OP_PREDF",
  "T_OP_PREDE", "T_OP_MOVMSK", "T_OP_MOVA1", "T_OP_MOVA", "T_OP_MOV",
  "T_OP_COV", "T_OP_SWZ", "T_OP_GAT", "T_OP_SCT", "T_OP_ADD_F",
  "T_OP_MIN_F", "T_OP_MAX_F", "T_OP_MUL_F", "T_OP_SIGN_F", "T_OP_CMPS_F",
  "T_OP_ABSNEG_F", "T_OP_CMPV_F", "T_OP_FLOOR_F", "T_OP_CEIL_F",
  "T_OP_RNDNE_F", "T_OP_RNDAZ_F", "T_OP_TRUNC_F", "T_OP_ADD_U",
  "T_OP_ADD_S", "T_OP_SUB_U", "T_OP_SUB_S", "T_OP_CMPS_U", "T_OP_CMPS_S",
  "T_OP_MIN_U", "T_OP_MIN_S", "T_OP_MAX_U", "T_OP_MAX_S", "T_OP_ABSNEG_S",
  "T_OP_AND_B", "T_OP_OR_B", "T_OP_NOT_B", "T_OP_XOR_B", "T_OP_CMPV_U",
  "T_OP_CMPV_S", "T_OP_MUL_U24", "T_OP_MUL_S24", "T_OP_MULL_U",
  "T_OP_BFREV_B", "T_OP_CLZ_S", "T_OP_CLZ_B", "T_OP_SHL_B", "T_OP_SHR_B",
  "T_OP_ASHR_B", "T_OP_BARY_F", "T_OP_FLAT_B", "T_OP_MGEN_B",
  "T_OP_GETBIT_B", "T_OP_SETRM", "T_OP_CBITS_B", "T_OP_SHB", "T_OP_MSAD",
  "T_OP_MAD_U16", "T_OP_MADSH_U16", "T_OP_MAD_S16", "T_OP_MADSH_M16",
  "T_OP_MAD_U24", "T_OP_MAD_S24", "T_OP_MAD_F16", "T_OP_MAD_F32",
  "T_OP_SEL_B16", "T_OP_SEL_B32", "T_OP_SEL_S16", "T_OP_SEL_S32",
  "T_OP_SEL_F16", "T_OP_SEL_F32", "T_OP_SAD_S16", "T_OP_SAD_S32",
  "T_OP_SHRM", "T_OP_SHLM", "T_OP_SHRG", "T_OP_SHLG", "T_OP_ANDG",
  "T_OP_DP2ACC", "T_OP_DP4ACC", "T_OP_WMM", "T_OP_WMM_ACCU", "T_OP_RCP",
  "T_OP_RSQ", "T_OP_LOG2", "T_OP_EXP2", "T_OP_SIN", "T_OP_COS",
  "T_OP_SQRT", "T_OP_HRSQ", "T_OP_HLOG2", "T_OP_HEXP2", "T_OP_ISAM",
  "T_OP_ISAML", "T_OP_ISAMM", "T_OP_SAM", "T_OP_SAMB", "T_OP_SAML",
  "T_OP_SAMGQ", "T_OP_GETLOD", "T_OP_CONV", "T_OP_CONVM", "T_OP_GETSIZE",
  "T_OP_GETBUF", "T_OP_GETPOS", "T_OP_GETINFO", "T_OP_DSX", "T_OP_DSY",
  "T_OP_GATHER4R", "T_OP_GATHER4G", "T_OP_GATHER4B", "T_OP_GATHER4A",
  "T_OP_SAMGP0", "T_OP_SAMGP1", "T_OP_SAMGP2", "T_OP_SAMGP3",
  "T_OP_DSXPP_1", "T_OP_DSYPP_1", "T_OP_RGETPOS", "T_OP_RGETINFO",
  "T_OP_BRCST_A", "T_OP_QSHUFFLE_BRCST", "T_OP_QSHUFFLE_H",
  "T_OP_QSHUFFLE_V", "T_OP_QSHUFFLE_DIAG", "T_OP_TCINV", "T_OP_LDG",
  "T_OP_LDG_A", "T_OP_LDL", "T_OP_LDP", "T_OP_STG", "T_OP_STG_A",
  "T_OP_STL", "T_OP_STP", "T_OP_LDIB", "T_OP_G2L", "T_OP_L2G",
  "T_OP_PREFETCH", "T_OP_LDLW", "T_OP_STLW", "T_OP_RESFMT", "T_OP_RESINFO",
  "T_OP_ATOMIC_ADD", "T_OP_ATOMIC_SUB", "T_OP_ATOMIC_XCHG",
  "T_OP_ATOMIC_INC", "T_OP_ATOMIC_DEC", "T_OP_ATOMIC_CMPXCHG",
  "T_OP_ATOMIC_MIN", "T_OP_ATOMIC_MAX", "T_OP_ATOMIC_AND",
  "T_OP_ATOMIC_OR", "T_OP_ATOMIC_XOR", "T_OP_RESINFO_B", "T_OP_LDIB_B",
  "T_OP_STIB_B", "T_OP_ATOMIC_B_ADD", "T_OP_ATOMIC_B_SUB",
  "T_OP_ATOMIC_B_XCHG", "T_OP_ATOMIC_B_INC", "T_OP_ATOMIC_B_DEC",
  "T_OP_ATOMIC_B_CMPXCHG", "T_OP_ATOMIC_B_MIN", "T_OP_ATOMIC_B_MAX",
  "T_OP_ATOMIC_B_AND", "T_OP_ATOMIC_B_OR", "T_OP_ATOMIC_B_XOR",
  "T_OP_ATOMIC_S_ADD", "T_OP_ATOMIC_S_SUB", "T_OP_ATOMIC_S_XCHG",
  "T_OP_ATOMIC_S_INC", "T_OP_ATOMIC_S_DEC", "T_OP_ATOMIC_S_CMPXCHG",
  "T_OP_ATOMIC_S_MIN", "T_OP_ATOMIC_S_MAX", "T_OP_ATOMIC_S_AND",
  "T_OP_ATOMIC_S_OR", "T_OP_ATOMIC_S_XOR", "T_OP_ATOMIC_G_ADD",
  "T_OP_ATOMIC_G_SUB", "T_OP_ATOMIC_G_XCHG", "T_OP_ATOMIC_G_INC",
  "T_OP_ATOMIC_G_DEC", "T_OP_ATOMIC_G_CMPXCHG", "T_OP_ATOMIC_G_MIN",
  "T_OP_ATOMIC_G_MAX", "T_OP_ATOMIC_G_AND", "T_OP_ATOMIC_G_OR",
  "T_OP_ATOMIC_G_XOR", "T_OP_LDGB", "T_OP_STGB", "T_OP_STIB", "T_OP_LDC",
  "T_OP_LDLV", "T_OP_GETSPID", "T_OP_GETWID", "T_OP_GETFIBERID",
  "T_OP_STC", "T_OP_STSC", "T_OP_BAR", "T_OP_FENCE", "T_OP_SLEEP",
  "T_OP_ICINV", "T_OP_DCCLN", "T_OP_DCINV", "T_OP_DCFLU", "T_OP_CCINV",
  "T_OP_LOCK", "T_OP_UNLOCK", "T_OP_ALIAS", "T_RAW", "T_OP_PRINT",
  "T_TYPE_F16", "T_TYPE_F32", "T_TYPE_U16", "T_TYPE_U32", "T_TYPE_S16",
  "T_TYPE_S32", "T_TYPE_U8", "T_TYPE_S8", "T_UNTYPED", "T_TYPED",
  "T_MIXED", "T_UNSIGNED", "T_LOW", "T_HIGH", "T_1D", "T_2D", "T_3D",
  "T_4D", "T_LT", "T_LE", "T_GT", "T_GE", "T_EQ", "T_NE", "T_S2EN",
  "T_SAMP", "T_TEX", "T_BASE", "T_OFFSET", "T_UNIFORM", "T_NONUNIFORM",
  "T_IMM", "T_NAN", "T_INF", "T_A0", "T_A1", "T_P0", "T_W",
  "T_CAT1_TYPE_TYPE", "T_INSTR_TYPE", "T_MOD_TEX", "T_MOD_MEM", "T_MOD_RT",
  "'-'", "','", "'('", "')'", "'='", "':'", "'!'", "'#'", "'.'", "'a'",
  "'o'", "'p'", "'s'", "'+'", "'<'", "'g'", "'['", "']'", "'l'", "'k'",
  "'c'", "'w'", "'r'", "'>'", "'h'", "$accept", "shader", "$@1", "headers",
  "header", "const_val", "localsize_header", "const_header",
  "buf_header_addr_reg", "buf_header", "$@2", "invocationid_header",
  "wgid_header", "numwg_header", "branchstack_header", "pvtmem_header",
  "earlypreamble_header", "in_header", "out_header", "tex_header", "iflag",
  "iflags", "instrs", "instr", "label", "cat0_src1", "cat0_src2",
  "cat0_immed", "cat0_instr", "$@3", "$@4", "$@5", "$@6", "$@7", "$@8",
  "$@9", "$@10", "$@11", "$@12", "$@13", "$@14", "$@15", "$@16", "$@17",
  "$@18", "cat1_opc", "cat1_src", "cat1_movmsk", "$@19", "cat1_mova1",
  "$@20", "cat1_mova", "$@21", "cat1_swz", "$@22", "cat1_gat", "$@23",
  "cat1_sct", "$@24", "cat1_instr", "cat2_opc_1src", "cat2_opc_2src_cnd",
  "cat2_opc_2src", "cond", "cat2_instr", "cat3_dp_signedness",
  "cat3_dp_pack", "cat3_opc", "cat3_imm_reg_opc", "cat3_wmm", "cat3_dp",
  "cat3_instr", "cat4_opc", "cat4_instr", "cat5_opc_dsxypp", "cat5_opc",
  "cat5_flag", "cat5_flags", "cat5_samp", "cat5_tex", "cat5_type",
  "cat5_a1", "cat5_instr", "cat6_typed", "cat6_dim", "cat6_type",
  "cat6_imm_offset", "cat6_offset", "cat6_dst_offset", "cat6_immed",
  "cat6_a6xx_global_address_pt3", "cat6_a6xx_global_address_pt2",
  "cat6_a6xx_global_address", "cat6_load", "$@25", "$@26", "$@27", "$@28",
  "$@29", "$@30", "$@31", "cat6_store", "$@32", "$@33", "$@34", "$@35",
  "$@36", "cat6_loadib", "$@37", "cat6_storeib", "$@38", "cat6_prefetch",
  "$@39", "cat6_atomic_opc", "cat6_a3xx_atomic_opc",
  "cat6_a6xx_atomic_opc", "cat6_a3xx_atomic_s", "cat6_a6xx_atomic_g",
  "cat6_atomic_l", "cat6_atomic", "cat6_ibo_opc_1src", "cat6_ibo_opc_ldgb",
  "cat6_ibo_opc_stgb", "cat6_ibo", "$@40", "cat6_id_opc", "cat6_id",
  "cat6_bindless_base", "cat6_bindless_mode", "cat6_reg_or_immed",
  "cat6_bindless_ibo_opc_1src", "cat6_bindless_ibo_opc_2src",
  "cat6_bindless_ibo_opc_2src_dst", "cat6_bindless_ibo",
  "cat6_bindless_ldc_opc", "cat6_bindless_ldc_middle", "cat6_bindless_ldc",
  "stc_dst", "cat6_stc", "$@41", "$@42", "cat6_todo", "cat6_instr",
  "cat7_scope", "cat7_scopes", "cat7_barrier", "$@43", "$@44",
  "cat7_data_cache", "cat7_alias_src", "cat7_alias_scope", "cat7_instr",
  "$@45", "raw_instr", "meta_print_regs", "meta_print_reg",
  "meta_print_start", "meta_print", "src", "dst", "const", "dst_reg_flag",
  "dst_reg_flags", "dst_reg", "src_reg_flag", "src_reg_flags", "src_reg",
  "src_reg_gpr", "src_const", "src_reg_or_const",
  "src_reg_or_const_or_rel", "src_reg_or_const_or_rel_or_imm",
  "src_reg_or_rel_or_imm", "offset", "relative_gpr_src",
  "relative_gpr_dst", "relative_const", "relative", "immediate_cat1",
  "immediate", "flut_immed", "integer", "float", "type", YY_NULLPTR
};

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  return yytname[yysymbol];
}
#endif

#define YYPACT_NINF (-948)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-4)

#define yytable_value_is_error(Yyn) \
  0

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
static const yytype_int16 yypact[] =
{
    -948,    29,  1007,  -948,    64,  -287,    64,  -278,  -258,  -253,
      64,  -248,  -244,  -221,    64,  -948,   750,  1007,  -948,  -948,
    -948,  -948,  -948,  -948,  -948,  -948,  -948,  -948,  -948,  -948,
    -948,  -948,  -948,   123,  -200,   149,  -948,   152,    93,   154,
    -948,   160,   169,   193,  -948,  -137,  -948,  -948,  -948,  -948,
    -948,  -948,  -948,  -948,  -948,   200,   147,  1227,   885,  -948,
    -948,  -948,  -126,  -948,  -948,  -948,    64,   -96,   -83,   -63,
     -60,   -58,   -55,   -54,   -53,   -49,  -948,  -948,  -948,  -948,
    -948,  -948,  -948,   -86,  -948,  -948,  -948,  -948,  -948,  -948,
    -948,  -948,  -948,  -948,  -948,  -948,  -948,  -948,  -948,  -948,
    -948,  -948,   -79,  -948,  -948,  -948,  -948,  -948,  -948,  -948,
     -52,   -29,   -27,   -43,   -41,   -40,   -34,   -31,  -948,  -948,
    -948,  -948,  -948,  -948,  -948,  -948,  -948,  -948,  -948,  -948,
    -948,  -948,  -948,  -948,  -948,  -948,  -948,  -948,  -948,  -948,
    -948,  -948,  -948,  -948,  -948,  -948,  -948,  -948,  -948,  -948,
    -948,  -948,  -948,  -948,  -948,  -948,  -948,  -948,  -948,  -948,
    -948,  -948,  -948,  -948,  -948,  -948,  -948,  -948,  -948,  -948,
    -948,  -948,  -948,  -948,  -948,  -948,  -948,  -948,  -948,  -948,
    -948,  -948,  -948,  -948,  -948,  -948,  -948,  -948,  -948,  -948,
    -948,  -948,  -948,  -948,  -948,  -948,  -948,  -948,  -948,  -948,
    -948,  -948,  -948,  -948,  -948,  -948,  -948,  -948,  -948,  -948,
    -948,  -948,  -948,  -948,  -948,  -948,  -948,  -948,  -948,  -948,
    -948,  -948,  -948,  -948,  -948,  -948,  -948,  -948,  -948,  -948,
    -948,  -948,  -948,  -948,  -948,  -948,  -948,  -948,  -948,  -948,
    -948,  -948,  -948,  -948,  -948,  -948,  -948,  -948,  -948,  -948,
    -948,  -948,  -948,  -948,  -948,  -948,  -948,  -948,  -948,  -948,
    -948,  -948,  -948,  -948,  -948,  -948,  -948,  -948,  -948,  -948,
    -948,  -948,  -948,  -948,  -948,  -948,  -948,  -948,  -948,  -948,
    -948,  -948,  -948,  -948,  -948,  -948,  -948,  -948,  -948,  -948,
    -948,  -948,  -948,  -948,  -948,  -948,  -948,  -948,  -948,  -948,
    -948,  -948,  -948,  -948,  -948,  -948,  -948,  -948,  -948,  -948,
    -948,  -948,  -948,  -948,  -948,  -948,  -948,  -948,  -948,   266,
    -948,  -948,  -948,  -948,  -948,  -948,  -948,   327,   -30,   327,
    -948,   327,   327,   327,   -25,  -948,   327,  -948,   -24,   -24,
    -948,  -948,  -948,  -948,  -948,  -948,   -23,   -23,   -23,  -948,
    -948,  -948,  -948,   -15,   -23,   -23,  -948,   -15,  -948,   -23,
     -23,   -23,  -948,   -13,  -948,  -948,  -948,  -948,  -948,  -948,
    -948,  -948,   326,  -948,  -126,     4,    64,   339,  -948,  -948,
    -948,  -948,  -948,   342,   355,   356,  -234,  -234,  -234,     9,
    -234,  -234,    21,    21,    21,  -234,    21,    36,    21,    21,
    -234,  -234,    37,    38,    45,    52,    60,    61,    63,    66,
     -15,   -15,   -15,   -15,   -15,   -15,   -15,   -15,   -23,    33,
     -15,   -15,   -23,   -15,   -15,   -15,    74,    74,    82,  -948,
      81,  -948,  -948,  -948,  -948,  -948,  -948,  -948,  -948,    87,
    -948,   510,    43,    84,   102,   103,   238,   109,   110,   111,
     115,  -193,   113,   118,   684,   -24,   327,    73,  -187,   117,
     117,   117,   555,   117,   117,   117,   327,   117,   117,   117,
      67,  -948,  -948,    64,   125,   126,   129,   130,   132,  -948,
     140,   136,   137,   141,  -948,  -948,   176,  -948,   142,   143,
      71,  -948,  -948,  -948,  -948,  -948,  -948,  -948,  -948,  -948,
    -948,  -948,  -948,  -948,  -948,  -948,  -948,  -948,  -948,   327,
     327,   327,   327,   145,   146,   127,   155,   117,   135,   327,
     138,   117,   327,   151,   157,  -118,    74,  -948,  -948,  -201,
     166,   167,  -948,  -948,   148,   148,   785,  -948,  -948,  -948,
    -948,  -948,  -948,   327,   785,   302,   876,   161,  -948,  -948,
     -74,   327,   785,  -948,  -948,  -948,  -948,  -948,  -948,  -948,
    -948,  -948,  -948,  -948,   168,   555,   327,  -948,  -948,   -88,
     -15,   -15,   -15,  -948,  -948,  -948,  -948,  -948,  -948,  -948,
    -948,  -948,   327,   -15,   -15,  -948,   -15,   -15,   -15,   159,
     172,   173,  -948,  -948,    64,  -948,   512,   513,     9,  -948,
      21,  -180,  -180,  -948,  -948,    21,    21,    21,  -948,  -948,
      21,   327,   148,   148,   327,   327,   327,   183,   184,   190,
     191,   177,   178,   180,   194,   -15,    58,   208,   203,   -15,
     232,   214,   218,  -948,  -948,  -948,  -948,  -948,  -948,  -948,
    -948,   199,  -184,  -184,  -948,  -948,  -948,  -948,  -948,  -948,
    -948,   222,   223,  -948,  -948,  -948,    53,   224,   225,   246,
    -948,  -948,  -948,   540,     7,  -948,  -948,  -948,  -948,  -948,
    -948,  -948,  -948,  -948,  -948,  -948,  -948,  -948,  -948,  -948,
    -948,  -948,  -948,  -948,  -948,  -948,  -948,     9,   727,   918,
    -948,  -948,  -948,  -948,  -948,   248,   249,   254,    58,  -948,
     260,  -948,  -948,  -948,   262,  -948,  -948,  -948,   265,  -948,
     559,   264,   270,  -948,  -948,  -948,  -948,   267,   269,   275,
     284,   278,   282,   283,   288,   290,     9,   280,    23,   299,
     300,   301,   306,  -948,  -948,   315,   310,   312,  -948,  -948,
    -948,  -948,  -948,  -948,  -948,   316,   320,   322,   314,   317,
     309,   323,    58,   106,    58,    58,   325,  -173,   313,    58,
     328,   319,    89,    89,   345,     9,     9,   324,   330,   344,
     354,  -948,   343,   346,   185,   348,   357,   366,   367,    94,
    -948,  -948,  -948,  -948,   358,     9,  -948,  -948,   785,   785,
     106,   106,   559,   876,  -948,  -948,   206,     9,     9,     9,
     347,     9,     9,     9,     9,     9,   351,   364,   365,  -948,
    -948,    64,     9,     9,   705,  -948,    21,    21,   327,   559,
     327,   359,   360,   362,   368,  -184,   363,    77,   370,  -172,
    -172,     9,    23,  -948,   371,  -948,   373,  -172,     9,   375,
     374,   377,  -948,   378,   384,  -948,  -948,  -948,  -948,  -184,
    -184,  -948,  -948,  -948,  -948,  -948,  -184,  -184,   393,   395,
    -948,   396,   380,  -948,   399,   401,   402,   405,  -948,  -948,
     406,  -948,   407,   403,   408,   412,   394,   327,  -948,   413,
     428,   429,  -108,  -108,    23,   414,   411,   435,   436,  -948,
    -948,   438,   441,   442,    58,   106,    58,    58,   392,   445,
      15,    23,   437,  -948,   440,   327,  -948,   452,    58,   450,
     461,     9,     9,   476,   477,     9,   457,   470,   471,   472,
    -948,  -948,  -948,   785,   302,   876,     2,   106,   514,   206,
     478,   483,   484,    23,   500,   487,  -108,  -108,  -108,   495,
     495,   495,   327,   488,  -948,    64,  -948,  -948,     9,   559,
     559,   327,  -173,   503,  -173,  -173,   520,    58,    58,  -948,
     -81,  -948,   522,   523,   524,     9,  -173,   525,   511,   515,
    -948,   559,     2,   327,  -948,  -948,  -948,  -948,  -948,  -948,
    -948,  -948,   534,  -948,   535,   536,   537,   327,   327,   327,
     516,   489,   531,   327,   559,   327,   571,  -948,  -948,  -948,
    -948,   541,  -948,   558,   567,   568,   569,   539,   570,   550,
     573,    58,   586,  -184,    23,   577,  -948,    58,    58,   588,
    -948,   575,    58,     2,  -948,   600,   603,   604,   876,   229,
     559,   206,   605,   609,   610,  -948,   596,    23,   612,   625,
     626,  -948,   636,   962,   559,   559,   327,   632,     2,   633,
     634,   635,     2,   644,  -948,     9,   637,   647,   621,   650,
     660,   649,   666,     9,     9,   100,  -948,  -948,  -948,  -948,
    -948,   668,   672,  -948,   659,   676,    58,    23,   675,    23,
      23,    23,   680,   694,  -948,   698,   699,     2,  -948,     2,
       2,     2,  -948,   687,  -184,     2,     2,     2,     2,     2,
     701,     2,  -948,  -948,  -948,  -948,  -948,   229,   559,   688,
     691,   702,   692,   707,  -948,   709,   710,  -948,     9,   559,
     559,  -948,  -948,  -948,  -948,   700,   703,  -948,  -948,   696,
    -948,  -948,    58,  -948,  -948,  -948,  -948,    23,    23,    58,
     714,    58,    23,    23,   717,  -948,  -948,     9,   706,   718,
     720,   708,   711,  -948,    58,   721,  -948,  -948,  1054,  -948,
       9,    58,    58,   723,   725,   726,    23,   730,  -948,   729,
     734,    58,    58,    58,   735,     9,    58,    58,  -948,   738,
    -948,    58,   739,  -948,  -948,    58,  -948,  1062,   740,   741,
      58,     9,  -948,  -948
};

/* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE does not specify something else to do.  Zero
   means the default is an error.  */
static const yytype_int16 yydefact[] =
{
       2,     0,     4,     1,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    34,    46,     4,     6,     7,
       8,     9,    10,    11,    12,    16,    17,    13,    14,    15,
      19,    21,    18,     0,     0,     0,    26,     0,     0,     0,
      32,     0,     0,     0,    33,     0,    38,    39,    40,    41,
      42,    43,    44,    45,   481,     0,    46,     0,    46,    49,
      60,    58,     0,    59,     5,    20,     0,     0,    25,     0,
       0,     0,     0,     0,     0,     0,    61,   485,    47,    68,
      69,    71,    73,     0,    77,    79,    81,    83,    85,    87,
      88,    90,    91,    92,    93,    94,    95,    96,    98,    99,
     100,   101,     0,   102,   104,   105,   107,   108,   110,   112,
       0,     0,     0,     0,     0,     0,     0,     0,   159,   160,
     161,   162,   143,   153,   139,   156,   144,   145,   146,   147,
     148,   163,   164,   165,   166,   154,   155,   167,   168,   169,
     170,   140,   171,   172,   149,   173,   157,   158,   174,   175,
     176,   150,   142,   141,   177,   178,   179,   180,   181,   182,
     183,   151,   152,   184,   185,   199,   200,   201,   202,   203,
     204,   205,   206,   207,   208,   209,   210,   211,   212,   213,
     214,   215,   216,   217,   218,   219,   222,   223,   220,   221,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   239,   240,   265,   266,   267,   268,
     269,   270,   271,   306,   325,   327,   331,   329,   338,   340,
     344,   342,   348,   439,   440,   352,   333,   346,   441,   393,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   411,   424,   423,   412,   413,   414,   415,   416,   417,
     418,   419,   420,   421,   422,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,   383,   384,   385,   386,   394,   395,   350,
     428,   335,   400,   401,   402,   435,   437,   460,   462,   474,
     476,   464,   465,   466,   475,   477,   478,   479,    50,     0,
     131,   132,   133,   134,   135,   136,    51,     0,     0,     0,
      52,     0,     0,     0,     0,    53,     0,    54,   282,   282,
      55,   442,   444,   443,   445,   446,     0,     0,     0,   391,
     392,   390,   447,     0,     0,     0,   448,     0,   449,     0,
       0,     0,   451,     0,   450,   452,   453,    56,   472,   473,
      57,    48,     0,   486,   482,     0,     0,     0,    27,    28,
      29,    30,    31,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   458,   458,     0,   491,
       0,   496,   497,   498,   499,   500,   492,   493,   494,     0,
     503,   501,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   282,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   484,   483,     0,     0,     0,     0,     0,     0,    63,
       0,     0,     0,     0,   564,   566,     0,    75,     0,     0,
       0,    82,    84,    86,    89,    97,   113,   103,   106,   109,
     111,   119,   121,   123,   115,   116,   125,   127,   129,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   458,   461,   463,     0,
       0,     0,   502,   504,     0,     0,     0,   186,   187,   188,
     189,   190,   191,     0,     0,     0,     0,     0,   195,   196,
       0,     0,     0,   272,   277,   280,   278,   279,   281,   273,
     274,   275,   276,   283,     0,     0,     0,   307,   308,     0,
       0,     0,     0,   570,   571,   572,   573,   574,   575,   576,
     577,   313,     0,     0,     0,   403,     0,     0,     0,     0,
       0,     0,   319,    22,     0,    24,     0,     0,     0,    62,
       0,     0,     0,   565,   567,     0,     0,     0,    67,    66,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   457,   456,   454,   455,   459,   469,   470,
     471,     0,   529,   529,   487,   495,   505,   506,   507,   508,
     509,     0,     0,   488,   489,   490,     0,     0,     0,     0,
     137,   512,   516,   510,     0,   518,   519,   520,   117,   538,
     539,   521,   118,   540,   138,   552,   553,   554,   555,   556,
     557,   558,   559,   560,   561,   562,   563,     0,     0,     0,
     523,   192,   525,   549,   547,     0,     0,     0,     0,   526,
       0,   527,   528,   514,     0,   515,   197,   198,     0,   238,
       0,     0,   305,   309,   310,   311,   312,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    70,    65,     0,     0,     0,    76,    78,
      80,   114,   120,   122,   124,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   529,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   568,     0,     0,     0,     0,     0,     0,     0,     0,
     511,   513,   517,   522,     0,     0,   551,   524,     0,     0,
       0,     0,     0,     0,   288,   286,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   409,
     410,     0,     0,     0,     0,    64,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   529,     0,     0,     0,   529,
     529,     0,     0,   315,     0,   314,     0,   529,     0,     0,
     433,     0,   432,     0,     0,   531,   530,   535,   534,   529,
     529,   545,   546,   569,   541,   542,   529,   529,     0,     0,
     548,     0,     0,   194,     0,     0,     0,     0,   284,   285,
     303,   304,   301,     0,     0,     0,     0,     0,   398,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    72,
      74,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   317,     0,     0,   316,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     543,   544,   550,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   404,
     404,   404,     0,     0,   431,     0,    35,    36,     0,     0,
       0,     0,   529,     0,   529,   529,     0,     0,     0,   324,
       0,   318,     0,     0,     0,     0,   529,     0,     0,     0,
     434,     0,     0,     0,   533,   537,   536,   532,   193,   224,
     225,   226,     0,   302,   299,   300,   295,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   407,   408,   406,
     429,     0,    23,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   529,     0,     0,   323,     0,     0,     0,
     353,     0,     0,     0,   336,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   396,     0,     0,     0,     0,
       0,   405,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   321,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   227,   296,   297,   287,
     298,   293,   294,   289,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   126,     0,     0,     0,   328,     0,
       0,     0,   341,     0,   529,     0,     0,     0,     0,     0,
       0,     0,   436,   438,   480,   467,   468,     0,     0,     0,
       0,     0,     0,     0,   425,     0,     0,   430,     0,     0,
       0,   326,   332,   330,   339,     0,     0,   345,   343,     0,
     334,   347,     0,   337,   290,   291,   292,     0,     0,     0,
       0,     0,     0,     0,     0,   128,   130,     0,     0,     0,
       0,     0,     0,   388,     0,     0,   426,   427,     0,   322,
       0,     0,     0,     0,     0,     0,     0,     0,   320,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   389,     0,
     397,     0,     0,   349,   351,     0,   399,     0,     0,     0,
       0,     0,   387,    37
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -948,  -948,  -948,  1063,  -948,    -6,  -948,  -948,  -948,  -948,
    -948,  -948,  -948,  -948,  -948,  -948,  -948,  -948,  -948,  -948,
    -948,  1023,  -948,  1025,  -948,  -112,   479,  -345,  -948,  -948,
    -948,  -948,  -948,  -948,  -948,  -948,  -948,  -948,  -948,  -948,
    -948,  -948,  -948,  -948,  -948,  -948,  -476,  -948,  -948,  -948,
    -948,  -948,  -948,  -948,  -948,  -948,  -948,  -948,  -948,  -948,
    -948,  -948,  -948,  -948,  -948,  -948,  -948,  -948,  -948,  -948,
    -948,  -948,  -948,  -948,  -948,  -948,  -948,  -323,  -882,  -823,
    -948,  -947,  -948,   292,   532,   566,   259,  -876,  -720,   -97,
    -948,  -948,   192,  -948,  -948,  -948,  -948,  -948,  -948,  -948,
    -948,  -948,  -948,  -948,  -948,  -948,  -948,  -948,  -948,  -948,
    -948,  -948,  -948,  -948,  -948,  -948,  -948,  -948,  -948,  -948,
    -948,  -948,  -948,  -948,  -948,  -948,  -948,  -669,  -794,   -68,
    -948,  -948,  -948,  -948,  -948,  -948,  -948,   329,  -948,  -948,
    -948,  -948,  -948,  -948,  -372,  -948,  -948,  -948,  -948,  -948,
    -948,  -948,  -948,  -948,   712,  -948,  -948,  -948,  -295,   643,
    -570,  -948,   648,  -308,  -948,  -472,  -529,  -948,  -948,  -441,
    -525,  -541,  -786,  -611,   543,  -948,  -948,  -544,    26,  -480,
     400,  -388,   318,   528
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
       0,     1,     2,    16,    17,    34,    18,    19,   378,    20,
      68,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      56,    57,    58,    59,    60,   481,   736,   491,   318,   386,
     387,   388,   605,   390,   391,   392,   393,   394,   395,   396,
     398,   399,   400,   401,   610,   319,   660,   320,   611,   321,
     612,   322,   613,   323,   614,   324,   615,   325,   616,   326,
     327,   328,   329,   543,   330,   452,   551,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   455,   456,   870,   871,
     566,  1068,   340,   459,   570,   463,   833,   834,   902,   590,
    1016,   959,   826,   341,   410,   411,   413,   412,   420,   423,
    1062,   342,   414,   415,   417,   416,   421,   343,   418,   344,
     422,   345,   419,   346,   347,   348,   349,   350,   351,   352,
     353,   354,   355,   356,   935,   357,   358,   997,   942,   808,
     359,   360,   361,   362,   363,   591,   364,   841,   365,   424,
     425,   366,   367,   526,   527,   368,   426,   427,   369,  1104,
     641,   370,   428,    61,   373,   374,    62,    63,   661,   440,
     662,   441,   442,   443,   663,   698,   665,   704,   666,   667,
     690,   691,   700,   835,   669,   444,   670,   671,   672,   692,
     693,   694,   776,   581
};

/* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule whose
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
      36,   487,   701,   696,    40,   484,   485,   867,    44,   668,
     668,   709,   484,   485,   644,   645,   457,   699,   703,   445,
     697,   447,   644,   448,   449,   450,   484,   485,   453,     3,
     644,   767,   768,   651,   652,   675,   676,   677,   678,   679,
     680,   681,   682,   683,   684,   685,   686,   984,   492,   493,
     429,   495,    35,   497,   498,   528,   484,   485,   771,   674,
     375,    37,   664,   664,   689,   644,   702,    30,    31,    32,
     484,   485,   689,   664,   484,   485,  1007,   608,  1009,  1010,
     689,    38,   592,  1070,   644,   645,    39,   668,   668,   943,
    1021,    41,   484,   485,   782,    42,   479,   484,   485,   771,
      70,    71,   609,   484,   485,   983,   985,   644,   645,   480,
     904,   548,   549,   644,   645,   567,   568,   909,    43,   782,
     783,   646,   647,   648,   649,   650,    65,   646,   647,   648,
     649,   650,   563,   638,   639,   640,   743,   744,    66,   980,
     664,   664,   993,   994,   995,   783,   673,   673,   564,  1071,
     734,   484,   485,   765,   637,   644,   645,    67,   585,    69,
    1135,  1136,    72,   735,   765,   765,   766,    73,   644,   646,
     647,   648,   649,   650,   651,   652,    74,   832,   901,   603,
     604,   794,   646,   647,   648,   649,   650,   651,   603,   604,
     853,   780,    46,    47,    48,    49,    50,    51,    52,    53,
      75,   617,   618,   619,   620,    76,  1067,    77,  1072,   787,
     732,   627,   372,   644,   630,   939,   940,   941,   903,   903,
     713,   714,   715,   716,   673,   673,   903,   646,   647,   648,
     649,   650,   706,   707,   633,   695,   644,   634,   916,   917,
     635,   636,  1066,   708,   376,   918,   919,   862,   863,   701,
     646,   647,   648,   649,   650,   733,   377,   782,   712,   389,
     738,   739,   740,   866,   699,   741,   397,   872,   775,  1014,
    1015,   998,   999,   429,   720,   482,   483,   379,   488,   489,
     380,   827,   381,   494,  1134,   382,   383,   384,   499,   500,
     892,   385,   430,   402,   431,   432,   433,   434,   435,   784,
     403,   404,   405,   742,   406,   407,   745,   746,   747,   644,
     645,   408,   828,   702,   409,   446,   689,   689,   827,   827,
     451,   454,   458,   646,   647,   648,   649,   650,   651,   652,
     462,   757,   470,   471,   429,   653,   654,   655,   592,   486,
     810,   687,   473,   653,   654,   655,   486,   475,   476,   864,
     865,   653,   654,   655,   958,   431,   432,   433,   434,   435,
     486,   477,   478,   688,   657,   490,   658,   496,   501,   781,
     474,   436,   437,   438,   842,   842,   502,   845,   846,   772,
     773,   701,   978,   503,   504,   518,   653,   654,   655,   589,
     774,   858,   505,   506,   781,   507,   699,   861,   508,   979,
     986,    33,  1053,   781,   486,   653,   654,   655,   486,   592,
     592,   592,   565,   592,   592,   592,   592,   592,   840,   525,
    1004,  1005,   534,   827,   886,   887,   486,   529,   653,   654,
     655,   774,   530,   809,   653,   654,   655,   486,   531,   656,
     535,   536,  1025,   592,   846,   702,   981,   544,   545,   546,
     592,   689,   664,   547,   828,   827,   552,   825,   550,   829,
     830,   659,   569,   594,   837,  1039,   595,   593,   596,   597,
     599,   889,   890,   598,   600,   601,   653,   654,   655,   602,
     606,   607,   623,  1126,   701,   486,   982,   656,   626,   653,
     654,   655,  1026,   628,   642,   643,   810,   621,   622,   699,
    1069,  1069,  1073,   624,   726,   657,   710,   658,   631,   659,
     891,   728,   893,   846,   632,  1084,  1085,   727,   730,   731,
     658,   748,   749,   969,   970,   868,   869,   973,   750,   751,
     752,   753,   781,   754,   653,   654,   655,   906,   431,   432,
     433,   434,   435,  1061,   764,   810,   758,   755,   702,   869,
     537,   538,   539,   540,   541,   542,   759,   653,   654,   655,
    1003,   646,   647,   648,   649,   650,   644,   762,  1088,   934,
     761,   763,  1092,   769,   770,   777,   778,   592,  1069,  1069,
     646,   647,   648,   649,   650,   779,   788,   789,   729,   809,
    1145,  1146,   790,   827,   436,   437,   438,   964,   791,   952,
     792,   954,   955,   793,   795,   960,   961,  1121,   796,  1122,
    1123,  1124,   797,   966,   798,  1127,  1128,  1129,  1130,  1131,
     799,  1133,   800,   801,  1105,   439,   810,   802,   803,   806,
     653,   654,   655,   804,  1000,   805,   807,   811,   809,   460,
     461,   812,   813,  1006,   814,   815,   464,   465,   816,   810,
     817,   467,   468,   469,   818,   436,   437,   438,   819,   657,
     820,   658,  1012,  1013,   823,  1027,   821,  1094,   836,   822,
     831,   824,   849,   838,   839,   592,   592,   673,   844,  1032,
    1033,  1034,   850,   851,   847,  1038,   852,  1040,   854,   810,
     848,   810,   810,   810,   856,   857,   882,   855,   860,   876,
     873,   874,   875,   884,   877,   878,   879,   880,   881,   883,
     517,   888,   894,   895,   521,   896,  1051,   899,   923,   809,
     900,   897,  1056,  1057,   912,   907,   908,  1060,   911,   915,
    1144,   913,   914,   920,   905,   921,   922,   924,  1086,   925,
     926,   910,   809,   927,   928,   929,   956,   933,   930,   810,
     810,   946,   945,   931,   810,   810,    45,   932,   936,  1159,
     675,   676,   677,   678,   679,   680,   681,   682,   683,   684,
     685,   686,  1168,   937,   938,   947,   949,   948,   810,   950,
     951,  1111,   809,   957,   809,   809,   809,  1182,   484,   485,
     965,   962,   644,   645,   963,    46,    47,    48,    49,    50,
      51,    52,    53,  1193,   967,   885,   646,   647,   648,   649,
     650,   651,   652,   968,   971,   972,   944,   974,   675,   676,
     677,   678,   679,   680,   681,   682,   683,   684,   685,   686,
     975,   976,   977,   987,   869,   988,   989,  1150,   991,   992,
     996,  1036,   809,   809,  1153,  1001,  1155,   809,   809,   573,
     574,   575,   576,   577,   578,   579,   580,  1008,  1011,  1165,
    1017,  1018,  1019,  1022,  1023,   990,  1169,  1170,  1020,  1024,
    1035,   809,  1028,  1029,  1030,  1031,  1178,  1179,  1180,   484,
     485,  1183,  1184,   644,  1037,    -3,  1186,   653,   654,   655,
    1188,    45,  1041,  1047,  1042,  1192,  1043,   646,   647,   648,
     649,   650,   651,   652,  1049,  1044,  1045,  1046,  1048,   675,
     676,   677,   678,   679,   680,   681,   682,   683,   684,   685,
     686,   484,   485,   466,  1052,   644,   645,  1050,  1055,  1059,
      46,    47,    48,    49,    50,    51,    52,    53,  1063,  1002,
    1058,  1064,  1065,  1074,   651,   652,  1054,  1075,  1076,  1077,
    1079,   675,   676,   677,   678,   679,   680,   681,   682,   683,
     684,   685,   686,  1080,  1081,  1082,  1102,  1103,  1083,  1078,
    1087,  1089,  1090,  1091,  1097,  1095,   509,   510,   511,   512,
     513,   514,   515,   516,  1093,  1096,   519,   520,  1098,   522,
     523,   524,   571,   572,   553,   582,   583,   584,  1099,   586,
     587,   588,   554,  1100,  1101,   555,  1107,   556,   557,  1112,
    1108,  1114,  1115,  1116,  1109,   558,     4,     5,     6,     7,
       8,     9,    10,    11,    12,    13,    14,    15,  1110,  1113,
     559,   560,   561,   562,  1117,  1118,  1119,  1120,  1125,  1132,
    1139,  1137,    54,    55,  1138,  1141,  1140,  1142,  1143,   625,
    1149,  1147,  1154,   629,  1148,  1158,  1161,  1160,  1162,  1166,
    1167,  1171,  1163,  1172,  1173,  1164,   785,  1176,  1189,  1151,
    1152,  1175,  1177,  1181,  1156,  1157,  1185,  1187,  1190,    78,
      64,   737,  1191,   371,   898,   533,   472,   953,   786,   532,
     705,  1106,   843,   711,     0,     0,     0,   859,  1174,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   653,   654,   655,     0,     0,     0,     0,
       0,     0,   486,     0,   687,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   717,   718,   719,     0,
       0,     0,   657,     0,   658,     0,   688,     0,     0,   721,
     722,     0,   723,   724,   725,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    54,    55,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   756,     0,     0,     0,   760,     0,     0,     0,     0,
       0,     0,     0,     0,   653,   654,   655,     0,     0,     0,
       0,     0,     0,   486,     0,   687,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   657,     0,   658,     0,   688,     0,     0,
       0,     0,     0,     0,     0,     0,   653,   654,   655,     0,
       0,     0,     0,     0,     0,   486,     0,   687,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   657,     0,   658,     0,   688,
      79,    80,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    90,    91,    92,    93,    94,    95,    96,    97,    98,
      99,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     119,   120,   121,   122,   123,   124,   125,   126,   127,   128,
     129,   130,   131,   132,   133,   134,   135,   136,   137,   138,
     139,   140,   141,   142,   143,   144,   145,   146,   147,   148,
     149,   150,   151,   152,   153,   154,   155,   156,   157,   158,
     159,   160,   161,   162,   163,   164,   165,   166,   167,   168,
     169,   170,   171,   172,   173,   174,   175,   176,   177,   178,
     179,   180,   181,   182,   183,   184,   185,   186,   187,   188,
     189,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   202,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
     269,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
     289,   290,   291,   292,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,   315,   316,   317
};

static const yytype_int16 yycheck[] =
{
       6,   389,   546,   544,    10,     3,     4,   793,    14,   534,
     535,   552,     3,     4,     7,     8,   339,   546,   547,   327,
     545,   329,     7,   331,   332,   333,     3,     4,   336,     0,
       7,   642,   643,    26,    27,    33,    34,    35,    36,    37,
      38,    39,    40,    41,    42,    43,    44,   929,   393,   394,
       7,   396,   339,   398,   399,   427,     3,     4,     5,   535,
      66,   339,   534,   535,   536,     7,   546,     3,     4,     5,
       3,     4,   544,   545,     3,     4,   952,     6,   954,   955,
     552,   339,   470,  1030,     7,     8,   339,   612,   613,   883,
     966,   339,     3,     4,   664,   339,   330,     3,     4,     5,
       7,     8,   490,     3,     4,   928,   929,     7,     8,   343,
     830,   304,   305,     7,     8,   302,   303,   837,   339,   689,
     664,    21,    22,    23,    24,    25,     3,    21,    22,    23,
      24,    25,   455,   334,   335,   336,   612,   613,   338,   925,
     612,   613,   936,   937,   938,   689,   534,   535,   456,  1031,
     330,     3,     4,   337,   526,     7,     8,     8,   466,     7,
    1107,  1108,     8,   343,   337,   337,   350,     7,     7,    21,
      22,    23,    24,    25,    26,    27,     7,   350,   350,     3,
       4,   710,    21,    22,    23,    24,    25,    26,     3,     4,
       5,   663,    45,    46,    47,    48,    49,    50,    51,    52,
       7,   509,   510,   511,   512,   342,  1029,     7,  1031,   689,
     598,   519,   338,     7,   522,   323,   324,   325,   829,   830,
     308,   309,   310,   311,   612,   613,   837,    21,    22,    23,
      24,    25,   306,   307,   352,   543,     7,   355,   849,   850,
     358,   359,  1028,   551,   340,   856,   857,   788,   789,   793,
      21,    22,    23,    24,    25,   600,   339,   827,   566,   345,
     605,   606,   607,   792,   793,   610,   345,   796,   656,   350,
     351,   940,   941,     7,   582,   387,   388,   340,   390,   391,
     340,   753,   340,   395,  1107,   340,   340,   340,   400,   401,
     819,   340,    26,   345,    28,    29,    30,    31,    32,   687,
     329,   328,   345,   611,   345,   345,   614,   615,   616,     7,
       8,   345,   753,   793,   345,   345,   788,   789,   790,   791,
     345,   345,   345,    21,    22,    23,    24,    25,    26,    27,
     345,   626,   345,     7,     7,   328,   329,   330,   726,   337,
     728,   339,   338,   328,   329,   330,   337,     8,     6,   790,
     791,   328,   329,   330,   339,    28,    29,    30,    31,    32,
     337,     6,     6,   361,   357,   344,   359,   331,   331,   664,
     376,   328,   329,   330,   762,   763,   338,   765,   766,   326,
     327,   925,   923,   338,   332,   352,   328,   329,   330,   322,
     337,   779,   332,   332,   689,   332,   925,   785,   332,   924,
     929,   337,  1013,   698,   337,   328,   329,   330,   337,   797,
     798,   799,   339,   801,   802,   803,   804,   805,   329,   345,
     949,   950,   338,   895,   812,   813,   337,   345,   328,   329,
     330,   337,   351,   728,   328,   329,   330,   337,   351,   339,
     338,   338,   971,   831,   832,   925,   926,   338,   338,   338,
     838,   923,   924,   338,   895,   927,   338,   752,   345,   754,
     755,   361,   345,   338,   759,   994,   340,   473,   339,   339,
     330,   816,   817,   341,   338,   338,   328,   329,   330,   338,
     338,   338,   355,  1094,  1028,   337,   927,   339,   353,   328,
     329,   330,   972,   355,   328,   328,   884,   352,   352,  1028,
    1029,  1030,  1031,   348,   345,   357,   338,   359,   357,   361,
     818,   338,   820,   901,   357,  1044,  1045,   345,     6,     6,
     359,   338,   338,   911,   912,   319,   320,   915,   338,   338,
     353,   353,   827,   353,   328,   329,   330,   832,    28,    29,
      30,    31,    32,  1023,   345,   933,   338,   353,  1028,   320,
     312,   313,   314,   315,   316,   317,   353,   328,   329,   330,
     948,    21,    22,    23,    24,    25,     7,   353,  1048,   877,
     338,   353,  1052,   351,   351,   351,   351,   965,  1107,  1108,
      21,    22,    23,    24,    25,   339,   338,   338,   594,   884,
    1119,  1120,   338,  1065,   328,   329,   330,   905,   338,   894,
     338,   896,   897,   338,   340,   900,   901,  1087,   338,  1089,
    1090,  1091,   345,   908,   345,  1095,  1096,  1097,  1098,  1099,
     345,  1101,   338,   345,  1065,   359,  1014,   345,   345,   726,
     328,   329,   330,   345,   942,   345,   356,   338,   933,   347,
     348,   341,   341,   951,   338,   330,   354,   355,   338,  1037,
     338,   359,   360,   361,   338,   328,   329,   330,   338,   357,
     338,   359,   957,   958,   355,   973,   352,  1055,   355,   352,
     345,   348,   328,   345,   355,  1063,  1064,  1065,   333,   987,
     988,   989,   328,   340,   360,   993,   340,   995,   340,  1077,
     360,  1079,  1080,  1081,   328,   328,   345,   340,   340,   352,
     797,   798,   799,   338,   801,   802,   803,   804,   805,   345,
     418,     6,   353,   353,   422,   353,  1011,   354,   338,  1014,
     350,   353,  1017,  1018,   350,   354,   353,  1022,   353,   345,
    1118,   354,   354,   340,   831,   340,   340,   338,  1046,   338,
     338,   838,  1037,   338,   338,   338,   354,   353,   345,  1137,
    1138,   340,   338,   345,  1142,  1143,     6,   345,   345,  1147,
      33,    34,    35,    36,    37,    38,    39,    40,    41,    42,
      43,    44,  1160,   345,   345,   340,   338,   341,  1166,   338,
     338,  1076,  1077,   338,  1079,  1080,  1081,  1175,     3,     4,
     338,   354,     7,     8,   354,    45,    46,    47,    48,    49,
      50,    51,    52,  1191,   354,   811,    21,    22,    23,    24,
      25,    26,    27,   352,   338,   338,   884,   360,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
     360,   360,   360,   355,   320,   352,   352,  1132,   338,   352,
     345,   352,  1137,  1138,  1139,   357,  1141,  1142,  1143,   294,
     295,   296,   297,   298,   299,   300,   301,   354,   338,  1154,
     338,   338,   338,   338,   353,   933,  1161,  1162,   965,   354,
     354,  1166,   338,   338,   338,   338,  1171,  1172,  1173,     3,
       4,  1176,  1177,     7,   353,     0,  1181,   328,   329,   330,
    1185,     6,   321,   354,   353,  1190,   338,    21,    22,    23,
      24,    25,    26,    27,   354,   338,   338,   338,   338,    33,
      34,    35,    36,    37,    38,    39,    40,    41,    42,    43,
      44,     3,     4,   357,   338,     7,     8,   354,   351,   354,
      45,    46,    47,    48,    49,    50,    51,    52,   338,   945,
     352,   338,   338,   338,    26,    27,  1014,   338,   338,   353,
     338,    33,    34,    35,    36,    37,    38,    39,    40,    41,
      42,    43,    44,   338,   338,   329,  1063,  1064,     6,  1037,
     338,   338,   338,   338,   353,   338,   410,   411,   412,   413,
     414,   415,   416,   417,   340,   338,   420,   421,   338,   423,
     424,   425,   460,   461,   310,   463,   464,   465,   338,   467,
     468,   469,   318,   354,   338,   321,   338,   323,   324,  1077,
     338,  1079,  1080,  1081,   355,   331,     9,    10,    11,    12,
      13,    14,    15,    16,    17,    18,    19,    20,   352,   354,
     346,   347,   348,   349,   354,   341,   338,   338,   351,   338,
     338,   353,   292,   293,   353,   338,   354,   338,   338,   517,
     354,   351,   338,   521,   351,   338,   338,   351,   338,   338,
       6,   338,   354,   338,   338,   354,   339,   338,     6,  1137,
    1138,   341,   338,   338,  1142,  1143,   338,   338,   338,    56,
      17,   602,   341,    58,   825,   442,   374,   895,   688,   441,
     547,  1065,   763,   565,    -1,    -1,    -1,   779,  1166,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   328,   329,   330,    -1,    -1,    -1,    -1,
      -1,    -1,   337,    -1,   339,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   570,   571,   572,    -1,
      -1,    -1,   357,    -1,   359,    -1,   361,    -1,    -1,   583,
     584,    -1,   586,   587,   588,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   292,   293,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   625,    -1,    -1,    -1,   629,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   328,   329,   330,    -1,    -1,    -1,
      -1,    -1,    -1,   337,    -1,   339,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   357,    -1,   359,    -1,   361,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   328,   329,   330,    -1,
      -1,    -1,    -1,    -1,    -1,   337,    -1,   339,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   357,    -1,   359,    -1,   361,
      53,    54,    55,    56,    57,    58,    59,    60,    61,    62,
      63,    64,    65,    66,    67,    68,    69,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    90,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
     103,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   116,   117,   118,   119,   120,   121,   122,
     123,   124,   125,   126,   127,   128,   129,   130,   131,   132,
     133,   134,   135,   136,   137,   138,   139,   140,   141,   142,
     143,   144,   145,   146,   147,   148,   149,   150,   151,   152,
     153,   154,   155,   156,   157,   158,   159,   160,   161,   162,
     163,   164,   165,   166,   167,   168,   169,   170,   171,   172,
     173,   174,   175,   176,   177,   178,   179,   180,   181,   182,
     183,   184,   185,   186,   187,   188,   189,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   202,
     203,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,   269,   270,   271,   272,
     273,   274,   275,   276,   277,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,   289,   290,   291
};

/* YYSTOS[STATE-NUM] -- The symbol kind of the accessing symbol of
   state STATE-NUM.  */
static const yytype_int16 yystos[] =
{
       0,   363,   364,     0,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,   365,   366,   368,   369,
     371,   373,   374,   375,   376,   377,   378,   379,   380,   381,
       3,     4,     5,   337,   367,   339,   367,   339,   339,   339,
     367,   339,   339,   339,   367,     6,    45,    46,    47,    48,
      49,    50,    51,    52,   292,   293,   382,   383,   384,   385,
     386,   515,   518,   519,   365,     3,   338,     8,   372,     7,
       7,     8,     8,     7,     7,     7,   342,     7,   383,    53,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    72,    73,
      74,    75,    76,    77,    78,    79,    80,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    90,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,   119,   120,   121,   122,   123,
     124,   125,   126,   127,   128,   129,   130,   131,   132,   133,
     134,   135,   136,   137,   138,   139,   140,   141,   142,   143,
     144,   145,   146,   147,   148,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   159,   160,   161,   162,   163,
     164,   165,   166,   167,   168,   169,   170,   171,   172,   173,
     174,   175,   176,   177,   178,   179,   180,   181,   182,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
     204,   205,   206,   207,   208,   209,   210,   211,   212,   213,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   390,   407,
     409,   411,   413,   415,   417,   419,   421,   422,   423,   424,
     426,   429,   430,   431,   432,   433,   434,   435,   436,   437,
     444,   455,   463,   469,   471,   473,   475,   476,   477,   478,
     479,   480,   481,   482,   483,   484,   485,   487,   488,   492,
     493,   494,   495,   496,   498,   500,   503,   504,   507,   510,
     513,   385,   338,   516,   517,   367,   340,   339,   370,   340,
     340,   340,   340,   340,   340,   340,   391,   392,   393,   345,
     395,   396,   397,   398,   399,   400,   401,   345,   402,   403,
     404,   405,   345,   329,   328,   345,   345,   345,   345,   345,
     456,   457,   459,   458,   464,   465,   467,   466,   470,   474,
     460,   468,   472,   461,   501,   502,   508,   509,   514,     7,
      26,    28,    29,    30,    31,    32,   328,   329,   330,   359,
     521,   523,   524,   525,   537,   525,   345,   525,   525,   525,
     525,   345,   427,   525,   345,   438,   439,   439,   345,   445,
     445,   445,   345,   447,   445,   445,   447,   445,   445,   445,
     345,     7,   516,   338,   367,     8,     6,     6,     6,   330,
     343,   387,   387,   387,     3,     4,   337,   543,   387,   387,
     344,   389,   389,   389,   387,   389,   331,   389,   389,   387,
     387,   331,   338,   338,   332,   332,   332,   332,   332,   447,
     447,   447,   447,   447,   447,   447,   447,   445,   352,   447,
     447,   445,   447,   447,   447,   345,   505,   506,   506,   345,
     351,   351,   524,   521,   338,   338,   338,   312,   313,   314,
     315,   316,   317,   425,   338,   338,   338,   338,   304,   305,
     345,   428,   338,   310,   318,   321,   323,   324,   331,   346,
     347,   348,   349,   439,   525,   339,   442,   302,   303,   345,
     446,   446,   446,   294,   295,   296,   297,   298,   299,   300,
     301,   545,   446,   446,   446,   525,   446,   446,   446,   322,
     451,   497,   543,   367,   338,   340,   339,   339,   341,   330,
     338,   338,   338,     3,     4,   394,   338,   338,     6,   543,
     406,   410,   412,   414,   416,   418,   420,   525,   525,   525,
     525,   352,   352,   355,   348,   446,   353,   525,   355,   446,
     525,   357,   357,   352,   355,   358,   359,   506,   334,   335,
     336,   512,   328,   328,     7,     8,    21,    22,    23,    24,
      25,    26,    27,   328,   329,   330,   339,   357,   359,   361,
     408,   520,   522,   526,   527,   528,   530,   531,   532,   536,
     538,   539,   540,   543,   408,    33,    34,    35,    36,    37,
      38,    39,    40,    41,    42,    43,    44,   339,   361,   527,
     532,   533,   541,   542,   543,   525,   533,   532,   527,   528,
     534,   539,   541,   528,   529,   536,   306,   307,   525,   533,
     338,   545,   525,   308,   309,   310,   311,   447,   447,   447,
     525,   447,   447,   447,   447,   447,   345,   345,   338,   367,
       6,     6,   543,   389,   330,   343,   388,   388,   389,   389,
     389,   389,   525,   408,   408,   525,   525,   525,   338,   338,
     338,   338,   353,   353,   353,   353,   447,   520,   338,   353,
     447,   338,   353,   353,   345,   337,   350,   535,   535,   351,
     351,     5,   326,   327,   337,   543,   544,   351,   351,   339,
     527,   520,   522,   539,   543,   339,   542,   541,   338,   338,
     338,   338,   338,   338,   528,   340,   338,   345,   345,   345,
     338,   345,   345,   345,   345,   345,   451,   356,   491,   520,
     543,   338,   341,   341,   338,   330,   338,   338,   338,   338,
     338,   352,   352,   355,   348,   520,   454,   527,   531,   520,
     520,   345,   350,   448,   449,   535,   355,   520,   345,   355,
     329,   499,   543,   499,   333,   543,   543,   360,   360,   328,
     328,   340,   340,     5,   340,   340,   328,   328,   543,   544,
     340,   543,   533,   533,   531,   531,   528,   534,   319,   320,
     440,   441,   528,   451,   451,   451,   352,   451,   451,   451,
     451,   451,   345,   345,   338,   367,   543,   543,     6,   389,
     389,   525,   528,   525,   353,   353,   353,   353,   448,   354,
     350,   350,   450,   535,   450,   451,   520,   354,   353,   450,
     451,   353,   350,   354,   354,   345,   535,   535,   535,   535,
     340,   340,   340,   338,   338,   338,   338,   338,   338,   338,
     345,   345,   345,   353,   525,   486,   345,   345,   345,   323,
     324,   325,   490,   490,   491,   338,   340,   340,   341,   338,
     338,   338,   520,   454,   520,   520,   354,   338,   339,   453,
     520,   520,   354,   354,   525,   338,   520,   354,   352,   543,
     543,   338,   338,   543,   360,   360,   360,   360,   533,   532,
     534,   541,   531,   441,   440,   441,   528,   355,   352,   352,
     491,   338,   352,   490,   490,   490,   345,   489,   489,   489,
     525,   357,   367,   543,   528,   528,   525,   449,   354,   449,
     449,   338,   520,   520,   350,   351,   452,   338,   338,   338,
     451,   449,   338,   353,   354,   528,   541,   525,   338,   338,
     338,   338,   525,   525,   525,   354,   352,   353,   525,   528,
     525,   321,   353,   338,   338,   338,   338,   354,   338,   354,
     354,   520,   338,   535,   491,   351,   520,   520,   352,   354,
     520,   541,   462,   338,   338,   338,   534,   441,   443,   528,
     443,   440,   441,   528,   338,   338,   338,   353,   491,   338,
     338,   338,   329,     6,   528,   528,   525,   338,   541,   338,
     338,   338,   541,   340,   543,   338,   338,   353,   338,   338,
     354,   338,   451,   451,   511,   531,   540,   338,   338,   355,
     352,   520,   491,   354,   491,   491,   491,   354,   341,   338,
     338,   541,   541,   541,   541,   351,   535,   541,   541,   541,
     541,   541,   338,   541,   441,   443,   443,   353,   353,   338,
     354,   338,   338,   338,   543,   528,   528,   351,   351,   354,
     520,   491,   491,   520,   338,   520,   491,   491,   338,   543,
     351,   338,   338,   354,   354,   520,   338,     6,   543,   520,
     520,   338,   338,   338,   491,   341,   338,   338,   520,   520,
     520,   338,   543,   520,   520,   338,   520,   338,   520,     6,
     338,   341,   520,   543
};

/* YYR1[RULE-NUM] -- Symbol kind of the left-hand side of rule RULE-NUM.  */
static const yytype_int16 yyr1[] =
{
       0,   362,   364,   363,   365,   365,   366,   366,   366,   366,
     366,   366,   366,   366,   366,   366,   366,   366,   367,   367,
     367,   367,   368,   369,   370,   370,   372,   371,   373,   374,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   382,
     382,   382,   382,   382,   382,   382,   383,   383,   384,   384,
     385,   385,   385,   385,   385,   385,   385,   385,   385,   385,
     385,   386,   387,   387,   388,   388,   389,   389,   390,   391,
     390,   392,   390,   393,   390,   394,   390,   395,   390,   396,
     390,   397,   390,   398,   390,   399,   390,   390,   400,   390,
     390,   390,   390,   390,   390,   390,   401,   390,   390,   390,
     390,   390,   402,   390,   390,   403,   390,   390,   404,   390,
     405,   390,   390,   406,   390,   407,   407,   408,   408,   410,
     409,   412,   411,   414,   413,   416,   415,   418,   417,   420,
     419,   421,   421,   421,   421,   421,   421,   421,   421,   422,
     422,   422,   422,   422,   422,   422,   422,   422,   422,   422,
     422,   422,   422,   423,   423,   423,   423,   423,   423,   424,
     424,   424,   424,   424,   424,   424,   424,   424,   424,   424,
     424,   424,   424,   424,   424,   424,   424,   424,   424,   424,
     424,   424,   424,   424,   424,   424,   425,   425,   425,   425,
     425,   425,   426,   426,   426,   427,   427,   428,   428,   429,
     429,   429,   429,   429,   429,   429,   429,   429,   429,   429,
     429,   429,   429,   429,   429,   430,   430,   430,   430,   430,
     431,   431,   432,   432,   433,   433,   433,   433,   434,   434,
     434,   434,   434,   434,   434,   434,   434,   434,   435,   436,
     436,   437,   437,   437,   437,   437,   437,   437,   437,   437,
     437,   437,   437,   437,   437,   437,   437,   437,   437,   437,
     437,   437,   437,   437,   437,   437,   437,   437,   437,   437,
     437,   437,   438,   438,   438,   438,   438,   438,   438,   438,
     438,   438,   439,   439,   440,   441,   442,   443,   444,   444,
     444,   444,   444,   444,   444,   444,   444,   444,   444,   444,
     444,   444,   444,   444,   444,   444,   444,   445,   445,   446,
     446,   446,   446,   447,   448,   449,   449,   450,   450,   451,
     452,   452,   453,   453,   454,   456,   455,   457,   455,   458,
     455,   459,   455,   460,   455,   461,   462,   455,   464,   463,
     465,   463,   466,   463,   467,   463,   468,   463,   470,   469,
     472,   471,   474,   473,   475,   475,   475,   475,   475,   475,
     475,   475,   475,   475,   475,   476,   476,   476,   476,   476,
     476,   476,   476,   476,   476,   476,   477,   477,   477,   477,
     477,   477,   477,   477,   477,   477,   477,   478,   479,   480,
     481,   481,   481,   482,   483,   484,   485,   485,   486,   485,
     487,   487,   487,   488,   489,   489,   490,   490,   490,   491,
     491,   492,   493,   493,   493,   493,   493,   493,   493,   493,
     493,   493,   493,   493,   494,   495,   495,   495,   496,   497,
     497,   498,   499,   499,   499,   501,   500,   502,   500,   503,
     503,   503,   504,   504,   504,   504,   504,   504,   504,   504,
     504,   504,   504,   504,   505,   505,   505,   505,   506,   506,
     508,   507,   509,   507,   510,   510,   510,   511,   511,   512,
     512,   512,   513,   513,   513,   513,   513,   513,   513,   514,
     513,   515,   516,   516,   517,   518,   519,   520,   520,   520,
     520,   521,   521,   521,   521,   522,   523,   523,   523,   523,
     523,   524,   524,   525,   525,   526,   526,   526,   526,   526,
     527,   527,   528,   528,   529,   529,   530,   530,   531,   531,
     532,   532,   532,   533,   533,   533,   534,   534,   534,   535,
     535,   535,   536,   536,   537,   537,   538,   538,   539,   539,
     540,   540,   540,   540,   540,   540,   540,   541,   541,   541,
     541,   541,   542,   542,   542,   542,   542,   542,   542,   542,
     542,   542,   542,   542,   543,   543,   543,   543,   544,   544,
     545,   545,   545,   545,   545,   545,   545,   545
};

/* YYR2[RULE-NUM] -- Number of symbols on the right-hand side of rule RULE-NUM.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     0,     3,     0,     2,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       2,     1,     6,    11,     3,     0,     0,     4,     4,     4,
       4,     4,     2,     2,     1,    10,    10,    23,     1,     1,
       1,     1,     1,     1,     1,     1,     0,     2,     2,     1,
       2,     2,     2,     2,     2,     2,     2,     2,     1,     1,
       1,     2,     2,     1,     2,     1,     2,     2,     1,     0,
       5,     0,     7,     0,     7,     0,     5,     0,     5,     0,
       5,     0,     3,     0,     3,     0,     3,     1,     0,     3,
       1,     1,     1,     1,     1,     1,     0,     3,     1,     1,
       1,     1,     0,     3,     1,     0,     3,     1,     0,     3,
       0,     3,     1,     0,     5,     3,     3,     1,     1,     0,
       5,     0,     5,     0,     5,     0,    11,     0,    13,     0,
      13,     1,     1,     1,     1,     1,     1,     4,     4,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     4,     8,     6,     2,     2,     2,     2,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     8,     8,     8,    10,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     4,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     0,     2,     1,     1,     3,     1,     5,    10,
      12,    12,    12,    10,    10,     8,    10,    10,    10,     8,
       8,     6,     8,     6,     6,     4,     1,     2,     2,     2,
       2,     2,     2,     2,     1,     1,     2,     1,     2,     1,
       7,     2,     7,     2,     3,     0,    12,     0,    11,     0,
      12,     0,    12,     0,    12,     0,     0,    12,     0,    12,
       0,    11,     0,    12,     0,    12,     0,    12,     0,    17,
       0,    17,     0,     9,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,    20,    13,    16,
       1,     1,     1,     1,     1,     1,     9,    16,     0,    17,
       1,     1,     1,     3,     0,     2,     2,     2,     2,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,    11,    13,    13,     1,     6,
       9,     7,     1,     1,     3,     0,    11,     0,    11,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     2,     2,     2,     2,     0,     2,
       0,     3,     0,     3,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     0,
      11,     1,     1,     2,     2,     2,     2,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     2,     1,     2,     1,     1,     1,     1,     1,
       1,     2,     1,     2,     1,     1,     1,     2,     1,     1,
       1,     1,     2,     1,     2,     1,     1,     1,     1,     0,
       2,     2,     5,     5,     5,     5,     5,     5,     1,     1,
       1,     3,     3,     4,     4,     3,     3,     1,     3,     1,
       4,     2,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     2,     1,     2,     1,     2,
       1,     1,     1,     1,     1,     1,     1,     1
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab
#define YYNOMEM         goto yyexhaustedlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use YYerror or YYUNDEF. */
#define YYERRCODE YYUNDEF


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)




# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  FILE *yyoutput = yyo;
  YY_USE (yyoutput);
  if (!yyvaluep)
    return;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  yy_symbol_value_print (yyo, yykind, yyvaluep);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp,
                 int yyrule)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)]);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


/* Context of a parse error.  */
typedef struct
{
  yy_state_t *yyssp;
  yysymbol_kind_t yytoken;
} yypcontext_t;

/* Put in YYARG at most YYARGN of the expected tokens given the
   current YYCTX, and return the number of tokens stored in YYARG.  If
   YYARG is null, return the number of expected tokens (guaranteed to
   be less than YYNTOKENS).  Return YYENOMEM on memory exhaustion.
   Return 0 if there are more than YYARGN expected tokens, yet fill
   YYARG up to YYARGN. */
static int
yypcontext_expected_tokens (const yypcontext_t *yyctx,
                            yysymbol_kind_t yyarg[], int yyargn)
{
  /* Actual size of YYARG. */
  int yycount = 0;
  int yyn = yypact[+*yyctx->yyssp];
  if (!yypact_value_is_default (yyn))
    {
      /* Start YYX at -YYN if negative to avoid negative indexes in
         YYCHECK.  In other words, skip the first -YYN actions for
         this state because they are default actions.  */
      int yyxbegin = yyn < 0 ? -yyn : 0;
      /* Stay within bounds of both yycheck and yytname.  */
      int yychecklim = YYLAST - yyn + 1;
      int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
      int yyx;
      for (yyx = yyxbegin; yyx < yyxend; ++yyx)
        if (yycheck[yyx + yyn] == yyx && yyx != YYSYMBOL_YYerror
            && !yytable_value_is_error (yytable[yyx + yyn]))
          {
            if (!yyarg)
              ++yycount;
            else if (yycount == yyargn)
              return 0;
            else
              yyarg[yycount++] = YY_CAST (yysymbol_kind_t, yyx);
          }
    }
  if (yyarg && yycount == 0 && 0 < yyargn)
    yyarg[0] = YYSYMBOL_YYEMPTY;
  return yycount;
}




#ifndef yystrlen
# if defined __GLIBC__ && defined _STRING_H
#  define yystrlen(S) (YY_CAST (YYPTRDIFF_T, strlen (S)))
# else
/* Return the length of YYSTR.  */
static YYPTRDIFF_T
yystrlen (const char *yystr)
{
  YYPTRDIFF_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
# endif
#endif

#ifndef yystpcpy
# if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#  define yystpcpy stpcpy
# else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
# endif
#endif

#ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYPTRDIFF_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYPTRDIFF_T yyn = 0;
      char const *yyp = yystr;
      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            else
              goto append;

          append:
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (yyres)
    return yystpcpy (yyres, yystr) - yyres;
  else
    return yystrlen (yystr);
}
#endif


static int
yy_syntax_error_arguments (const yypcontext_t *yyctx,
                           yysymbol_kind_t yyarg[], int yyargn)
{
  /* Actual size of YYARG. */
  int yycount = 0;
  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yyctx->yytoken != YYSYMBOL_YYEMPTY)
    {
      int yyn;
      if (yyarg)
        yyarg[yycount] = yyctx->yytoken;
      ++yycount;
      yyn = yypcontext_expected_tokens (yyctx,
                                        yyarg ? yyarg + 1 : yyarg, yyargn - 1);
      if (yyn == YYENOMEM)
        return YYENOMEM;
      else
        yycount += yyn;
    }
  return yycount;
}

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return -1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return YYENOMEM if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYPTRDIFF_T *yymsg_alloc, char **yymsg,
                const yypcontext_t *yyctx)
{
  enum { YYARGS_MAX = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat: reported tokens (one for the "unexpected",
     one per "expected"). */
  yysymbol_kind_t yyarg[YYARGS_MAX];
  /* Cumulated lengths of YYARG.  */
  YYPTRDIFF_T yysize = 0;

  /* Actual size of YYARG. */
  int yycount = yy_syntax_error_arguments (yyctx, yyarg, YYARGS_MAX);
  if (yycount == YYENOMEM)
    return YYENOMEM;

  switch (yycount)
    {
#define YYCASE_(N, S)                       \
      case N:                               \
        yyformat = S;                       \
        break
    default: /* Avoid compiler warnings. */
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
#undef YYCASE_
    }

  /* Compute error message size.  Don't count the "%s"s, but reserve
     room for the terminator.  */
  yysize = yystrlen (yyformat) - 2 * yycount + 1;
  {
    int yyi;
    for (yyi = 0; yyi < yycount; ++yyi)
      {
        YYPTRDIFF_T yysize1
          = yysize + yytnamerr (YY_NULLPTR, yytname[yyarg[yyi]]);
        if (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM)
          yysize = yysize1;
        else
          return YYENOMEM;
      }
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return -1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yytname[yyarg[yyi++]]);
          yyformat += 2;
        }
      else
        {
          ++yyp;
          ++yyformat;
        }
  }
  return 0;
}


/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep)
{
  YY_USE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/* Lookahead token kind.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;




/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    yy_state_fast_t yystate = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus = 0;

    /* Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize = YYINITDEPTH;

    /* The state stack: array, bottom, top.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss = yyssa;
    yy_state_t *yyssp = yyss;

    /* The semantic value stack: array, bottom, top.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs = yyvsa;
    YYSTYPE *yyvsp = yyvs;

  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead symbol kind.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYPTRDIFF_T yymsg_alloc = sizeof yymsgbuf;

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = YYEMPTY; /* Cause a token to be read.  */

  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    YYNOMEM;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        YYNOMEM;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          YYNOMEM;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */


  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = YYEOF;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == YYerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = YYUNDEF;
      yytoken = YYSYMBOL_YYerror;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 2: /* $@1: %empty  */
#line 721 "../src/freedreno/ir3/ir3_parser.y"
                   { new_shader(); }
#line 3163 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 18: /* const_val: T_FLOAT  */
#line 739 "../src/freedreno/ir3/ir3_parser.y"
                             { (yyval.unum) = fui((yyvsp[0].flt)); }
#line 3169 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 19: /* const_val: T_INT  */
#line 740 "../src/freedreno/ir3/ir3_parser.y"
                             { (yyval.unum) = (yyvsp[0].num);      }
#line 3175 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 20: /* const_val: '-' T_INT  */
#line 741 "../src/freedreno/ir3/ir3_parser.y"
                             { (yyval.unum) = -(yyvsp[0].num);     }
#line 3181 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 21: /* const_val: T_HEX  */
#line 742 "../src/freedreno/ir3/ir3_parser.y"
                             { (yyval.unum) = (yyvsp[0].unum);      }
#line 3187 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 22: /* localsize_header: T_A_LOCALSIZE const_val ',' const_val ',' const_val  */
#line 744 "../src/freedreno/ir3/ir3_parser.y"
                                                                       {
                       variant->local_size[0] = (yyvsp[-4].unum);
                       variant->local_size[1] = (yyvsp[-2].unum);
                       variant->local_size[2] = (yyvsp[0].unum);
}
#line 3197 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 23: /* const_header: T_A_CONST '(' T_CONSTANT ')' const_val ',' const_val ',' const_val ',' const_val  */
#line 750 "../src/freedreno/ir3/ir3_parser.y"
                                                                                                    {
                       add_const((yyvsp[-8].num), (yyvsp[-6].unum), (yyvsp[-4].unum), (yyvsp[-2].unum), (yyvsp[0].unum));
}
#line 3205 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 24: /* buf_header_addr_reg: '(' T_CONSTANT ')'  */
#line 755 "../src/freedreno/ir3/ir3_parser.y"
                                      {
                       assert(((yyvsp[-1].num) & 0x1) == 0);  /* half-reg not allowed */
                       unsigned reg = (yyvsp[-1].num) >> 1;

                       info->buf_addr_regs[info->num_bufs - 1] = reg;
                       /* reserve space in immediates for the actual value to be plugged in later: */
                       add_const((yyvsp[-1].num), 0, 0, 0, 0);
}
#line 3218 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 26: /* $@2: %empty  */
#line 765 "../src/freedreno/ir3/ir3_parser.y"
                                     {
                       int idx = info->num_bufs++;
                       assert(idx < MAX_BUFS);
                       info->buf_sizes[idx] = (yyvsp[0].unum);
}
#line 3228 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 28: /* invocationid_header: T_A_INVOCATIONID '(' T_REGISTER ')'  */
#line 771 "../src/freedreno/ir3/ir3_parser.y"
                                                         {
                       assert(((yyvsp[-1].num) & 0x1) == 0);  /* half-reg not allowed */
                       unsigned reg = (yyvsp[-1].num) >> 1;
                       add_sysval(reg, 0x7, SYSTEM_VALUE_LOCAL_INVOCATION_ID);
}
#line 3238 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 29: /* wgid_header: T_A_WGID '(' T_REGISTER ')'  */
#line 777 "../src/freedreno/ir3/ir3_parser.y"
                                               {
                       assert(((yyvsp[-1].num) & 0x1) == 0);  /* half-reg not allowed */
                       unsigned reg = (yyvsp[-1].num) >> 1;
                       assert(variant->compiler->gen >= 5);
                       assert(reg >= regid(48, 0)); /* must be a high reg */
                       add_sysval(reg, 0x7, SYSTEM_VALUE_WORKGROUP_ID);
}
#line 3250 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 30: /* wgid_header: T_A_WGID '(' T_CONSTANT ')'  */
#line 784 "../src/freedreno/ir3/ir3_parser.y"
                                               {
                       assert(((yyvsp[-1].num) & 0x1) == 0);  /* half-reg not allowed */
                       unsigned reg = (yyvsp[-1].num) >> 1;
                       assert(variant->compiler->gen < 5);
                       info->wgid = reg;
}
#line 3261 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 31: /* numwg_header: T_A_NUMWG '(' T_CONSTANT ')'  */
#line 791 "../src/freedreno/ir3/ir3_parser.y"
                                                {
                       assert(((yyvsp[-1].num) & 0x1) == 0);  /* half-reg not allowed */
                       unsigned reg = (yyvsp[-1].num) >> 1;
                       info->numwg = reg;
                       /* reserve space in immediates for the actual value to be plugged in later: */
                       if (variant->compiler->gen >= 5)
                          add_const((yyvsp[-1].num), 0, 0, 0, 0);
}
#line 3274 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 32: /* branchstack_header: T_A_BRANCHSTACK const_val  */
#line 800 "../src/freedreno/ir3/ir3_parser.y"
                                              { variant->branchstack = (yyvsp[0].unum); }
#line 3280 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 33: /* pvtmem_header: T_A_PVTMEM const_val  */
#line 802 "../src/freedreno/ir3/ir3_parser.y"
                                    { variant->pvtmem_size = (yyvsp[0].unum); }
#line 3286 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 34: /* earlypreamble_header: T_A_EARLYPREAMBLE  */
#line 804 "../src/freedreno/ir3/ir3_parser.y"
                                        { info->early_preamble = 1; }
#line 3292 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 35: /* in_header: T_A_IN '(' T_REGISTER ')' T_IDENTIFIER '(' T_IDENTIFIER '=' integer ')'  */
#line 807 "../src/freedreno/ir3/ir3_parser.y"
                                                                                           { }
#line 3298 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 36: /* out_header: T_A_OUT '(' T_REGISTER ')' T_IDENTIFIER '(' T_IDENTIFIER '=' integer ')'  */
#line 809 "../src/freedreno/ir3/ir3_parser.y"
                                                                                            { }
#line 3304 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 37: /* tex_header: T_A_TEX '(' T_REGISTER ')' T_IDENTIFIER '=' integer ',' T_IDENTIFIER '=' integer ',' T_IDENTIFIER '=' integer ',' T_IDENTIFIER '=' integer ',' T_IDENTIFIER '=' integer  */
#line 816 "../src/freedreno/ir3/ir3_parser.y"
                                                              { }
#line 3310 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 38: /* iflag: T_SY  */
#line 818 "../src/freedreno/ir3/ir3_parser.y"
                          { iflags.flags |= IR3_INSTR_SY; }
#line 3316 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 39: /* iflag: T_SS  */
#line 819 "../src/freedreno/ir3/ir3_parser.y"
                          { iflags.flags |= IR3_INSTR_SS; }
#line 3322 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 40: /* iflag: T_JP  */
#line 820 "../src/freedreno/ir3/ir3_parser.y"
                          { iflags.flags |= IR3_INSTR_JP; }
#line 3328 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 41: /* iflag: T_EQ_FLAG  */
#line 821 "../src/freedreno/ir3/ir3_parser.y"
                             { iflags.flags |= IR3_INSTR_EQ; }
#line 3334 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 42: /* iflag: T_SAT  */
#line 822 "../src/freedreno/ir3/ir3_parser.y"
                          { iflags.flags |= IR3_INSTR_SAT; }
#line 3340 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 43: /* iflag: T_RPT  */
#line 823 "../src/freedreno/ir3/ir3_parser.y"
                          { iflags.repeat = (yyvsp[0].num); }
#line 3346 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 44: /* iflag: T_UL  */
#line 824 "../src/freedreno/ir3/ir3_parser.y"
                          { iflags.flags |= IR3_INSTR_UL; }
#line 3352 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 45: /* iflag: T_NOP  */
#line 825 "../src/freedreno/ir3/ir3_parser.y"
                          { iflags.nop = (yyvsp[0].tok); }
#line 3358 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 55: /* instr: iflags cat5_instr  */
#line 838 "../src/freedreno/ir3/ir3_parser.y"
                                     { fixup_cat5_s2en(); }
#line 3364 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 61: /* label: T_IDENTIFIER ':'  */
#line 845 "../src/freedreno/ir3/ir3_parser.y"
                                    { new_label((yyvsp[-1].str)); }
#line 3370 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 62: /* cat0_src1: '!' T_P0  */
#line 847 "../src/freedreno/ir3/ir3_parser.y"
                                   { instr->cat0.inv1 = true; instr->cat0.comp1 = (yyvsp[0].num) >> 1; }
#line 3376 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 63: /* cat0_src1: T_P0  */
#line 848 "../src/freedreno/ir3/ir3_parser.y"
                                   { instr->cat0.comp1 = (yyvsp[0].num) >> 1; }
#line 3382 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 64: /* cat0_src2: '!' T_P0  */
#line 850 "../src/freedreno/ir3/ir3_parser.y"
                                   { instr->cat0.inv2 = true; instr->cat0.comp2 = (yyvsp[0].num) >> 1; }
#line 3388 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 65: /* cat0_src2: T_P0  */
#line 851 "../src/freedreno/ir3/ir3_parser.y"
                                   { instr->cat0.comp2 = (yyvsp[0].num) >> 1; }
#line 3394 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 66: /* cat0_immed: '#' integer  */
#line 853 "../src/freedreno/ir3/ir3_parser.y"
                                   { instr->cat0.immed = (yyvsp[0].num); }
#line 3400 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 67: /* cat0_immed: '#' T_IDENTIFIER  */
#line 854 "../src/freedreno/ir3/ir3_parser.y"
                                    { ralloc_steal(instr, (void *)(yyvsp[0].str)); instr->cat0.target_label = (yyvsp[0].str); }
#line 3406 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 68: /* cat0_instr: T_OP_NOP  */
#line 856 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_NOP); }
#line 3412 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 69: /* $@3: %empty  */
#line 857 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_B)->cat0.brtype = BRANCH_PLAIN; }
#line 3418 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 71: /* $@4: %empty  */
#line 858 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_B)->cat0.brtype = BRANCH_OR;    }
#line 3424 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 73: /* $@5: %empty  */
#line 859 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_B)->cat0.brtype = BRANCH_AND;    }
#line 3430 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 75: /* $@6: %empty  */
#line 860 "../src/freedreno/ir3/ir3_parser.y"
                                         { new_instr(OPC_B)->cat0.brtype = BRANCH_CONST; instr->cat0.idx = (yyvsp[0].num); }
#line 3436 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 77: /* $@7: %empty  */
#line 861 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_B)->cat0.brtype = BRANCH_ANY; }
#line 3442 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 79: /* $@8: %empty  */
#line 862 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_B)->cat0.brtype = BRANCH_ALL; }
#line 3448 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 81: /* $@9: %empty  */
#line 863 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_B)->cat0.brtype = BRANCH_X; }
#line 3454 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 83: /* $@10: %empty  */
#line 864 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_JUMP); }
#line 3460 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 85: /* $@11: %empty  */
#line 865 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_CALL); }
#line 3466 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 87: /* cat0_instr: T_OP_RET  */
#line 866 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_RET); }
#line 3472 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 88: /* $@12: %empty  */
#line 867 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_KILL); }
#line 3478 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 90: /* cat0_instr: T_OP_END  */
#line 868 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_END); }
#line 3484 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 91: /* cat0_instr: T_OP_EMIT  */
#line 869 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_EMIT); }
#line 3490 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 92: /* cat0_instr: T_OP_CUT  */
#line 870 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_CUT); }
#line 3496 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 93: /* cat0_instr: T_OP_CHMASK  */
#line 871 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_CHMASK); }
#line 3502 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 94: /* cat0_instr: T_OP_CHSH  */
#line 872 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_CHSH); }
#line 3508 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 95: /* cat0_instr: T_OP_FLOW_REV  */
#line 873 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_FLOW_REV); }
#line 3514 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 96: /* $@13: %empty  */
#line 874 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_BKT); }
#line 3520 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 98: /* cat0_instr: T_OP_STKS  */
#line 875 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_STKS); }
#line 3526 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 99: /* cat0_instr: T_OP_STKR  */
#line 876 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_STKR); }
#line 3532 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 100: /* cat0_instr: T_OP_XSET  */
#line 877 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_XSET); }
#line 3538 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 101: /* cat0_instr: T_OP_XCLR  */
#line 878 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_XCLR); }
#line 3544 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 102: /* $@14: %empty  */
#line 879 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_GETONE); }
#line 3550 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 104: /* cat0_instr: T_OP_DBG  */
#line 880 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_DBG); }
#line 3556 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 105: /* $@15: %empty  */
#line 881 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_SHPS); }
#line 3562 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 107: /* cat0_instr: T_OP_SHPE  */
#line 882 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_SHPE); }
#line 3568 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 108: /* $@16: %empty  */
#line 883 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_PREDT); }
#line 3574 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 110: /* $@17: %empty  */
#line 884 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_PREDF); }
#line 3580 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 112: /* cat0_instr: T_OP_PREDE  */
#line 885 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_PREDE); }
#line 3586 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 113: /* $@18: %empty  */
#line 886 "../src/freedreno/ir3/ir3_parser.y"
                                        { new_instr(OPC_GETLAST); }
#line 3592 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 115: /* cat1_opc: T_OP_MOV '.' T_CAT1_TYPE_TYPE  */
#line 888 "../src/freedreno/ir3/ir3_parser.y"
                                                 {
                       parse_type_type(new_instr(OPC_MOV), (yyvsp[0].str));
}
#line 3600 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 116: /* cat1_opc: T_OP_COV '.' T_CAT1_TYPE_TYPE  */
#line 891 "../src/freedreno/ir3/ir3_parser.y"
                                                 {
                       parse_type_type(new_instr(OPC_MOV), (yyvsp[0].str));
}
#line 3608 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 119: /* $@19: %empty  */
#line 898 "../src/freedreno/ir3/ir3_parser.y"
                                       {
                       new_instr(OPC_MOVMSK);
                       instr->cat1.src_type = TYPE_U32;
                       instr->cat1.dst_type = TYPE_U32;
                   }
#line 3618 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 120: /* cat1_movmsk: T_OP_MOVMSK '.' T_W $@19 dst_reg  */
#line 902 "../src/freedreno/ir3/ir3_parser.y"
                             {
                       if (((yyvsp[-2].num) % 32) != 0)
                          yyerror("w# must be multiple of 32");
                       if ((yyvsp[-2].num) < 32)
                          yyerror("w# must be at least 32");

                       int num = (yyvsp[-2].num) / 32;

                       instr->repeat = num - 1;
                       instr->dsts[0]->wrmask = (1 << num) - 1;
                   }
#line 3634 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 121: /* $@20: %empty  */
#line 914 "../src/freedreno/ir3/ir3_parser.y"
                                       {
                       new_instr(OPC_MOV);
                       instr->cat1.src_type = TYPE_U16;
                       instr->cat1.dst_type = TYPE_U16;
                       new_dst((61 << 3) + 2, IR3_REG_HALF);
                   }
#line 3645 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 123: /* $@21: %empty  */
#line 921 "../src/freedreno/ir3/ir3_parser.y"
                                      {
                       new_instr(OPC_MOV);
                       instr->cat1.src_type = TYPE_S16;
                       instr->cat1.dst_type = TYPE_S16;
                       new_dst((61 << 3), IR3_REG_HALF);
                   }
#line 3656 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 125: /* $@22: %empty  */
#line 928 "../src/freedreno/ir3/ir3_parser.y"
                                                 { parse_type_type(new_instr(OPC_SWZ), (yyvsp[0].str)); }
#line 3662 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 127: /* $@23: %empty  */
#line 930 "../src/freedreno/ir3/ir3_parser.y"
                                                 { parse_type_type(new_instr(OPC_GAT), (yyvsp[0].str)); }
#line 3668 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 129: /* $@24: %empty  */
#line 932 "../src/freedreno/ir3/ir3_parser.y"
                                                 { parse_type_type(new_instr(OPC_SCT), (yyvsp[0].str)); }
#line 3674 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 139: /* cat2_opc_1src: T_OP_ABSNEG_F  */
#line 944 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_ABSNEG_F); }
#line 3680 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 140: /* cat2_opc_1src: T_OP_ABSNEG_S  */
#line 945 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_ABSNEG_S); }
#line 3686 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 141: /* cat2_opc_1src: T_OP_CLZ_B  */
#line 946 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_CLZ_B); }
#line 3692 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 142: /* cat2_opc_1src: T_OP_CLZ_S  */
#line 947 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_CLZ_S); }
#line 3698 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 143: /* cat2_opc_1src: T_OP_SIGN_F  */
#line 948 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SIGN_F); }
#line 3704 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 144: /* cat2_opc_1src: T_OP_FLOOR_F  */
#line 949 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_FLOOR_F); }
#line 3710 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 145: /* cat2_opc_1src: T_OP_CEIL_F  */
#line 950 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_CEIL_F); }
#line 3716 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 146: /* cat2_opc_1src: T_OP_RNDNE_F  */
#line 951 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_RNDNE_F); }
#line 3722 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 147: /* cat2_opc_1src: T_OP_RNDAZ_F  */
#line 952 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_RNDAZ_F); }
#line 3728 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 148: /* cat2_opc_1src: T_OP_TRUNC_F  */
#line 953 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_TRUNC_F); }
#line 3734 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 149: /* cat2_opc_1src: T_OP_NOT_B  */
#line 954 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_NOT_B); }
#line 3740 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 150: /* cat2_opc_1src: T_OP_BFREV_B  */
#line 955 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_BFREV_B); }
#line 3746 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 151: /* cat2_opc_1src: T_OP_SETRM  */
#line 956 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SETRM); }
#line 3752 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 152: /* cat2_opc_1src: T_OP_CBITS_B  */
#line 957 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_CBITS_B); }
#line 3758 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 153: /* cat2_opc_2src_cnd: T_OP_CMPS_F  */
#line 959 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_CMPS_F); }
#line 3764 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 154: /* cat2_opc_2src_cnd: T_OP_CMPS_U  */
#line 960 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_CMPS_U); }
#line 3770 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 155: /* cat2_opc_2src_cnd: T_OP_CMPS_S  */
#line 961 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_CMPS_S); }
#line 3776 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 156: /* cat2_opc_2src_cnd: T_OP_CMPV_F  */
#line 962 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_CMPV_F); }
#line 3782 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 157: /* cat2_opc_2src_cnd: T_OP_CMPV_U  */
#line 963 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_CMPV_U); }
#line 3788 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 158: /* cat2_opc_2src_cnd: T_OP_CMPV_S  */
#line 964 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_CMPV_S); }
#line 3794 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 159: /* cat2_opc_2src: T_OP_ADD_F  */
#line 966 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_ADD_F); }
#line 3800 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 160: /* cat2_opc_2src: T_OP_MIN_F  */
#line 967 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MIN_F); }
#line 3806 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 161: /* cat2_opc_2src: T_OP_MAX_F  */
#line 968 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MAX_F); }
#line 3812 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 162: /* cat2_opc_2src: T_OP_MUL_F  */
#line 969 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MUL_F); }
#line 3818 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 163: /* cat2_opc_2src: T_OP_ADD_U  */
#line 970 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_ADD_U); }
#line 3824 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 164: /* cat2_opc_2src: T_OP_ADD_S  */
#line 971 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_ADD_S); }
#line 3830 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 165: /* cat2_opc_2src: T_OP_SUB_U  */
#line 972 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SUB_U); }
#line 3836 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 166: /* cat2_opc_2src: T_OP_SUB_S  */
#line 973 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SUB_S); }
#line 3842 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 167: /* cat2_opc_2src: T_OP_MIN_U  */
#line 974 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MIN_U); }
#line 3848 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 168: /* cat2_opc_2src: T_OP_MIN_S  */
#line 975 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MIN_S); }
#line 3854 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 169: /* cat2_opc_2src: T_OP_MAX_U  */
#line 976 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MAX_U); }
#line 3860 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 170: /* cat2_opc_2src: T_OP_MAX_S  */
#line 977 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MAX_S); }
#line 3866 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 171: /* cat2_opc_2src: T_OP_AND_B  */
#line 978 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_AND_B); }
#line 3872 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 172: /* cat2_opc_2src: T_OP_OR_B  */
#line 979 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_OR_B); }
#line 3878 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 173: /* cat2_opc_2src: T_OP_XOR_B  */
#line 980 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_XOR_B); }
#line 3884 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 174: /* cat2_opc_2src: T_OP_MUL_U24  */
#line 981 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MUL_U24); }
#line 3890 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 175: /* cat2_opc_2src: T_OP_MUL_S24  */
#line 982 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MUL_S24); }
#line 3896 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 176: /* cat2_opc_2src: T_OP_MULL_U  */
#line 983 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MULL_U); }
#line 3902 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 177: /* cat2_opc_2src: T_OP_SHL_B  */
#line 984 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SHL_B); }
#line 3908 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 178: /* cat2_opc_2src: T_OP_SHR_B  */
#line 985 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SHR_B); }
#line 3914 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 179: /* cat2_opc_2src: T_OP_ASHR_B  */
#line 986 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_ASHR_B); }
#line 3920 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 180: /* cat2_opc_2src: T_OP_BARY_F  */
#line 987 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_BARY_F); }
#line 3926 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 181: /* cat2_opc_2src: T_OP_FLAT_B  */
#line 988 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_FLAT_B); }
#line 3932 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 182: /* cat2_opc_2src: T_OP_MGEN_B  */
#line 989 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MGEN_B); }
#line 3938 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 183: /* cat2_opc_2src: T_OP_GETBIT_B  */
#line 990 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_GETBIT_B); }
#line 3944 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 184: /* cat2_opc_2src: T_OP_SHB  */
#line 991 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SHB); }
#line 3950 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 185: /* cat2_opc_2src: T_OP_MSAD  */
#line 992 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MSAD); }
#line 3956 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 186: /* cond: T_LT  */
#line 994 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->cat2.condition = IR3_COND_LT; }
#line 3962 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 187: /* cond: T_LE  */
#line 995 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->cat2.condition = IR3_COND_LE; }
#line 3968 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 188: /* cond: T_GT  */
#line 996 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->cat2.condition = IR3_COND_GT; }
#line 3974 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 189: /* cond: T_GE  */
#line 997 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->cat2.condition = IR3_COND_GE; }
#line 3980 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 190: /* cond: T_EQ  */
#line 998 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->cat2.condition = IR3_COND_EQ; }
#line 3986 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 191: /* cond: T_NE  */
#line 999 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->cat2.condition = IR3_COND_NE; }
#line 3992 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 195: /* cat3_dp_signedness: '.' T_MIXED  */
#line 1005 "../src/freedreno/ir3/ir3_parser.y"
                                 { instr->cat3.signedness = IR3_SRC_MIXED; }
#line 3998 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 196: /* cat3_dp_signedness: '.' T_UNSIGNED  */
#line 1006 "../src/freedreno/ir3/ir3_parser.y"
                                 { instr->cat3.signedness = IR3_SRC_UNSIGNED; }
#line 4004 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 197: /* cat3_dp_pack: '.' T_LOW  */
#line 1008 "../src/freedreno/ir3/ir3_parser.y"
                                 { instr->cat3.packed = IR3_SRC_PACKED_LOW; }
#line 4010 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 198: /* cat3_dp_pack: '.' T_HIGH  */
#line 1009 "../src/freedreno/ir3/ir3_parser.y"
                                 { instr->cat3.packed = IR3_SRC_PACKED_HIGH; }
#line 4016 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 199: /* cat3_opc: T_OP_MAD_U16  */
#line 1011 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MAD_U16); }
#line 4022 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 200: /* cat3_opc: T_OP_MADSH_U16  */
#line 1012 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MADSH_U16); }
#line 4028 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 201: /* cat3_opc: T_OP_MAD_S16  */
#line 1013 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MAD_S16); }
#line 4034 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 202: /* cat3_opc: T_OP_MADSH_M16  */
#line 1014 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MADSH_M16); }
#line 4040 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 203: /* cat3_opc: T_OP_MAD_U24  */
#line 1015 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MAD_U24); }
#line 4046 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 204: /* cat3_opc: T_OP_MAD_S24  */
#line 1016 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MAD_S24); }
#line 4052 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 205: /* cat3_opc: T_OP_MAD_F16  */
#line 1017 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MAD_F16); }
#line 4058 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 206: /* cat3_opc: T_OP_MAD_F32  */
#line 1018 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_MAD_F32); }
#line 4064 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 207: /* cat3_opc: T_OP_SEL_B16  */
#line 1019 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SEL_B16); }
#line 4070 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 208: /* cat3_opc: T_OP_SEL_B32  */
#line 1020 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SEL_B32); }
#line 4076 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 209: /* cat3_opc: T_OP_SEL_S16  */
#line 1021 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SEL_S16); }
#line 4082 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 210: /* cat3_opc: T_OP_SEL_S32  */
#line 1022 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SEL_S32); }
#line 4088 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 211: /* cat3_opc: T_OP_SEL_F16  */
#line 1023 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SEL_F16); }
#line 4094 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 212: /* cat3_opc: T_OP_SEL_F32  */
#line 1024 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SEL_F32); }
#line 4100 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 213: /* cat3_opc: T_OP_SAD_S16  */
#line 1025 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SAD_S16); }
#line 4106 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 214: /* cat3_opc: T_OP_SAD_S32  */
#line 1026 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SAD_S32); }
#line 4112 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 215: /* cat3_imm_reg_opc: T_OP_SHRM  */
#line 1028 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SHRM); }
#line 4118 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 216: /* cat3_imm_reg_opc: T_OP_SHLM  */
#line 1029 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SHLM); }
#line 4124 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 217: /* cat3_imm_reg_opc: T_OP_SHRG  */
#line 1030 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SHRG); }
#line 4130 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 218: /* cat3_imm_reg_opc: T_OP_SHLG  */
#line 1031 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SHLG); }
#line 4136 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 219: /* cat3_imm_reg_opc: T_OP_ANDG  */
#line 1032 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_ANDG); }
#line 4142 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 220: /* cat3_wmm: T_OP_WMM  */
#line 1034 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_WMM); }
#line 4148 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 221: /* cat3_wmm: T_OP_WMM_ACCU  */
#line 1035 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_WMM_ACCU); }
#line 4154 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 222: /* cat3_dp: T_OP_DP2ACC  */
#line 1037 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_DP2ACC); }
#line 4160 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 223: /* cat3_dp: T_OP_DP4ACC  */
#line 1038 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_DP4ACC); }
#line 4166 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 228: /* cat4_opc: T_OP_RCP  */
#line 1045 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_RCP); }
#line 4172 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 229: /* cat4_opc: T_OP_RSQ  */
#line 1046 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_RSQ); }
#line 4178 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 230: /* cat4_opc: T_OP_LOG2  */
#line 1047 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_LOG2); }
#line 4184 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 231: /* cat4_opc: T_OP_EXP2  */
#line 1048 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_EXP2); }
#line 4190 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 232: /* cat4_opc: T_OP_SIN  */
#line 1049 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SIN); }
#line 4196 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 233: /* cat4_opc: T_OP_COS  */
#line 1050 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_COS); }
#line 4202 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 234: /* cat4_opc: T_OP_SQRT  */
#line 1051 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SQRT); }
#line 4208 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 235: /* cat4_opc: T_OP_HRSQ  */
#line 1052 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_HRSQ); }
#line 4214 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 236: /* cat4_opc: T_OP_HLOG2  */
#line 1053 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_HLOG2); }
#line 4220 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 237: /* cat4_opc: T_OP_HEXP2  */
#line 1054 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_HEXP2); }
#line 4226 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 239: /* cat5_opc_dsxypp: T_OP_DSXPP_1  */
#line 1058 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_DSXPP_1)->cat5.type = TYPE_F32; }
#line 4232 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 240: /* cat5_opc_dsxypp: T_OP_DSYPP_1  */
#line 1059 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_DSYPP_1)->cat5.type = TYPE_F32; }
#line 4238 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 241: /* cat5_opc: T_OP_ISAM  */
#line 1061 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_ISAM); }
#line 4244 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 242: /* cat5_opc: T_OP_ISAML  */
#line 1062 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_ISAML); }
#line 4250 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 243: /* cat5_opc: T_OP_ISAMM  */
#line 1063 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_ISAMM); }
#line 4256 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 244: /* cat5_opc: T_OP_SAM  */
#line 1064 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SAM); }
#line 4262 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 245: /* cat5_opc: T_OP_SAMB  */
#line 1065 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SAMB); }
#line 4268 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 246: /* cat5_opc: T_OP_SAML  */
#line 1066 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SAML); }
#line 4274 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 247: /* cat5_opc: T_OP_SAMGQ  */
#line 1067 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SAMGQ); }
#line 4280 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 248: /* cat5_opc: T_OP_GETLOD  */
#line 1068 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_GETLOD); }
#line 4286 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 249: /* cat5_opc: T_OP_CONV  */
#line 1069 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_CONV); }
#line 4292 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 250: /* cat5_opc: T_OP_CONVM  */
#line 1070 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_CONVM); }
#line 4298 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 251: /* cat5_opc: T_OP_GETSIZE  */
#line 1071 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_GETSIZE); }
#line 4304 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 252: /* cat5_opc: T_OP_GETBUF  */
#line 1072 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_GETBUF); }
#line 4310 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 253: /* cat5_opc: T_OP_GETPOS  */
#line 1073 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_GETPOS); }
#line 4316 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 254: /* cat5_opc: T_OP_GETINFO  */
#line 1074 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_GETINFO); }
#line 4322 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 255: /* cat5_opc: T_OP_DSX  */
#line 1075 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_DSX); }
#line 4328 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 256: /* cat5_opc: T_OP_DSY  */
#line 1076 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_DSY); }
#line 4334 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 257: /* cat5_opc: T_OP_GATHER4R  */
#line 1077 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_GATHER4R); }
#line 4340 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 258: /* cat5_opc: T_OP_GATHER4G  */
#line 1078 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_GATHER4G); }
#line 4346 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 259: /* cat5_opc: T_OP_GATHER4B  */
#line 1079 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_GATHER4B); }
#line 4352 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 260: /* cat5_opc: T_OP_GATHER4A  */
#line 1080 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_GATHER4A); }
#line 4358 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 261: /* cat5_opc: T_OP_SAMGP0  */
#line 1081 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SAMGP0); }
#line 4364 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 262: /* cat5_opc: T_OP_SAMGP1  */
#line 1082 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SAMGP1); }
#line 4370 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 263: /* cat5_opc: T_OP_SAMGP2  */
#line 1083 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SAMGP2); }
#line 4376 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 264: /* cat5_opc: T_OP_SAMGP3  */
#line 1084 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_SAMGP3); }
#line 4382 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 265: /* cat5_opc: T_OP_RGETPOS  */
#line 1085 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_RGETPOS); }
#line 4388 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 266: /* cat5_opc: T_OP_RGETINFO  */
#line 1086 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_RGETINFO); }
#line 4394 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 267: /* cat5_opc: T_OP_BRCST_A  */
#line 1087 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_BRCST_ACTIVE); }
#line 4400 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 268: /* cat5_opc: T_OP_QSHUFFLE_BRCST  */
#line 1088 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_instr(OPC_QUAD_SHUFFLE_BRCST); }
#line 4406 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 269: /* cat5_opc: T_OP_QSHUFFLE_H  */
#line 1089 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_instr(OPC_QUAD_SHUFFLE_HORIZ); }
#line 4412 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 270: /* cat5_opc: T_OP_QSHUFFLE_V  */
#line 1090 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_instr(OPC_QUAD_SHUFFLE_VERT); }
#line 4418 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 271: /* cat5_opc: T_OP_QSHUFFLE_DIAG  */
#line 1091 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_instr(OPC_QUAD_SHUFFLE_DIAG); }
#line 4424 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 272: /* cat5_flag: '.' T_3D  */
#line 1093 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->flags |= IR3_INSTR_3D; }
#line 4430 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 273: /* cat5_flag: '.' 'a'  */
#line 1094 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->flags |= IR3_INSTR_A; }
#line 4436 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 274: /* cat5_flag: '.' 'o'  */
#line 1095 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->flags |= IR3_INSTR_O; }
#line 4442 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 275: /* cat5_flag: '.' 'p'  */
#line 1096 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->flags |= IR3_INSTR_P; }
#line 4448 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 276: /* cat5_flag: '.' 's'  */
#line 1097 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->flags |= IR3_INSTR_S; }
#line 4454 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 277: /* cat5_flag: '.' T_S2EN  */
#line 1098 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->flags |= IR3_INSTR_S2EN; }
#line 4460 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 278: /* cat5_flag: '.' T_UNIFORM  */
#line 1099 "../src/freedreno/ir3/ir3_parser.y"
                                  { }
#line 4466 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 279: /* cat5_flag: '.' T_NONUNIFORM  */
#line 1100 "../src/freedreno/ir3/ir3_parser.y"
                                     { instr->flags |= IR3_INSTR_NONUNIF; }
#line 4472 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 280: /* cat5_flag: '.' T_BASE  */
#line 1101 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->flags |= IR3_INSTR_B; instr->cat5.tex_base = (yyvsp[0].tok); }
#line 4478 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 281: /* cat5_flag: '.' T_W  */
#line 1102 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->cat5.cluster_size = (yyvsp[0].num); }
#line 4484 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 284: /* cat5_samp: T_SAMP  */
#line 1106 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->cat5.samp = (yyvsp[0].tok); }
#line 4490 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 285: /* cat5_tex: T_TEX  */
#line 1107 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->cat5.tex = (yyvsp[0].tok); }
#line 4496 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 286: /* cat5_type: '(' type ')'  */
#line 1108 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->cat5.type = (yyvsp[-1].type); }
#line 4502 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 287: /* cat5_a1: src_reg  */
#line 1109 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->flags |= IR3_INSTR_A1EN; }
#line 4508 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 306: /* cat5_instr: T_OP_TCINV  */
#line 1129 "../src/freedreno/ir3/ir3_parser.y"
                              { new_instr(OPC_TCINV); }
#line 4514 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 307: /* cat6_typed: '.' T_UNTYPED  */
#line 1131 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->cat6.typed = 0; }
#line 4520 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 308: /* cat6_typed: '.' T_TYPED  */
#line 1132 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->cat6.typed = 1; }
#line 4526 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 309: /* cat6_dim: '.' T_1D  */
#line 1134 "../src/freedreno/ir3/ir3_parser.y"
                             { instr->cat6.d = 1; }
#line 4532 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 310: /* cat6_dim: '.' T_2D  */
#line 1135 "../src/freedreno/ir3/ir3_parser.y"
                             { instr->cat6.d = 2; }
#line 4538 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 311: /* cat6_dim: '.' T_3D  */
#line 1136 "../src/freedreno/ir3/ir3_parser.y"
                             { instr->cat6.d = 3; }
#line 4544 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 312: /* cat6_dim: '.' T_4D  */
#line 1137 "../src/freedreno/ir3/ir3_parser.y"
                             { instr->cat6.d = 4; }
#line 4550 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 313: /* cat6_type: '.' type  */
#line 1139 "../src/freedreno/ir3/ir3_parser.y"
                             { instr->cat6.type = (yyvsp[0].type); }
#line 4556 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 314: /* cat6_imm_offset: offset  */
#line 1140 "../src/freedreno/ir3/ir3_parser.y"
                             { new_src(0, IR3_REG_IMMED)->iim_val = (yyvsp[0].num); }
#line 4562 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 317: /* cat6_dst_offset: offset  */
#line 1143 "../src/freedreno/ir3/ir3_parser.y"
                             { instr->cat6.dst_offset = (yyvsp[0].num); }
#line 4568 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 319: /* cat6_immed: integer  */
#line 1146 "../src/freedreno/ir3/ir3_parser.y"
                             { instr->cat6.iim_val = (yyvsp[0].num); }
#line 4574 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 320: /* cat6_a6xx_global_address_pt3: '<' '<' integer offset '<' '<' integer  */
#line 1149 "../src/freedreno/ir3/ir3_parser.y"
                                                          {
                        assert((yyvsp[0].num) == 2);
                        new_src(0, IR3_REG_IMMED)->uim_val = (yyvsp[-4].num) - 2;
                        new_src(0, IR3_REG_IMMED)->uim_val = (yyvsp[-3].num);
                   }
#line 4584 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 321: /* cat6_a6xx_global_address_pt3: '+' cat6_reg_or_immed  */
#line 1154 "../src/freedreno/ir3/ir3_parser.y"
                                         {
                        // Dummy src to smooth the difference between a6xx and a7xx
                        new_src(0, IR3_REG_IMMED)->uim_val = 0;
                   }
#line 4593 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 322: /* cat6_a6xx_global_address_pt2: '(' src offset ')' '<' '<' integer  */
#line 1160 "../src/freedreno/ir3/ir3_parser.y"
                                                      {
                        assert((yyvsp[0].num) == 2);
                        new_src(0, IR3_REG_IMMED)->uim_val = 0;
                        new_src(0, IR3_REG_IMMED)->uim_val = (yyvsp[-4].num);
                   }
#line 4603 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 325: /* $@25: %empty  */
#line 1171 "../src/freedreno/ir3/ir3_parser.y"
                              { new_instr(OPC_LDG); }
#line 4609 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 327: /* $@26: %empty  */
#line 1172 "../src/freedreno/ir3/ir3_parser.y"
                              { new_instr(OPC_LDG_A); }
#line 4615 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 329: /* $@27: %empty  */
#line 1173 "../src/freedreno/ir3/ir3_parser.y"
                              { new_instr(OPC_LDP); }
#line 4621 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 331: /* $@28: %empty  */
#line 1174 "../src/freedreno/ir3/ir3_parser.y"
                              { new_instr(OPC_LDL); }
#line 4627 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 333: /* $@29: %empty  */
#line 1175 "../src/freedreno/ir3/ir3_parser.y"
                              { new_instr(OPC_LDLW); }
#line 4633 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 335: /* $@30: %empty  */
#line 1176 "../src/freedreno/ir3/ir3_parser.y"
                              { new_instr(OPC_LDLV); }
#line 4639 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 336: /* $@31: %empty  */
#line 1176 "../src/freedreno/ir3/ir3_parser.y"
                                                                                                  {
                       new_src(0, IR3_REG_IMMED)->iim_val = (yyvsp[-1].num);
                   }
#line 4647 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 338: /* $@32: %empty  */
#line 1180 "../src/freedreno/ir3/ir3_parser.y"
                              { new_instr(OPC_STG); dummy_dst(); }
#line 4653 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 340: /* $@33: %empty  */
#line 1181 "../src/freedreno/ir3/ir3_parser.y"
                              { new_instr(OPC_STG_A); dummy_dst(); }
#line 4659 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 342: /* $@34: %empty  */
#line 1182 "../src/freedreno/ir3/ir3_parser.y"
                             { new_instr(OPC_STP); dummy_dst(); }
#line 4665 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 344: /* $@35: %empty  */
#line 1183 "../src/freedreno/ir3/ir3_parser.y"
                             { new_instr(OPC_STL); dummy_dst(); }
#line 4671 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 346: /* $@36: %empty  */
#line 1184 "../src/freedreno/ir3/ir3_parser.y"
                             { new_instr(OPC_STLW); dummy_dst(); }
#line 4677 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 348: /* $@37: %empty  */
#line 1186 "../src/freedreno/ir3/ir3_parser.y"
                             { new_instr(OPC_LDIB); }
#line 4683 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 350: /* $@38: %empty  */
#line 1187 "../src/freedreno/ir3/ir3_parser.y"
                             { new_instr(OPC_STIB); dummy_dst(); }
#line 4689 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 352: /* $@39: %empty  */
#line 1189 "../src/freedreno/ir3/ir3_parser.y"
                                 { new_instr(OPC_PREFETCH); new_dst(0,0); /* dummy dst */ }
#line 4695 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 354: /* cat6_atomic_opc: T_OP_ATOMIC_ADD  */
#line 1191 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_instr(OPC_ATOMIC_ADD); }
#line 4701 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 355: /* cat6_atomic_opc: T_OP_ATOMIC_SUB  */
#line 1192 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_instr(OPC_ATOMIC_SUB); }
#line 4707 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 356: /* cat6_atomic_opc: T_OP_ATOMIC_XCHG  */
#line 1193 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_instr(OPC_ATOMIC_XCHG); }
#line 4713 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 357: /* cat6_atomic_opc: T_OP_ATOMIC_INC  */
#line 1194 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_instr(OPC_ATOMIC_INC); }
#line 4719 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 358: /* cat6_atomic_opc: T_OP_ATOMIC_DEC  */
#line 1195 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_instr(OPC_ATOMIC_DEC); }
#line 4725 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 359: /* cat6_atomic_opc: T_OP_ATOMIC_CMPXCHG  */
#line 1196 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_instr(OPC_ATOMIC_CMPXCHG); }
#line 4731 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 360: /* cat6_atomic_opc: T_OP_ATOMIC_MIN  */
#line 1197 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_instr(OPC_ATOMIC_MIN); }
#line 4737 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 361: /* cat6_atomic_opc: T_OP_ATOMIC_MAX  */
#line 1198 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_instr(OPC_ATOMIC_MAX); }
#line 4743 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 362: /* cat6_atomic_opc: T_OP_ATOMIC_AND  */
#line 1199 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_instr(OPC_ATOMIC_AND); }
#line 4749 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 363: /* cat6_atomic_opc: T_OP_ATOMIC_OR  */
#line 1200 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_instr(OPC_ATOMIC_OR); }
#line 4755 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 364: /* cat6_atomic_opc: T_OP_ATOMIC_XOR  */
#line 1201 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_instr(OPC_ATOMIC_XOR); }
#line 4761 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 365: /* cat6_a3xx_atomic_opc: T_OP_ATOMIC_S_ADD  */
#line 1203 "../src/freedreno/ir3/ir3_parser.y"
                                              { new_instr(OPC_ATOMIC_S_ADD); }
#line 4767 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 366: /* cat6_a3xx_atomic_opc: T_OP_ATOMIC_S_SUB  */
#line 1204 "../src/freedreno/ir3/ir3_parser.y"
                                              { new_instr(OPC_ATOMIC_S_SUB); }
#line 4773 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 367: /* cat6_a3xx_atomic_opc: T_OP_ATOMIC_S_XCHG  */
#line 1205 "../src/freedreno/ir3/ir3_parser.y"
                                              { new_instr(OPC_ATOMIC_S_XCHG); }
#line 4779 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 368: /* cat6_a3xx_atomic_opc: T_OP_ATOMIC_S_INC  */
#line 1206 "../src/freedreno/ir3/ir3_parser.y"
                                              { new_instr(OPC_ATOMIC_S_INC); }
#line 4785 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 369: /* cat6_a3xx_atomic_opc: T_OP_ATOMIC_S_DEC  */
#line 1207 "../src/freedreno/ir3/ir3_parser.y"
                                              { new_instr(OPC_ATOMIC_S_DEC); }
#line 4791 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 370: /* cat6_a3xx_atomic_opc: T_OP_ATOMIC_S_CMPXCHG  */
#line 1208 "../src/freedreno/ir3/ir3_parser.y"
                                              { new_instr(OPC_ATOMIC_S_CMPXCHG); }
#line 4797 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 371: /* cat6_a3xx_atomic_opc: T_OP_ATOMIC_S_MIN  */
#line 1209 "../src/freedreno/ir3/ir3_parser.y"
                                              { new_instr(OPC_ATOMIC_S_MIN); }
#line 4803 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 372: /* cat6_a3xx_atomic_opc: T_OP_ATOMIC_S_MAX  */
#line 1210 "../src/freedreno/ir3/ir3_parser.y"
                                              { new_instr(OPC_ATOMIC_S_MAX); }
#line 4809 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 373: /* cat6_a3xx_atomic_opc: T_OP_ATOMIC_S_AND  */
#line 1211 "../src/freedreno/ir3/ir3_parser.y"
                                              { new_instr(OPC_ATOMIC_S_AND); }
#line 4815 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 374: /* cat6_a3xx_atomic_opc: T_OP_ATOMIC_S_OR  */
#line 1212 "../src/freedreno/ir3/ir3_parser.y"
                                              { new_instr(OPC_ATOMIC_S_OR); }
#line 4821 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 375: /* cat6_a3xx_atomic_opc: T_OP_ATOMIC_S_XOR  */
#line 1213 "../src/freedreno/ir3/ir3_parser.y"
                                              { new_instr(OPC_ATOMIC_S_XOR); }
#line 4827 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 376: /* cat6_a6xx_atomic_opc: T_OP_ATOMIC_G_ADD  */
#line 1215 "../src/freedreno/ir3/ir3_parser.y"
                                              { new_instr(OPC_ATOMIC_G_ADD); }
#line 4833 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 377: /* cat6_a6xx_atomic_opc: T_OP_ATOMIC_G_SUB  */
#line 1216 "../src/freedreno/ir3/ir3_parser.y"
                                              { new_instr(OPC_ATOMIC_G_SUB); }
#line 4839 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 378: /* cat6_a6xx_atomic_opc: T_OP_ATOMIC_G_XCHG  */
#line 1217 "../src/freedreno/ir3/ir3_parser.y"
                                              { new_instr(OPC_ATOMIC_G_XCHG); }
#line 4845 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 379: /* cat6_a6xx_atomic_opc: T_OP_ATOMIC_G_INC  */
#line 1218 "../src/freedreno/ir3/ir3_parser.y"
                                              { new_instr(OPC_ATOMIC_G_INC); }
#line 4851 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 380: /* cat6_a6xx_atomic_opc: T_OP_ATOMIC_G_DEC  */
#line 1219 "../src/freedreno/ir3/ir3_parser.y"
                                              { new_instr(OPC_ATOMIC_G_DEC); }
#line 4857 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 381: /* cat6_a6xx_atomic_opc: T_OP_ATOMIC_G_CMPXCHG  */
#line 1220 "../src/freedreno/ir3/ir3_parser.y"
                                              { new_instr(OPC_ATOMIC_G_CMPXCHG); }
#line 4863 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 382: /* cat6_a6xx_atomic_opc: T_OP_ATOMIC_G_MIN  */
#line 1221 "../src/freedreno/ir3/ir3_parser.y"
                                              { new_instr(OPC_ATOMIC_G_MIN); }
#line 4869 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 383: /* cat6_a6xx_atomic_opc: T_OP_ATOMIC_G_MAX  */
#line 1222 "../src/freedreno/ir3/ir3_parser.y"
                                              { new_instr(OPC_ATOMIC_G_MAX); }
#line 4875 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 384: /* cat6_a6xx_atomic_opc: T_OP_ATOMIC_G_AND  */
#line 1223 "../src/freedreno/ir3/ir3_parser.y"
                                              { new_instr(OPC_ATOMIC_G_AND); }
#line 4881 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 385: /* cat6_a6xx_atomic_opc: T_OP_ATOMIC_G_OR  */
#line 1224 "../src/freedreno/ir3/ir3_parser.y"
                                              { new_instr(OPC_ATOMIC_G_OR); }
#line 4887 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 386: /* cat6_a6xx_atomic_opc: T_OP_ATOMIC_G_XOR  */
#line 1225 "../src/freedreno/ir3/ir3_parser.y"
                                              { new_instr(OPC_ATOMIC_G_XOR); }
#line 4893 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 393: /* cat6_ibo_opc_1src: T_OP_RESINFO  */
#line 1237 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_RESINFO); }
#line 4899 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 394: /* cat6_ibo_opc_ldgb: T_OP_LDGB  */
#line 1239 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_LDGB); }
#line 4905 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 395: /* cat6_ibo_opc_stgb: T_OP_STGB  */
#line 1240 "../src/freedreno/ir3/ir3_parser.y"
                                  { new_instr(OPC_STGB); }
#line 4911 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 398: /* $@40: %empty  */
#line 1244 "../src/freedreno/ir3/ir3_parser.y"
                                                                                  { dummy_dst(); }
#line 4917 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 400: /* cat6_id_opc: T_OP_GETSPID  */
#line 1247 "../src/freedreno/ir3/ir3_parser.y"
                                { new_instr(OPC_GETSPID); }
#line 4923 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 401: /* cat6_id_opc: T_OP_GETWID  */
#line 1248 "../src/freedreno/ir3/ir3_parser.y"
                                { new_instr(OPC_GETWID); }
#line 4929 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 402: /* cat6_id_opc: T_OP_GETFIBERID  */
#line 1249 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_instr(OPC_GETFIBERID); }
#line 4935 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 405: /* cat6_bindless_base: '.' T_BASE  */
#line 1254 "../src/freedreno/ir3/ir3_parser.y"
                              { instr->flags |= IR3_INSTR_B; instr->cat6.base = (yyvsp[0].tok); }
#line 4941 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 408: /* cat6_bindless_mode: T_NONUNIFORM cat6_bindless_base  */
#line 1258 "../src/freedreno/ir3/ir3_parser.y"
                                                   { instr->flags |= IR3_INSTR_NONUNIF; }
#line 4947 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 410: /* cat6_reg_or_immed: integer  */
#line 1261 "../src/freedreno/ir3/ir3_parser.y"
                           { new_src(0, IR3_REG_IMMED)->iim_val = (yyvsp[0].num); }
#line 4953 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 411: /* cat6_bindless_ibo_opc_1src: T_OP_RESINFO_B  */
#line 1263 "../src/freedreno/ir3/ir3_parser.y"
                                                 { new_instr(OPC_RESINFO); }
#line 4959 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 412: /* cat6_bindless_ibo_opc_2src: T_OP_ATOMIC_B_ADD  */
#line 1265 "../src/freedreno/ir3/ir3_parser.y"
                                                     { new_instr(OPC_ATOMIC_B_ADD); dummy_dst(); }
#line 4965 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 413: /* cat6_bindless_ibo_opc_2src: T_OP_ATOMIC_B_SUB  */
#line 1266 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_instr(OPC_ATOMIC_B_SUB); dummy_dst(); }
#line 4971 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 414: /* cat6_bindless_ibo_opc_2src: T_OP_ATOMIC_B_XCHG  */
#line 1267 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_instr(OPC_ATOMIC_B_XCHG); dummy_dst(); }
#line 4977 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 415: /* cat6_bindless_ibo_opc_2src: T_OP_ATOMIC_B_INC  */
#line 1268 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_instr(OPC_ATOMIC_B_INC); dummy_dst(); }
#line 4983 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 416: /* cat6_bindless_ibo_opc_2src: T_OP_ATOMIC_B_DEC  */
#line 1269 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_instr(OPC_ATOMIC_B_DEC); dummy_dst(); }
#line 4989 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 417: /* cat6_bindless_ibo_opc_2src: T_OP_ATOMIC_B_CMPXCHG  */
#line 1270 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_instr(OPC_ATOMIC_B_CMPXCHG); dummy_dst(); }
#line 4995 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 418: /* cat6_bindless_ibo_opc_2src: T_OP_ATOMIC_B_MIN  */
#line 1271 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_instr(OPC_ATOMIC_B_MIN); dummy_dst(); }
#line 5001 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 419: /* cat6_bindless_ibo_opc_2src: T_OP_ATOMIC_B_MAX  */
#line 1272 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_instr(OPC_ATOMIC_B_MAX); dummy_dst(); }
#line 5007 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 420: /* cat6_bindless_ibo_opc_2src: T_OP_ATOMIC_B_AND  */
#line 1273 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_instr(OPC_ATOMIC_B_AND); dummy_dst(); }
#line 5013 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 421: /* cat6_bindless_ibo_opc_2src: T_OP_ATOMIC_B_OR  */
#line 1274 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_instr(OPC_ATOMIC_B_OR); dummy_dst(); }
#line 5019 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 422: /* cat6_bindless_ibo_opc_2src: T_OP_ATOMIC_B_XOR  */
#line 1275 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_instr(OPC_ATOMIC_B_XOR); dummy_dst(); }
#line 5025 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 423: /* cat6_bindless_ibo_opc_2src: T_OP_STIB_B  */
#line 1276 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_instr(OPC_STIB); dummy_dst(); }
#line 5031 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 424: /* cat6_bindless_ibo_opc_2src_dst: T_OP_LDIB_B  */
#line 1278 "../src/freedreno/ir3/ir3_parser.y"
                                                         { new_instr(OPC_LDIB); }
#line 5037 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 426: /* cat6_bindless_ibo: cat6_bindless_ibo_opc_2src cat6_typed cat6_dim cat6_type '.' cat6_immed '.' cat6_bindless_mode src_reg ',' cat6_reg_or_immed ',' cat6_reg_or_immed  */
#line 1281 "../src/freedreno/ir3/ir3_parser.y"
                                                                                                                                                                      { swap(instr->srcs[0], instr->srcs[2]); }
#line 5043 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 427: /* cat6_bindless_ibo: cat6_bindless_ibo_opc_2src_dst cat6_typed cat6_dim cat6_type '.' cat6_immed '.' cat6_bindless_mode dst_reg ',' cat6_reg_or_immed ',' cat6_reg_or_immed  */
#line 1282 "../src/freedreno/ir3/ir3_parser.y"
                                                                                                                                                                          { swap(instr->srcs[0], instr->srcs[1]); }
#line 5049 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 428: /* cat6_bindless_ldc_opc: T_OP_LDC  */
#line 1284 "../src/freedreno/ir3/ir3_parser.y"
                                 { new_instr(OPC_LDC); }
#line 5055 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 429: /* cat6_bindless_ldc_middle: T_OFFSET '.' cat6_immed '.' cat6_bindless_mode dst_reg  */
#line 1288 "../src/freedreno/ir3/ir3_parser.y"
                                                                               { instr->cat6.d = (yyvsp[-5].tok); }
#line 5061 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 430: /* cat6_bindless_ldc_middle: cat6_immed '.' 'k' '.' cat6_bindless_mode 'c' '[' T_A1 ']'  */
#line 1289 "../src/freedreno/ir3/ir3_parser.y"
                                                                                   { instr->opc = OPC_LDC_K; }
#line 5067 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 431: /* cat6_bindless_ldc: cat6_bindless_ldc_opc '.' cat6_bindless_ldc_middle ',' cat6_reg_or_immed ',' cat6_reg_or_immed  */
#line 1291 "../src/freedreno/ir3/ir3_parser.y"
                                                                                                                  {
                      instr->cat6.type = TYPE_U32;
                      /* TODO cleanup ir3 src order: */
                      swap(instr->srcs[0], instr->srcs[1]);
                   }
#line 5077 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 432: /* stc_dst: integer  */
#line 1297 "../src/freedreno/ir3/ir3_parser.y"
                          { new_src(0, IR3_REG_IMMED)->iim_val = (yyvsp[0].num); }
#line 5083 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 433: /* stc_dst: T_A1  */
#line 1298 "../src/freedreno/ir3/ir3_parser.y"
                       { new_src(0, IR3_REG_IMMED)->iim_val = 0; instr->flags |= IR3_INSTR_A1EN; }
#line 5089 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 434: /* stc_dst: T_A1 '+' integer  */
#line 1299 "../src/freedreno/ir3/ir3_parser.y"
                                   { new_src(0, IR3_REG_IMMED)->iim_val = (yyvsp[0].num); instr->flags |= IR3_INSTR_A1EN; }
#line 5095 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 435: /* $@41: %empty  */
#line 1302 "../src/freedreno/ir3/ir3_parser.y"
                        { new_instr(OPC_STC); }
#line 5101 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 437: /* $@42: %empty  */
#line 1303 "../src/freedreno/ir3/ir3_parser.y"
                        { new_instr(OPC_STSC); }
#line 5107 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 439: /* cat6_todo: T_OP_G2L  */
#line 1305 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_instr(OPC_G2L); }
#line 5113 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 440: /* cat6_todo: T_OP_L2G  */
#line 1306 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_instr(OPC_L2G); }
#line 5119 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 441: /* cat6_todo: T_OP_RESFMT  */
#line 1307 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_instr(OPC_RESFMT); }
#line 5125 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 454: /* cat7_scope: '.' 'w'  */
#line 1322 "../src/freedreno/ir3/ir3_parser.y"
                            { instr->cat7.w = true; }
#line 5131 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 455: /* cat7_scope: '.' 'r'  */
#line 1323 "../src/freedreno/ir3/ir3_parser.y"
                            { instr->cat7.r = true; }
#line 5137 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 456: /* cat7_scope: '.' 'l'  */
#line 1324 "../src/freedreno/ir3/ir3_parser.y"
                            { instr->cat7.l = true; }
#line 5143 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 457: /* cat7_scope: '.' 'g'  */
#line 1325 "../src/freedreno/ir3/ir3_parser.y"
                            { instr->cat7.g = true; }
#line 5149 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 460: /* $@43: %empty  */
#line 1330 "../src/freedreno/ir3/ir3_parser.y"
                                           { new_instr(OPC_BAR); }
#line 5155 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 462: /* $@44: %empty  */
#line 1331 "../src/freedreno/ir3/ir3_parser.y"
                                           { new_instr(OPC_FENCE); }
#line 5161 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 464: /* cat7_data_cache: T_OP_DCCLN  */
#line 1333 "../src/freedreno/ir3/ir3_parser.y"
                                           { new_instr(OPC_DCCLN); }
#line 5167 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 465: /* cat7_data_cache: T_OP_DCINV  */
#line 1334 "../src/freedreno/ir3/ir3_parser.y"
                                           { new_instr(OPC_DCINV); }
#line 5173 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 466: /* cat7_data_cache: T_OP_DCFLU  */
#line 1335 "../src/freedreno/ir3/ir3_parser.y"
                                           { new_instr(OPC_DCFLU); }
#line 5179 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 469: /* cat7_alias_scope: T_MOD_TEX  */
#line 1340 "../src/freedreno/ir3/ir3_parser.y"
                                { instr->cat7.alias_scope = ALIAS_TEX; }
#line 5185 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 470: /* cat7_alias_scope: T_MOD_MEM  */
#line 1341 "../src/freedreno/ir3/ir3_parser.y"
                                { instr->cat7.alias_scope = ALIAS_MEM; }
#line 5191 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 471: /* cat7_alias_scope: T_MOD_RT  */
#line 1342 "../src/freedreno/ir3/ir3_parser.y"
                                { instr->cat7.alias_scope = ALIAS_RT; }
#line 5197 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 474: /* cat7_instr: T_OP_SLEEP  */
#line 1346 "../src/freedreno/ir3/ir3_parser.y"
                                           { new_instr(OPC_SLEEP); }
#line 5203 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 475: /* cat7_instr: T_OP_CCINV  */
#line 1347 "../src/freedreno/ir3/ir3_parser.y"
                                           { new_instr(OPC_CCINV); }
#line 5209 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 476: /* cat7_instr: T_OP_ICINV  */
#line 1348 "../src/freedreno/ir3/ir3_parser.y"
                                           { new_instr(OPC_ICINV); }
#line 5215 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 477: /* cat7_instr: T_OP_LOCK  */
#line 1349 "../src/freedreno/ir3/ir3_parser.y"
                                           { new_instr(OPC_LOCK); }
#line 5221 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 478: /* cat7_instr: T_OP_UNLOCK  */
#line 1350 "../src/freedreno/ir3/ir3_parser.y"
                                           { new_instr(OPC_UNLOCK); }
#line 5227 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 479: /* $@45: %empty  */
#line 1351 "../src/freedreno/ir3/ir3_parser.y"
                              {
                       /* TODO: handle T_INSTR_TYPE */
                       new_instr(OPC_ALIAS);
                   }
#line 5236 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 480: /* cat7_instr: T_OP_ALIAS $@45 '.' cat7_alias_scope '.' T_INSTR_TYPE '.' integer dst_reg ',' cat7_alias_src  */
#line 1354 "../src/freedreno/ir3/ir3_parser.y"
                                                                                                  {
                       new_src(0, IR3_REG_IMMED)->uim_val = (yyvsp[-3].num);
                   }
#line 5244 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 481: /* raw_instr: T_RAW  */
#line 1358 "../src/freedreno/ir3/ir3_parser.y"
                   {new_instr(OPC_META_RAW)->raw.value = (yyvsp[0].u64);}
#line 5250 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 484: /* meta_print_reg: ',' T_REGISTER  */
#line 1363 "../src/freedreno/ir3/ir3_parser.y"
                               {
	meta_print_data.regs_to_dump[meta_print_data.regs_count++] = (yyvsp[0].num);
}
#line 5258 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 485: /* meta_print_start: T_OP_PRINT T_REGISTER  */
#line 1367 "../src/freedreno/ir3/ir3_parser.y"
                                        {
	meta_print_data.reg_address_lo = (yyvsp[0].num);
	meta_print_data.reg_address_hi = (yyvsp[0].num) + 2;
	meta_print_data.reg_tmp = (yyvsp[0].num) + 4;
	meta_print_data.regs_count = 0;
}
#line 5269 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 486: /* meta_print: meta_print_start meta_print_regs  */
#line 1374 "../src/freedreno/ir3/ir3_parser.y"
                                             {
	/* low */
	new_instr(OPC_MOV);
	instr->cat1.src_type = TYPE_U32;
	instr->cat1.dst_type = TYPE_U32;
	new_dst(meta_print_data.reg_address_lo, 0);
	new_src(0, IR3_REG_IMMED)->uim_val = info->shader_print_buffer_iova & 0xffffffff;

	/* high */
	new_instr(OPC_MOV);
	instr->cat1.src_type = TYPE_U32;
	instr->cat1.dst_type = TYPE_U32;
	new_dst(meta_print_data.reg_address_hi, 0);
	new_src(0, IR3_REG_IMMED)->uim_val = info->shader_print_buffer_iova >> 32;

	/* offset */
	new_instr(OPC_MOV);
	instr->cat1.src_type = TYPE_U32;
	instr->cat1.dst_type = TYPE_U32;
	new_dst(meta_print_data.reg_tmp, 0);
	new_src(0, IR3_REG_IMMED)->uim_val = 4 * meta_print_data.regs_count;

	new_instr(OPC_NOP);
	instr->repeat = 5;

	/* Increment and get current offset into print buffer */
	new_instr(OPC_ATOMIC_G_ADD);
	instr->cat6.d = 1;
	instr->cat6.typed = 0;
	instr->cat6.type = TYPE_U32;
	instr->cat6.iim_val = 1;

	new_dst(meta_print_data.reg_address_lo, 0);
	new_src(meta_print_data.reg_address_lo, 0);
	new_src(meta_print_data.reg_tmp, 0);

	/* Store all regs */
	for (uint32_t i = 0; i < meta_print_data.regs_count; i++) {
		new_instr(OPC_STG);
		dummy_dst();
		instr->cat6.type = TYPE_U32;
		instr->flags = IR3_INSTR_SY;
		new_src(meta_print_data.reg_address_lo, 0);
		new_src(0, IR3_REG_IMMED)->iim_val = 0;
		new_src(meta_print_data.regs_to_dump[i], IR3_REG_R);
		new_src(0, IR3_REG_IMMED)->iim_val = 1;

		new_instr(OPC_ADD_U);
		instr->flags = IR3_INSTR_SS;
		new_dst(meta_print_data.reg_address_lo, 0);
		new_src(meta_print_data.reg_address_lo, 0);
		new_src(0, IR3_REG_IMMED)->uim_val = 4;

		new_instr(OPC_NOP);
		instr->repeat = 5;
	}
}
#line 5331 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 487: /* src: T_REGISTER  */
#line 1432 "../src/freedreno/ir3/ir3_parser.y"
                                  { (yyval.reg) = new_src((yyvsp[0].num), 0); }
#line 5337 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 488: /* src: T_A0  */
#line 1433 "../src/freedreno/ir3/ir3_parser.y"
                                  { (yyval.reg) = new_src((61 << 3), IR3_REG_HALF); }
#line 5343 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 489: /* src: T_A1  */
#line 1434 "../src/freedreno/ir3/ir3_parser.y"
                                  { (yyval.reg) = new_src((61 << 3) + 1, IR3_REG_HALF); }
#line 5349 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 490: /* src: T_P0  */
#line 1435 "../src/freedreno/ir3/ir3_parser.y"
                                  { (yyval.reg) = new_src((62 << 3) + (yyvsp[0].num), 0); }
#line 5355 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 491: /* dst: T_REGISTER  */
#line 1437 "../src/freedreno/ir3/ir3_parser.y"
                                  { (yyval.reg) = new_dst((yyvsp[0].num), 0); }
#line 5361 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 492: /* dst: T_A0  */
#line 1438 "../src/freedreno/ir3/ir3_parser.y"
                                  { (yyval.reg) = new_dst((61 << 3), IR3_REG_HALF); }
#line 5367 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 493: /* dst: T_A1  */
#line 1439 "../src/freedreno/ir3/ir3_parser.y"
                                  { (yyval.reg) = new_dst((61 << 3) + 1, IR3_REG_HALF); }
#line 5373 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 494: /* dst: T_P0  */
#line 1440 "../src/freedreno/ir3/ir3_parser.y"
                                  { (yyval.reg) = new_dst((62 << 3) + (yyvsp[0].num), 0); }
#line 5379 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 495: /* const: T_CONSTANT  */
#line 1442 "../src/freedreno/ir3/ir3_parser.y"
                                  { (yyval.reg) = new_src((yyvsp[0].num), IR3_REG_CONST); }
#line 5385 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 496: /* dst_reg_flag: T_EVEN  */
#line 1444 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->cat1.round = ROUND_EVEN; }
#line 5391 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 497: /* dst_reg_flag: T_POS_INFINITY  */
#line 1445 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->cat1.round = ROUND_POS_INF; }
#line 5397 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 498: /* dst_reg_flag: T_NEG_INFINITY  */
#line 1446 "../src/freedreno/ir3/ir3_parser.y"
                                  { instr->cat1.round = ROUND_NEG_INF; }
#line 5403 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 499: /* dst_reg_flag: T_EI  */
#line 1447 "../src/freedreno/ir3/ir3_parser.y"
                                  { rflags.flags |= IR3_REG_EI; }
#line 5409 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 500: /* dst_reg_flag: T_WRMASK  */
#line 1448 "../src/freedreno/ir3/ir3_parser.y"
                                  { rflags.wrmask = (yyvsp[0].num); }
#line 5415 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 503: /* dst_reg: dst  */
#line 1454 "../src/freedreno/ir3/ir3_parser.y"
                                       { (yyvsp[0].reg)->flags |= IR3_REG_R; }
#line 5421 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 504: /* dst_reg: dst_reg_flags dst  */
#line 1455 "../src/freedreno/ir3/ir3_parser.y"
                                       { (yyvsp[0].reg)->flags |= IR3_REG_R; }
#line 5427 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 505: /* src_reg_flag: T_ABSNEG  */
#line 1457 "../src/freedreno/ir3/ir3_parser.y"
                                  { rflags.flags |= IR3_REG_ABS|IR3_REG_NEGATE; }
#line 5433 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 506: /* src_reg_flag: T_NEG  */
#line 1458 "../src/freedreno/ir3/ir3_parser.y"
                                  { rflags.flags |= IR3_REG_NEGATE; }
#line 5439 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 507: /* src_reg_flag: T_ABS  */
#line 1459 "../src/freedreno/ir3/ir3_parser.y"
                                  { rflags.flags |= IR3_REG_ABS; }
#line 5445 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 508: /* src_reg_flag: T_R  */
#line 1460 "../src/freedreno/ir3/ir3_parser.y"
                                  { rflags.flags |= IR3_REG_R; }
#line 5451 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 509: /* src_reg_flag: T_LAST  */
#line 1461 "../src/freedreno/ir3/ir3_parser.y"
                                  { rflags.flags |= IR3_REG_LAST_USE; }
#line 5457 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 529: /* offset: %empty  */
#line 1490 "../src/freedreno/ir3/ir3_parser.y"
                   { (yyval.num) = 0; }
#line 5463 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 530: /* offset: '+' integer  */
#line 1491 "../src/freedreno/ir3/ir3_parser.y"
                               { (yyval.num) = (yyvsp[0].num); }
#line 5469 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 531: /* offset: '-' integer  */
#line 1492 "../src/freedreno/ir3/ir3_parser.y"
                               { (yyval.num) = -(yyvsp[0].num); }
#line 5475 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 532: /* relative_gpr_src: 'r' '<' T_A0 offset '>'  */
#line 1494 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_src(0, IR3_REG_RELATIV)->array.offset = (yyvsp[-1].num); }
#line 5481 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 533: /* relative_gpr_src: T_HR '<' T_A0 offset '>'  */
#line 1495 "../src/freedreno/ir3/ir3_parser.y"
                                             { new_src(0, IR3_REG_RELATIV | IR3_REG_HALF)->array.offset = (yyvsp[-1].num); }
#line 5487 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 534: /* relative_gpr_dst: 'r' '<' T_A0 offset '>'  */
#line 1497 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_dst(0, IR3_REG_RELATIV)->array.offset = (yyvsp[-1].num); }
#line 5493 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 535: /* relative_gpr_dst: T_HR '<' T_A0 offset '>'  */
#line 1498 "../src/freedreno/ir3/ir3_parser.y"
                                             { new_dst(0, IR3_REG_RELATIV | IR3_REG_HALF)->array.offset = (yyvsp[-1].num); }
#line 5499 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 536: /* relative_const: 'c' '<' T_A0 offset '>'  */
#line 1500 "../src/freedreno/ir3/ir3_parser.y"
                                            { new_src(0, IR3_REG_RELATIV | IR3_REG_CONST)->array.offset = (yyvsp[-1].num); }
#line 5505 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 537: /* relative_const: T_HC '<' T_A0 offset '>'  */
#line 1501 "../src/freedreno/ir3/ir3_parser.y"
                                             { new_src(0, IR3_REG_RELATIV | IR3_REG_CONST | IR3_REG_HALF)->array.offset = (yyvsp[-1].num); }
#line 5511 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 540: /* immediate_cat1: integer  */
#line 1510 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_src(0, IR3_REG_IMMED)->iim_val = type_size(instr->cat1.src_type) < 32 ? (yyvsp[0].num) & 0xffff : (yyvsp[0].num); }
#line 5517 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 541: /* immediate_cat1: '(' integer ')'  */
#line 1511 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_src(0, IR3_REG_IMMED)->fim_val = (yyvsp[-1].num); }
#line 5523 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 542: /* immediate_cat1: '(' float ')'  */
#line 1512 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_src(0, IR3_REG_IMMED)->fim_val = (yyvsp[-1].flt); }
#line 5529 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 543: /* immediate_cat1: 'h' '(' integer ')'  */
#line 1513 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_src(0, IR3_REG_IMMED | IR3_REG_HALF)->iim_val = (yyvsp[-1].num) & 0xffff; }
#line 5535 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 544: /* immediate_cat1: 'h' '(' float ')'  */
#line 1514 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_src(0, IR3_REG_IMMED | IR3_REG_HALF)->uim_val = _mesa_float_to_half((yyvsp[-1].flt)); }
#line 5541 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 545: /* immediate_cat1: '(' T_NAN ')'  */
#line 1515 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_src(0, IR3_REG_IMMED)->fim_val = NAN; }
#line 5547 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 546: /* immediate_cat1: '(' T_INF ')'  */
#line 1516 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_src(0, IR3_REG_IMMED)->fim_val = INFINITY; }
#line 5553 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 547: /* immediate: integer  */
#line 1518 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_src(0, IR3_REG_IMMED)->iim_val = (yyvsp[0].num); }
#line 5559 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 548: /* immediate: '(' integer ')'  */
#line 1519 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_src(0, IR3_REG_IMMED)->fim_val = (yyvsp[-1].num); }
#line 5565 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 549: /* immediate: flut_immed  */
#line 1520 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_src(0, IR3_REG_IMMED)->uim_val = (yyvsp[0].num); }
#line 5571 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 550: /* immediate: 'h' '(' integer ')'  */
#line 1521 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_src(0, IR3_REG_IMMED | IR3_REG_HALF)->iim_val = (yyvsp[-1].num); }
#line 5577 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 551: /* immediate: 'h' flut_immed  */
#line 1522 "../src/freedreno/ir3/ir3_parser.y"
                                       { new_src(0, IR3_REG_IMMED | IR3_REG_HALF)->uim_val = (yyvsp[0].num); }
#line 5583 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 564: /* integer: T_INT  */
#line 1538 "../src/freedreno/ir3/ir3_parser.y"
                               { (yyval.num) = (yyvsp[0].num); }
#line 5589 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 565: /* integer: '-' T_INT  */
#line 1539 "../src/freedreno/ir3/ir3_parser.y"
                               { (yyval.num) = -(yyvsp[0].num); }
#line 5595 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 566: /* integer: T_HEX  */
#line 1540 "../src/freedreno/ir3/ir3_parser.y"
                               { (yyval.num) = (yyvsp[0].unum); }
#line 5601 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 567: /* integer: '-' T_HEX  */
#line 1541 "../src/freedreno/ir3/ir3_parser.y"
                               { (yyval.num) = -(yyvsp[0].unum); }
#line 5607 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 568: /* float: T_FLOAT  */
#line 1543 "../src/freedreno/ir3/ir3_parser.y"
                               { (yyval.flt) = (yyvsp[0].flt); }
#line 5613 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 569: /* float: '-' T_FLOAT  */
#line 1544 "../src/freedreno/ir3/ir3_parser.y"
                               { (yyval.flt) = -(yyvsp[0].flt); }
#line 5619 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 570: /* type: T_TYPE_F16  */
#line 1546 "../src/freedreno/ir3/ir3_parser.y"
                               { (yyval.type) = TYPE_F16; }
#line 5625 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 571: /* type: T_TYPE_F32  */
#line 1547 "../src/freedreno/ir3/ir3_parser.y"
                               { (yyval.type) = TYPE_F32; }
#line 5631 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 572: /* type: T_TYPE_U16  */
#line 1548 "../src/freedreno/ir3/ir3_parser.y"
                               { (yyval.type) = TYPE_U16; }
#line 5637 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 573: /* type: T_TYPE_U32  */
#line 1549 "../src/freedreno/ir3/ir3_parser.y"
                               { (yyval.type) = TYPE_U32; }
#line 5643 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 574: /* type: T_TYPE_S16  */
#line 1550 "../src/freedreno/ir3/ir3_parser.y"
                               { (yyval.type) = TYPE_S16; }
#line 5649 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 575: /* type: T_TYPE_S32  */
#line 1551 "../src/freedreno/ir3/ir3_parser.y"
                               { (yyval.type) = TYPE_S32; }
#line 5655 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 576: /* type: T_TYPE_U8  */
#line 1552 "../src/freedreno/ir3/ir3_parser.y"
                               { (yyval.type) = TYPE_U8;  }
#line 5661 "src/freedreno/ir3/ir3_parser.c"
    break;

  case 577: /* type: T_TYPE_S8  */
#line 1553 "../src/freedreno/ir3/ir3_parser.y"
                               { (yyval.type) = TYPE_S8;  }
#line 5667 "src/freedreno/ir3/ir3_parser.c"
    break;


#line 5671 "src/freedreno/ir3/ir3_parser.c"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      {
        yypcontext_t yyctx
          = {yyssp, yytoken};
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = yysyntax_error (&yymsg_alloc, &yymsg, &yyctx);
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == -1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = YY_CAST (char *,
                             YYSTACK_ALLOC (YY_CAST (YYSIZE_T, yymsg_alloc)));
            if (yymsg)
              {
                yysyntax_error_status
                  = yysyntax_error (&yymsg_alloc, &yymsg, &yyctx);
                yymsgp = yymsg;
              }
            else
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = YYENOMEM;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == YYENOMEM)
          YYNOMEM;
      }
    }

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;
  ++yynerrs;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturnlab;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturnlab;


/*-----------------------------------------------------------.
| yyexhaustedlab -- YYNOMEM (memory exhaustion) comes here.  |
`-----------------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  goto yyreturnlab;


/*----------------------------------------------------------.
| yyreturnlab -- parsing is finished, clean up and return.  |
`----------------------------------------------------------*/
yyreturnlab:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
  return yyresult;
}

